webpackJsonp([28],{

/***/ 1149:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GraphicStatisticsPageModule", function() { return GraphicStatisticsPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__graphic_statistics__ = __webpack_require__(1510);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var GraphicStatisticsPageModule = /** @class */ (function () {
    function GraphicStatisticsPageModule() {
    }
    GraphicStatisticsPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__graphic_statistics__["a" /* GraphicStatisticsPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__graphic_statistics__["a" /* GraphicStatisticsPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], GraphicStatisticsPageModule);
    return GraphicStatisticsPageModule;
}());

//# sourceMappingURL=graphic-statistics.module.js.map

/***/ }),

/***/ 1510:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GraphicStatisticsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_storage__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3__turf_turf__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_highcharts__ = __webpack_require__(224);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_highcharts___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_highcharts__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_highcharts_modules_annotations__ = __webpack_require__(1511);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_highcharts_modules_annotations___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_highcharts_modules_annotations__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__ = __webpack_require__(217);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_record_ride_record_ride__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_activity_metrics_activity_metrics__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_activity_controller_activity_controller__ = __webpack_require__(597);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






__WEBPACK_IMPORTED_MODULE_5_highcharts_modules_annotations__(__WEBPACK_IMPORTED_MODULE_4_highcharts__);







var MAX_INSTOGRAM_DISTANCE = 8;
var MAX_THROTTLE = 80;
var GraphicStatisticsPage = /** @class */ (function () {
    function GraphicStatisticsPage(navCtrl, navParams, metrics, recordRideProvider, amp, events, activityCtrl, logger, storage, translate) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.metrics = metrics;
        this.recordRideProvider = recordRideProvider;
        this.amp = amp;
        this.events = events;
        this.activityCtrl = activityCtrl;
        this.logger = logger;
        this.storage = storage;
        this.translate = translate;
        this.loadingMap = false;
        this.segmentsName = [];
        this.accelerationType = "no-acc";
        this.min_elevation_chart = 0;
        this.loading = true;
        this.isNoData = false;
        this.annotations_points = [];
        this.annotations_icons = [];
        this.segmentsDuration = [];
        this.rawCoordinates = [];
        this.maxElevation = [];
        this.maxSpeed = [];
        this.annotations_elevation = [];
        this.annotations_speed = [];
        this.allSegmentCoordinates = [];
        this.allSegmentColor = [];
        this.allTransferCoordinates = [];
        this.allAggregationData = [];
        this.isChartReady = false;
        this.DIFF = 10;
        this.startEndRecording = [];
        this.allSecondsPerKilometers = [];
        this.max_seconds_duration = 0;
        this.instantaneousSpeed = [0, ''];
        this.defaultGraphSettings = {
            show_columns: false,
            show_max_speed: true,
            show_max_elevation: true,
            map_style: "satellite",
        };
        this.counter = 0;
        this.allSplineSeries = [];
        this.isInitChartError = false;
        this.lastLapVisited = -1;
        this.currentRecordingIndex = 0;
        this.throttleGeoJSONMap = {};
        this.gearShiftSegmentMarker = [];
        this.isThrottleGeoJSONReady = false;
        this.METERS_TO_DISPLAY = 5000;
        this.pageHasBeenLeft = false;
        this._timesWrongSide = 1;
        this._instantPendence = null;
        this._totalPendenceMeters = 0;
        this._lastElevationPendence = -10000;
    }
    GraphicStatisticsPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.events.subscribe("laps_layer_removed", function () {
            setTimeout(function () {
                _this.addAllLapsLayers();
            }, 1000);
        });
        this.events.subscribe("remove_laps_layer", function () {
            _this.lastLapVisited = -1;
            _this.removeAllLapsLayers();
        });
        var intervalId = setInterval(function () {
            var session = _this.activityCtrl.getCurrentSession(_this.navParams.data);
            if (session && session.map) {
                clearInterval(intervalId);
                _this.activity = session.activity;
                _this.map = session.map;
                _this.layers = session.layers;
                var instantaneousMarker_1 = document.getElementById("instantpositionmarker");
                _this.instantValuesMarker = new __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__["Marker"](instantaneousMarker_1);
                setTimeout(function () {
                    instantaneousMarker_1.style.opacity = "1";
                }, 1000);
                _this._initPage();
            }
        }, 500);
        this.events.subscribe("graphic_settings_page_state: closed", function (data) {
            _this.logger.debug("settings modal data", data);
            // add/remove column
            if (data.show_columns == true &&
                !_this.defaultGraphSettings.show_columns) {
                _this.addColumnSerie(_this.allSecondsPerKilometers);
                _this.defaultGraphSettings.show_columns = true;
            }
            else if (data.show_columns == false &&
                _this.defaultGraphSettings.show_columns) {
                _this.removeColumnSerie();
                _this.defaultGraphSettings.show_columns = false;
            }
            // add/remove max elevation annotation
            if (data.show_max_elevation == true &&
                !_this.defaultGraphSettings.show_max_elevation) {
                _this.graph.annotations[2].setVisible(true);
                _this.defaultGraphSettings.show_max_elevation = true;
            }
            else if (data.show_max_elevation == false &&
                _this.defaultGraphSettings.show_max_elevation) {
                _this.graph.annotations[2].setVisible(false);
                _this.defaultGraphSettings.show_max_elevation = false;
            }
            // add/remove max speed annotation
            if (data.show_max_speed == true &&
                !_this.defaultGraphSettings.show_max_speed) {
                _this.graph.annotations[3].setVisible(true);
                _this.defaultGraphSettings.show_max_speed = true;
            }
            else if (data.show_max_speed == false &&
                _this.defaultGraphSettings.show_max_speed) {
                _this.graph.annotations[3].setVisible(false);
                _this.defaultGraphSettings.show_max_speed = false;
            }
            _this.events.publish("graphic_settings_page_state: update_data", data);
        });
    };
    GraphicStatisticsPage.prototype.ionViewDidEnter = function () {
        var _this = this;
        this.pageHasBeenLeft = false;
        if (this.isInitChartError) {
            this.isInitChartError = false;
            setTimeout(function () {
                _this.initChart();
            }, 500);
        }
        if (this.graphicMetrics) {
            this.lastLapVisited = -1;
            this.changeMapView(this.lastInstantanousValue);
            this.removeBestLapLayer();
            setTimeout(function () {
                _this.addAllLapsLayers();
            }, 1500);
        }
    };
    GraphicStatisticsPage.prototype.ionViewWillLeave = function () {
        this.pageHasBeenLeft = true;
        var instantaneousMarker = document.getElementById("instantpositionmarker");
        instantaneousMarker.style.opacity = "0";
        if (this.map) {
            this.removeAllLapsLayers();
            this.addBestLapLayers();
        }
        this.events.publish("lap_info_container: update_data", {
            showLapInfoContainer: false,
        });
    };
    GraphicStatisticsPage.prototype.removeBestLapLayer = function () {
        var removePointsLayer = false;
        if (this.map) {
            for (var _i = 0, _a = this.layers.segmentsFgLayer; _i < _a.length; _i++) {
                var segmentFg = _a[_i];
                if (this.graphicMetrics.activityData.lapId &&
                    this.graphicMetrics.activityData.lapId.includes(segmentFg.id)) {
                    removePointsLayer = true;
                    this.events.publish("best_lap_status", { removed: true });
                    for (var _b = 0, _c = this.map.getStyle().layers; _b < _c.length; _b++) {
                        var style = _c[_b];
                        if (style.id.includes(segmentFg.id)) {
                            this.map.removeLayer(style.id);
                            this.map.removeSource(style.id);
                        }
                    }
                }
            }
            if (removePointsLayer && this.map.getLayer(this.layers.pointsLayer.id)) {
                this.map.removeLayer(this.layers.pointsLayer.id);
                this.map.removeSource(this.layers.pointsLayer.id);
            }
        }
    };
    GraphicStatisticsPage.prototype.addBestLapLayers = function () {
        var addPointsLayer = false;
        for (var _i = 0, _a = this.layers.segmentsBgLayer; _i < _a.length; _i++) {
            var segmentBg = _a[_i];
            if (this.graphicMetrics.activityData.lapId &&
                this.graphicMetrics.activityData.lapId.includes(segmentBg.id.substring(0, segmentBg.id.lastIndexOf("-")))) {
                this.map.addLayer(segmentBg);
            }
        }
        for (var _b = 0, _c = this.layers.segmentsFgLayer; _b < _c.length; _b++) {
            var segmentFg = _c[_b];
            if (this.graphicMetrics.activityData.lapId &&
                this.graphicMetrics.activityData.lapId.includes(segmentFg.id)) {
                addPointsLayer = true;
                this.map.addLayer(segmentFg);
            }
        }
        if (addPointsLayer && this.layers.pointsLayer.id) {
            this.map.addLayer(this.layers.pointsLayer);
            this.events.publish("best_lap_status", { removed: false });
        }
    };
    GraphicStatisticsPage.prototype.changeMapView = function (lastInstantanousValue) {
        var bearingValue = this.recordRideProvider.getLatLngToBearing(lastInstantanousValue
            ? lastInstantanousValue[0][4]
            : this.rawCoordinates[0][0][1], lastInstantanousValue
            ? lastInstantanousValue[0][3]
            : this.rawCoordinates[0][0][0], lastInstantanousValue
            ? lastInstantanousValue[1][4]
            : this.rawCoordinates[0][10][1], lastInstantanousValue
            ? lastInstantanousValue[1][3]
            : this.rawCoordinates[0][10][0]);
        var zoom = 14;
        if (this.activity.isCCU2) {
            zoom = 17.5;
        }
        this.map.easeTo({
            duration: 800,
            center: lastInstantanousValue
                ? [lastInstantanousValue[0][3], lastInstantanousValue[0][4]]
                : this.rawCoordinates[0][0],
            zoom: zoom,
            pitch: 60,
            bearing: bearingValue,
        });
        this.instantValuesMarker
            .setLngLat(lastInstantanousValue
            ? [lastInstantanousValue[0][3], lastInstantanousValue[0][4]]
            : [this.rawCoordinates[0][0][0], this.rawCoordinates[0][0][1]])
            .addTo(this.map);
        var instantaneousMarker = document.getElementById("instantpositionmarker");
        instantaneousMarker.style.opacity = "1";
    };
    GraphicStatisticsPage.prototype._initPage = function () {
        var _this = this;
        var activityId = this.activity.id;
        this.isNoData = false;
        if (this.activity.isCCU2) {
            this.DIFF = 1;
        }
        this.amp
            .getGraphData(activityId, this.DIFF)
            .then(function (data) {
            _this.graphicMetrics = data;
            _this.logger.debug("graphic metrics ", _this.graphicMetrics);
            if (_this.graphicMetrics.activityData.total_distance > 100) {
                _this.storage.set("view_graph_page_speech", true);
                var lastRecordingLength = 0;
                if (_this.activity.isCCU2) {
                    _this.METERS_TO_DISPLAY = 1000;
                }
                for (var i = 0; i < _this.graphicMetrics.recordingData.length; i++) {
                    _this.rawCoordinates.push(_this.graphicMetrics.recordingData[i].raw_coordinates);
                    _this.allAggregationData.push(_this.graphicMetrics.recordingData[i].aggregated_metrics);
                    _this.allTransferCoordinates = _this.allTransferCoordinates.concat(_this.graphicMetrics.recordingData[i].transfers_elevations);
                    _this.allSecondsPerKilometers.push(_this.graphicMetrics.recordingData[i].seconds_per_kilometers);
                    if (_this.graphicMetrics.recordingData[i].meter_rpm &&
                        _this.graphicMetrics.recordingData[i].meter_rpm.length) {
                        _this.allSplineSeries.push({
                            data: _this.graphicMetrics.recordingData[i].meter_rpm,
                            color: "#e95151",
                            zIndex: 1,
                            yAxis: 1,
                            opacity: 0.5,
                        });
                    }
                    if (_this.graphicMetrics.recordingData[i].meter_gear &&
                        _this.graphicMetrics.recordingData[i].meter_gear.length) {
                        _this.allSplineSeries.push({
                            data: _this.graphicMetrics.recordingData[i].meter_gear,
                            color: "#8d72ca",
                            zIndex: 2,
                            yAxis: 2,
                            opacity: 1,
                        });
                    }
                    if (i === 0) {
                        _this.startEndRecording.push({
                            start: 0,
                            end: _this.graphicMetrics.recordingData[i].recording_distance,
                            recordingIndex: 0,
                        });
                    }
                    else {
                        _this.startEndRecording.push({
                            start: lastRecordingLength,
                            end: _this.graphicMetrics.recordingData[i].recording_distance +
                                lastRecordingLength,
                            recordingIndex: _this.startEndRecording[_this.startEndRecording.length - 1]
                                .recordingIndex + 1,
                        });
                    }
                    var metersbetween = 0;
                    if (_this.graphicMetrics.recordingData.length > i + 1) {
                        var prev = _this.graphicMetrics.recordingData[i].raw_coordinates[_this.graphicMetrics.recordingData[i].raw_coordinates.length - 1];
                        var next = _this.graphicMetrics.recordingData[i + 1]
                            .raw_coordinates[0];
                        var ppoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([prev[0], prev[1]]);
                        var npoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([next[0], next[1]]);
                        metersbetween = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](ppoint, npoint, {
                            units: "meters",
                        });
                        if (metersbetween < 20) {
                            metersbetween = 20;
                        }
                        if (metersbetween > 1000) {
                            metersbetween = 1000;
                        }
                    }
                    lastRecordingLength +=
                        _this.graphicMetrics.recordingData[i].recording_distance +
                            metersbetween;
                    if (_this.graphicMetrics.recordingData[i].segments_elevations.length) {
                        _this.segmentsDuration = _this.graphicMetrics.recordingData[i].segment_duration;
                        _this.segmentsName = _this.graphicMetrics.recordingData[i].segments_name;
                        _this.allSegmentCoordinates = _this.allSegmentCoordinates.concat(_this.graphicMetrics.recordingData[i].segments_elevations);
                        _this.allSegmentColor = _this.allSegmentColor.concat(_this.graphicMetrics.recordingData[i].segment_color);
                        _this._addSegmentAnnotation(_this.graphicMetrics.recordingData[i].segments_elevations);
                    }
                }
                _this.updateInstantaneousMarker(_this.allAggregationData[0][0], _this.allAggregationData[0][1]);
                setTimeout(function () {
                    _this.changeMapView();
                }, 500);
                _this.lastMetersValue = _this.graphicMetrics.activityData.total_distance;
                _this.maxElevation = _this.graphicMetrics.activityData.max_elevation;
                _this.maxSpeed = _this.graphicMetrics.activityData.max_speed;
                _this.max_seconds_duration = _this.graphicMetrics.activityData.max_seconds_duration;
                // set the max elevation
                if (_this.maxElevation[1] > 500) {
                    _this.max_elevation_chart = _this.maxElevation[1] + 50;
                }
                else {
                    _this.max_elevation_chart = 550;
                }
                // set the min elevation
                _this.min_elevation_chart = 0;
                var ele0 = _this.metrics.convertElevationInCurrentSystemMetrics(_this.min_elevation_chart);
                _this.item_l0 = ele0.value + " " + ele0.uom;
                var ele2 = _this.metrics.convertElevationInCurrentSystemMetrics((_this.max_elevation_chart - _this.min_elevation_chart) / 2);
                _this.item_l2 = ele2.value + " " + ele2.uom;
                var ele4 = _this.metrics.convertElevationInCurrentSystemMetrics(_this.max_elevation_chart);
                _this.item_l4 = ele4.value + " " + ele4.uom;
                _this.loading = false;
                if (!_this.pageHasBeenLeft) {
                    _this.removeBestLapLayer();
                    setTimeout(function () {
                        _this.addAllLapsLayers();
                    }, 1500);
                    setTimeout(function () {
                        _this.initChart();
                    }, 1000);
                }
                else {
                    _this.isInitChartError = true;
                }
            }
            else {
                _this.logger.debug("total distance < 100m");
                _this.loading = false;
                _this.isNoData = true;
            }
        })
            .catch(function (error) {
            _this.logger.debug("error to retrieve data", error);
        });
    };
    GraphicStatisticsPage.prototype._drawAreasSeries = function (stepToDraw, color) {
        for (var i = 0; i < stepToDraw.length; i++) {
            this.graph.addSeries({
                type: "areaspline",
                data: stepToDraw[i],
                lineColor: Array.isArray(color) ? color[i] : color,
                animation: false,
                fillColor: {
                    linearGradient: {
                        x1: 0,
                        y1: 0,
                        x2: 0,
                        y2: 1,
                    },
                    stops: [
                        [
                            0,
                            __WEBPACK_IMPORTED_MODULE_4_highcharts__["Color"](Array.isArray(color) ? color[i] : color)
                                .setOpacity(0.5)
                                .get("rgba"),
                        ],
                        [
                            1,
                            __WEBPACK_IMPORTED_MODULE_4_highcharts__["Color"](Array.isArray(color) ? color[i] : color)
                                .setOpacity(0.4)
                                .get("rgba"),
                        ],
                    ],
                },
                marker: {
                    enabled: false,
                },
                enableMouseTracking: false,
            });
        }
    };
    GraphicStatisticsPage.prototype._drawSplineSeries = function (stepToDraw, color, yAxisNumber, zIndex, opacity) {
        this.graph.addSeries({
            type: "spline",
            zIndex: zIndex,
            yAxis: yAxisNumber,
            data: stepToDraw,
            lineColor: color,
            lineWidth: 1,
            opacity: opacity,
            animation: false,
            marker: {
                enabled: false,
            },
            enableMouseTracking: false,
        });
    };
    GraphicStatisticsPage.prototype._addSegmentAnnotation = function (segment) {
        for (var y = 0; y < segment.length; y++) {
            var currentSegment = segment[y];
            var nextSegment = segment[y + 1];
            var distanceFromLine = 5;
            var distanceFromBottom = -5;
            if (y > 0) {
                if (nextSegment) {
                    if (currentSegment[currentSegment.length - 1][0] + 50 >=
                        nextSegment[0][0]) {
                        distanceFromLine = 30;
                        distanceFromBottom = 10;
                    }
                }
                else {
                    // check if this segment has a near segment
                    var secondLastSegment = segment[y - 1];
                    if (secondLastSegment[secondLastSegment.length - 1][0] + 50 >=
                        currentSegment[0][0]) {
                        distanceFromLine = 30;
                        distanceFromBottom = 10;
                    }
                }
            }
            if (segment[y] && segment[y][0] && segment[y][0][0]) {
                this.annotations_points.push({
                    backgroundColor: "transparent",
                    borderColor: "transparent",
                    allowOverlap: true,
                    shape: "rect",
                    distance: distanceFromLine,
                    point: {
                        x: segment[y][0][0],
                        y: segment[y][0][1],
                        xAxis: 0,
                        yAxis: 0,
                    },
                    text: '<div style="background-color:black; border-radius:5px; max-width:100px; white-space:nowrap; overflow:hidden; text-overflow:ellipsis; padding: 3px; font-family: NEXA">' +
                        this.segmentsName[y] +
                        "</div>",
                    useHTML: true,
                }, {
                    backgroundColor: "transparent",
                    borderColor: "transparent",
                    allowOverlap: true,
                    shape: "rect",
                    distance: 5,
                    point: {
                        x: segment[y][segment[y].length - 1][0],
                        y: segment[y][segment[y].length - 1][1],
                        xAxis: 0,
                        yAxis: 0,
                    },
                    text: '<div style="display:flex; align-items:center; background-color:black; border-radius: 5px;"><div style="background-image:url(' +
                        this.graphicMetrics.activityData.user.avatar +
                        '); width:20px; height:20px; background-size:cover; background-position:center; border-top-left-radius:5px;border-bottom-left-radius:5px;"></div><div style="font-family:NEXA; padding: 3px;">' +
                        this.segmentsDuration[y] +
                        "</div></div>",
                    useHTML: true,
                });
                this.annotations_icons.push({
                    //icons for segment start and end
                    backgroundColor: "transparent",
                    borderColor: "transparent",
                    allowOverlap: true,
                    shape: "rect",
                    distance: distanceFromBottom,
                    point: {
                        x: segment[y][0][0],
                        y: 0,
                        xAxis: 0,
                        yAxis: 0,
                    },
                    text: '<div style="background-image:url(assets/img/start-map.png); width:15px; height:15px; background-size:cover; transform:rotate(90deg); margin-left:10px;"></div>',
                    useHTML: true,
                }, {
                    //icons for segment start and end
                    backgroundColor: "transparent",
                    borderColor: "transparent",
                    allowOverlap: true,
                    shape: "rect",
                    distance: -5,
                    point: {
                        x: segment[y][segment[y].length - 1][0],
                        y: 0,
                        xAxis: 0,
                        yAxis: 0,
                    },
                    text: '<div style="background-image:url(assets/img/end-map.png); width:15px; height:15px; background-size:cover; margin-left:15px;"></div>',
                    useHTML: true,
                });
            }
        }
    };
    GraphicStatisticsPage.prototype.timeFormatter = function (seconds) {
        return this.metrics.getDisplayTime(seconds * 1000, true);
    };
    GraphicStatisticsPage.prototype.setPointer = function (elevationInsta) {
        var topPixel = Math.floor((this.plotAreaHeight * elevationInsta) /
            (this.max_elevation_chart - this.min_elevation_chart));
        this.yValue = -topPixel + "px";
    };
    GraphicStatisticsPage.prototype.scrollLeftPointer = function (scroll) {
        var offsetMeters = Math.floor(((this.graphicMetrics.activityData.total_distance +
            this.METERS_TO_DISPLAY) *
            scroll) /
            this.chart_width);
        for (var i = 0; i < this.startEndRecording.length; i++) {
            if (this.startEndRecording[i].start <= offsetMeters &&
                offsetMeters <= this.startEndRecording[i].end) {
                this.currentRecordingIndex = this.startEndRecording[i].recordingIndex;
                offsetMeters -= this.startEndRecording[i].start;
                var index = Math.floor(offsetMeters / this.DIFF);
                var currentInstantValues = this.allAggregationData[i][index];
                var nextInstantValues = this.allAggregationData[i][index];
                if (this.allAggregationData[i].length > index + 50) {
                    nextInstantValues = this.allAggregationData[i][index + 50];
                }
                var lastInstantValues = this.allAggregationData[i][index];
                var lastElev = currentInstantValues[1];
                if (index > 0) {
                    lastElev = this.allAggregationData[i][index][1];
                    lastInstantValues = this.allAggregationData[i][index - 1];
                }
                if (lastInstantValues[2] < currentInstantValues[2]) {
                    this.accelerationType = "acceleration";
                }
                else {
                    this.accelerationType = "deceleration";
                }
                var topPixel = Math.floor((this.plotAreaHeight * lastElev) /
                    (this.max_elevation_chart - this.min_elevation_chart));
                this.yValue = -topPixel + "px";
                this.lastInstantanousValue = [currentInstantValues, nextInstantValues];
                this.updateInstantaneousMarker(currentInstantValues, nextInstantValues);
            }
        }
    };
    GraphicStatisticsPage.prototype.updateInstantaneousMarker = function (currentInstantValues, nextInstantValues) {
        if (new Date().getTime() - this.counter > 150) {
            var bearingValue = this.recordRideProvider.getLatLngToBearing(currentInstantValues[4], currentInstantValues[3], nextInstantValues[4], nextInstantValues[3]);
            if (this._lastElevationPendence == -10000) {
                this._lastElevationPendence = currentInstantValues[1];
            }
            var ppoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([nextInstantValues[3], nextInstantValues[4]]);
            var npoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([currentInstantValues[3], currentInstantValues[4]]);
            var metersDiff = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](ppoint, npoint, {
                units: "meters",
            });
            if (this._totalPendenceMeters + metersDiff > 250) {
                var elDiff = nextInstantValues[1] - this._lastElevationPendence;
                this._lastElevationPendence = currentInstantValues[1];
                this._instantPendence = elDiff / (this._totalPendenceMeters + metersDiff);
                this._totalPendenceMeters = 0;
            }
            this._totalPendenceMeters += metersDiff;
            if (this.map.is3d && this._instantPendence < -0.08) {
                bearingValue = (bearingValue + (180 * Math.min(Math.floor((this._timesWrongSide / 4)), 1))) % 360;
                this._timesWrongSide += 1;
                this._timesWrongSide = Math.max(this._timesWrongSide, 8);
            }
            else if (this._instantPendence < -0.02) {
            }
            else {
                console.log("NO");
                this._timesWrongSide -= 1;
                this._timesWrongSide = Math.max(this._timesWrongSide, 1);
            }
            this.map.easeTo({
                duration: 300,
                pitch: 60,
                bearing: bearingValue,
                center: [currentInstantValues[3], currentInstantValues[4]],
            });
            this.counter = new Date().getTime();
        }
        this.instantValuesMarker.setLngLat([
            currentInstantValues[3],
            currentInstantValues[4],
        ]);
        this.instantaneousMeters = this.metrics.getDisplayHorizontalLongArray(currentInstantValues[0]);
        this.highlightCurrentLap(currentInstantValues);
        var instSpeedCalc = this.metrics.convertSpeedInCurrentSystemMetrics(currentInstantValues[2]);
        this.instantaneousSpeed[0] = instSpeedCalc.value;
        this.instantaneousSpeed[1] = instSpeedCalc.uom;
        var primaryContainer = this.instantValuesMarker._element
            .children[1].children[0];
        primaryContainer.children[1].innerHTML =
            '<span class="number">' +
                this.instantaneousSpeed[0] +
                "</span>" +
                '<span class="string">' +
                this.instantaneousSpeed[1] +
                "</span>";
        var secondaryContainer = this.instantValuesMarker._element
            .children[1].children[1];
        secondaryContainer.children[0].children[1].innerHTML =
            '<span class="number">' +
                this.instantaneousMeters[0] +
                "</span>" +
                '<span class="string">' +
                this.instantaneousMeters[1] +
                "</span>";
        var displayPendence = 0;
        if (this._instantPendence == null || (this._instantPendence > -0.01 && this._instantPendence < 0.01)) {
            displayPendence = 0;
        }
        else {
            if (this._instantPendence >= 1 || this._instantPendence <= -1) {
                displayPendence = 0;
            }
            displayPendence = Math.round(this._instantPendence * 100);
            console.log("displayPendence", displayPendence);
        }
        secondaryContainer.children[5].children[1].innerHTML =
            '<span class="number">' +
                displayPendence +
                "</span>" +
                '<span class="string">' +
                " %" +
                "</span>";
        if (this.graphicMetrics.activityData.isCCU2) {
            this.instantaneousRpm = [];
            this.instantaneousRpm.push(currentInstantValues[6]);
            this.instantaneousRpm.push("rpm");
            secondaryContainer.children[1].children[1].innerHTML =
                '<span class="number">' +
                    this.instantaneousRpm[0] +
                    "</span>" +
                    '<span class="string">' +
                    this.instantaneousRpm[1] +
                    "</span>";
            this.instantaneousGear = [];
            this.instantaneousGear.push(currentInstantValues[5]);
            this.instantaneousGear.push("Gear");
            secondaryContainer.children[2].children[1].innerHTML =
                '<span class="number">' +
                    this.instantaneousGear[0] +
                    "</span>" +
                    '<span class="string">' +
                    this.instantaneousGear[1] +
                    "</span>";
            this.instantaneousThrottle = [];
            this.instantaneousThrottle.push(currentInstantValues[7]);
            this.instantaneousThrottle.push("%");
            secondaryContainer.children[3].children[1].innerHTML =
                '<span class="number">' +
                    this.instantaneousThrottle[0] +
                    "</span>" +
                    '<span class="string">' +
                    this.instantaneousThrottle[1] +
                    "</span>";
            this.instantaneousMap = [];
            this.instantaneousMap.push(currentInstantValues[8]);
            this.instantaneousMap.push("Map");
            secondaryContainer.children[4].children[1].innerHTML =
                '<span class="number">' +
                    this.instantaneousMap[0] +
                    "</span>" +
                    '<span class="string">' +
                    this.instantaneousMap[1] +
                    "</span>";
        }
        else {
            secondaryContainer.children[1].style.display = "none";
            secondaryContainer.children[2].style.display = "none";
            secondaryContainer.children[3].style.display = "none";
            secondaryContainer.children[4].style.display = "none";
        }
    };
    GraphicStatisticsPage.prototype.addColumnSerie = function (stepColumn) {
        for (var i = 0; i < stepColumn.length; i++) {
            this.graph.addSeries({
                id: "columnSerie",
                type: "column",
                data: stepColumn[i],
                zIndex: 1,
                yAxis: 3,
                allowPointSelect: true,
                animation: false,
                borderColor: "rgba(170, 170, 170, 0.80)",
                color: "rgba(170, 170, 170, 0.50)",
                pointWidth: this.column_width,
                pointPlacement: "on",
                shadow: false,
                states: {
                    select: {
                        borderColor: "rgba(0,170,166, 0.80)",
                        color: "rgba(0,170,166, 0.50)",
                    },
                },
            });
        }
    };
    GraphicStatisticsPage.prototype.removeColumnSerie = function () {
        var serie = this.graph.get("columnSerie");
        serie.remove();
    };
    /*
     * Initializing Highchart graphic. The values setted on the yAxis correspond to the data that you would to rapresent.
     * For the elevation data we've set the min -> min_elevation_chart and max -> max_elevation_chart+50
     * For the gear data we've set the min -> 0 and max -> 10 (default is 7)
     * For the rpm data we've set the min -> 0 and max -> 35000 (default is 32000)
     * The max value is always upper than the real value to don't cut the various series,
     * To make the touch work on the graph, has been set in the scss the property to graph container -> pointer-events: none;
     */
    GraphicStatisticsPage.prototype.initChart = function () {
        var _this = this;
        var _t = this;
        try {
            this.column_width =
                this.content.contentWidth / (this.METERS_TO_DISPLAY / 1000);
            this.chart_width = Math.floor(((this.graphicMetrics.activityData.total_distance +
                this.METERS_TO_DISPLAY) /
                1000) *
                this.column_width);
            this.graph = __WEBPACK_IMPORTED_MODULE_4_highcharts__["chart"](this.graphicStatistics.nativeElement, {
                chart: {
                    width: _t.chart_width,
                    margin: [0, 0, 0, 0],
                    events: {
                        load: function () {
                            _t.loading;
                            if (!_t.graphicMetrics.activityData.lapId) {
                                _t.isChartReady = true;
                            }
                        },
                    },
                },
                title: {
                    text: null,
                },
                subtitle: {
                    text: null,
                },
                legend: {
                    enabled: false,
                },
                tooltip: {
                    enabled: false,
                },
                annotations: [
                    {
                        labels: _t.annotations_points,
                    },
                    {
                        labels: _t.annotations_icons,
                    },
                    {
                        labelOptions: {
                            //for max elevation
                            allowOverlap: true,
                            shape: "connector",
                            distance: 50,
                            padding: 0,
                        },
                        labels: _t.annotations_elevation,
                    },
                    {
                        labelOptions: {
                            //for max speed
                            allowOverlap: true,
                            shape: "connector",
                            distance: 50,
                            padding: 0,
                        },
                        labels: _t.annotations_speed,
                    },
                ],
                xAxis: [
                    {
                        min: -_t.METERS_TO_DISPLAY / 2,
                        max: _t.lastMetersValue + _t.METERS_TO_DISPLAY / 2,
                        tickInterval: 1000,
                        tickColor: "transparent",
                        lineColor: "transparent",
                        labels: {
                            enabled: false,
                        },
                        title: {
                            text: null,
                        },
                    },
                ],
                yAxis: [
                    {
                        // elevation areaspline
                        min: _t.min_elevation_chart,
                        max: _t.max_elevation_chart,
                        gridLineColor: 0,
                        endOnTick: false,
                        maxPadding: 0,
                        minPadding: 0,
                        minRange: 0,
                        labels: {
                            enabled: false,
                        },
                        title: {
                            text: null,
                        },
                    },
                    {
                        // rpm spline
                        min: 0,
                        max: 20000,
                        gridLineColor: 0,
                        endOnTick: false,
                        maxPadding: 0,
                        minPadding: 0,
                        minRange: 0,
                        labels: {
                            enabled: false,
                        },
                        title: {
                            text: null,
                        },
                    },
                    {
                        // Gear spline
                        min: 0,
                        max: 6,
                        gridLineColor: 0,
                        endOnTick: false,
                        maxPadding: 0,
                        minPadding: 0,
                        minRange: 0,
                        labels: {
                            enabled: false,
                        },
                        title: {
                            text: null,
                        },
                    },
                    {
                        // time column
                        min: 0,
                        max: _t.max_seconds_duration + 100,
                        gridLineWidth: 0,
                        endOnTick: false,
                        maxPadding: 0,
                        title: {
                            text: null,
                        },
                        labels: {
                            enabled: false,
                        },
                    },
                ],
            });
            this.chartScroll.addScrollEventListener(function (e) {
                _this.scrollLeftPointer(e.target.scrollLeft);
            });
            //add elevation transfers series
            this._drawAreasSeries(this.allTransferCoordinates, "#B0B3CC");
            //add elevation segments series
            this._drawAreasSeries(this.allSegmentCoordinates, this.allSegmentColor);
            if (this.allSplineSeries.length) {
                for (var _i = 0, _a = this.allSplineSeries; _i < _a.length; _i++) {
                    var spline = _a[_i];
                    this._drawSplineSeries(spline.data, spline.color, spline.yAxis, spline.zIndex, spline.opacity);
                }
            }
            this.plotAreaHeight = this.graphicStatistics.nativeElement.scrollHeight;
            this.setPointer(this.graphicMetrics.recordingData[0].initial_data[1]);
        }
        catch (error) {
            this.logger.debug("chart is not ready", error);
            this.isInitChartError = true;
        }
    };
    GraphicStatisticsPage.prototype.highlightCurrentLap = function (currentInstantValues) {
        if (currentInstantValues[9]) {
            // currentInstantValues[9] -> 'lap-<recordingIndex>-<lapIndex>'
            var lapIndex = parseInt(currentInstantValues[9].substring(currentInstantValues[9].lastIndexOf("-") + 1, currentInstantValues.length));
            var currentLapNumber = lapIndex + 1;
            var totalLapsNumber = this.graphicMetrics.activityData.recordingsLaps[this.currentRecordingIndex][0];
            if (this.lastLapVisited === -1) {
                this.lastLapVisited = lapIndex;
                this.pushLayerOnTop(lapIndex);
                this.events.publish("lap_info_container: update_data", {
                    showLapInfoContainer: true,
                    lapInfoText: this.translate.instant("graphic_statistics_page.laps_info", {
                        currentLap: currentLapNumber,
                        totalLaps: totalLapsNumber,
                    }),
                });
            }
            if (this.lastLapVisited !== lapIndex) {
                this.resetLayerOnTop();
                this.lastLapVisited = lapIndex;
                this.pushLayerOnTop(lapIndex);
                this.events.publish("lap_info_container: update_data", {
                    showLapInfoContainer: true,
                    lapInfoText: this.translate.instant("graphic_statistics_page.laps_info", {
                        currentLap: currentLapNumber,
                        totalLaps: totalLapsNumber,
                    }),
                });
            }
        }
        else {
            if (this.lastLapVisited > -1) {
                this.events.publish("lap_info_container: update_data", {
                    showLapInfoContainer: false,
                });
                this.resetLayerOnTop();
                this.lastLapVisited = -1;
            }
        }
    };
    GraphicStatisticsPage.prototype.resetLayerOnTop = function () {
        var lastLayerId = "temp-lap-layer/" +
            this.currentRecordingIndex +
            "-" +
            this.lastLapVisited;
        this.map.setPaintProperty(lastLayerId, "line-color", "#000000");
        this.map.setPaintProperty(lastLayerId, "line-opacity", 0.2);
        this.map.setPaintProperty(lastLayerId, "line-width", 2);
        var lastLayerFgId = "temp-lap-layer/fg-" +
            this.currentRecordingIndex +
            "-" +
            this.lastLapVisited;
        this.map.removeLayer(lastLayerFgId);
        this.map.removeSource(lastLayerFgId);
        this.map.removeLayer("throttle-layer");
        this.map.removeSource("throttle-layer");
        for (var _i = 0, _a = this.gearShiftSegmentMarker; _i < _a.length; _i++) {
            var marker = _a[_i];
            marker.remove();
        }
    };
    GraphicStatisticsPage.prototype.pushLayerOnTop = function (lapIndex) {
        var layerId = "temp-lap-layer/" + this.currentRecordingIndex + "-" + lapIndex;
        var layerToPutOnTop = this.map.getStyle().layers.find(function (_item) {
            return _item.id === layerId;
        });
        layerToPutOnTop.source = this.map.getStyle().sources[layerId];
        layerToPutOnTop.paint = {
            "line-width": 6,
            "line-color": "#057d54",
            "line-opacity": 1,
        };
        this.map.removeLayer(layerId);
        this.map.removeSource(layerId);
        if (this.activity.isCCU2) {
            this.showSegmentInstogramsLayer(lapIndex);
            this.showSegmentGearsShiftMarker(lapIndex);
        }
        this.map.addLayer(layerToPutOnTop);
        this.map.addLayer({
            id: "temp-lap-layer/fg-" + this.currentRecordingIndex + "-" + lapIndex,
            type: "line",
            source: {
                type: "geojson",
                data: {
                    type: "FeatureCollection",
                    features: [
                        {
                            type: "Feature",
                            properties: {},
                            geometry: {
                                type: "LineString",
                                coordinates: layerToPutOnTop.source.data.geometry.coordinates,
                            },
                        },
                    ],
                },
            },
            paint: {
                "line-opacity": 1,
                "line-width": 2,
                "line-color": "#00ffa8",
            },
            layout: {
                "line-join": "round",
                "line-cap": "round",
            },
        });
    };
    GraphicStatisticsPage.prototype.addAllLapsLayers = function () {
        if (this.graphicMetrics.activityData.lapId) {
            var recordingIndex = -1;
            for (var _i = 0, _a = this.graphicMetrics.recordingData; _i < _a.length; _i++) {
                var recording = _a[_i];
                recordingIndex++;
                for (var i = 0; i < recording.segments_elevations.length; i++) {
                    var segment = recording.segments_elevations[i];
                    var layerId = "temp-lap-layer/" + recordingIndex + "-" + i;
                    var feature = {
                        type: "Feature",
                        properties: {},
                        geometry: {
                            type: "LineString",
                            coordinates: segment.map(function (point) { return [point[3], point[4]]; }),
                        },
                    };
                    this.map.addLayer({
                        id: layerId,
                        type: "line",
                        source: {
                            type: "geojson",
                            data: feature,
                        },
                        layout: {
                            "line-join": "round",
                            "line-cap": "round",
                        },
                        paint: {
                            "line-width": 2,
                            "line-opacity": 0.2,
                        },
                    });
                    if (this.activity.isCCU2 && !this.isThrottleGeoJSONReady) {
                        var currentSegmentInstograms = recording.segment_istograms[i];
                        var throttleGeoJSON = {
                            type: "MultiLineString",
                            coordinates: [],
                        };
                        for (var _b = 0, currentSegmentInstograms_1 = currentSegmentInstograms; _b < currentSegmentInstograms_1.length; _b++) {
                            var point = currentSegmentInstograms_1[_b];
                            var firstPointAlongTheLine = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["along"](feature, point[0], {
                                units: "meters",
                            });
                            var secondPointAlongTheLine = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["along"](feature, point[0] + 1, {
                                units: "meters",
                            });
                            var bearing = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["bearing"](firstPointAlongTheLine, secondPointAlongTheLine);
                            var distance = (MAX_INSTOGRAM_DISTANCE * point[4]) / MAX_THROTTLE;
                            var newPoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["destination"](firstPointAlongTheLine, distance, bearing - 90, { units: "meters" });
                            throttleGeoJSON.coordinates.push([
                                firstPointAlongTheLine.geometry.coordinates,
                                newPoint.geometry.coordinates,
                            ]);
                        }
                        this.throttleGeoJSONMap[layerId] = throttleGeoJSON;
                    }
                }
            }
            this.isChartReady = true;
            this.isThrottleGeoJSONReady = true;
        }
    };
    GraphicStatisticsPage.prototype.removeAllLapsLayers = function () {
        for (var _i = 0, _a = this.map.getStyle().layers; _i < _a.length; _i++) {
            var style = _a[_i];
            if (style.id.includes("temp-lap-layer/")) {
                this.map.removeLayer(style.id);
            }
        }
        for (var property in this.map.getStyle().sources) {
            if (property.includes("temp-lap-layer/")) {
                this.map.removeSource(property);
            }
        }
        if (this.map.getLayer("throttle-layer")) {
            this.map.removeLayer("throttle-layer");
            this.map.removeSource("throttle-layer");
            for (var _b = 0, _c = this.gearShiftSegmentMarker; _b < _c.length; _b++) {
                var marker = _c[_b];
                marker.remove();
            }
        }
    };
    GraphicStatisticsPage.prototype.showSegmentInstogramsLayer = function (lapIndex) {
        var geoJSONToGetId = "temp-lap-layer/" + this.currentRecordingIndex + "-" + lapIndex;
        this.map.addLayer({
            id: "throttle-layer",
            type: "line",
            source: {
                type: "geojson",
                data: {
                    type: "Feature",
                    properties: {},
                    geometry: this.throttleGeoJSONMap[geoJSONToGetId],
                },
            },
            layout: {
                "line-join": "round",
                "line-cap": "round",
            },
            paint: {
                "line-color": "#6fc794",
                "line-width": 4,
            },
        });
    };
    GraphicStatisticsPage.prototype.showSegmentGearsShiftMarker = function (lapIndex) {
        var lastGearShift = -1;
        for (var _i = 0, _a = this.graphicMetrics.recordingData[this.currentRecordingIndex].segments_elevations[lapIndex]; _i < _a.length; _i++) {
            var point = _a[_i];
            if (lastGearShift === -1) {
                var marker = document.createElement("div");
                marker.className = "gearshift";
                var insideMarker = document.createElement("div");
                insideMarker.className = "gear-icon-container";
                insideMarker.innerHTML =
                    "<div class='up'></div>";
                marker.appendChild(insideMarker);
                var gearMarker = new __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__["Marker"](marker)
                    .setLngLat([point[3], point[4]])
                    .addTo(this.map);
                this.gearShiftSegmentMarker.push(gearMarker);
                lastGearShift = point[5];
            }
            else if (lastGearShift !== point[5]) {
                var gearMarker = void 0;
                if (point[5] > lastGearShift) {
                    var marker = document.createElement("div");
                    marker.className = "gearshift";
                    var insideMarker = document.createElement("div");
                    insideMarker.className = "gear-icon-container";
                    insideMarker.innerHTML =
                        "<div class='up'></div>";
                    marker.appendChild(insideMarker);
                    gearMarker = new __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__["Marker"](marker)
                        .setLngLat([point[3], point[4]])
                        .addTo(this.map);
                }
                else {
                    var marker = document.createElement("div");
                    marker.className = "gearshift";
                    var insideMarker = document.createElement("div");
                    insideMarker.className = "gear-icon-container";
                    insideMarker.innerHTML =
                        "<div class='down'></div>";
                    marker.appendChild(insideMarker);
                    gearMarker = new __WEBPACK_IMPORTED_MODULE_6_mapbox_gl_dist_mapbox_gl__["Marker"](marker)
                        .setLngLat([point[3], point[4]])
                        .addTo(this.map);
                }
                this.gearShiftSegmentMarker.push(gearMarker);
                lastGearShift = point[5];
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */])
    ], GraphicStatisticsPage.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("graphicstatistics"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], GraphicStatisticsPage.prototype, "graphicStatistics", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("chartscroll"),
        __metadata("design:type", Object)
    ], GraphicStatisticsPage.prototype, "chartScroll", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("mapstatistic"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], GraphicStatisticsPage.prototype, "mapStatistic", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("instantpositionmarker"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], GraphicStatisticsPage.prototype, "instantaneousMarker", void 0);
    GraphicStatisticsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-graphic-statistics",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/graphic-statistics/graphic-statistics.html"*/'<ion-content no-bounce has-bouncing="false" >\n\n  <ion-spinner ion-fixed class="center" *ngIf="loading"></ion-spinner>\n\n  <div class="general-container" *ngIf="!loading && !isNoData" ion-fixed>\n\n    <div class="chart-container">\n      <div class="y-axis-left">\n        <div class="item-left">{{item_l4}}</div>\n        <div class="item-left">{{item_l2}}</div>\n        <div class="item-left">{{item_l0}}</div>\n      </div>\n\n      <div class="circle-pointer-chart" [ngClass]="{ \'chart-ready\': isChartReady }" [ngStyle]="{ \'transform\': \'translate3d(0,\'+yValue+\',0)\' }">\n        <div class="line"></div>\n      </div>\n      \n      <ion-spinner ion-fixed class="center" *ngIf="!isChartReady"></ion-spinner>\n\n      <ion-scroll #chartscroll name="chart" class="chartscroll" scrollX="true">\n        <div #graphicstatistics class="graphic-statistic"></div>\n      </ion-scroll>\n\n    </div>\n  </div>\n\n  <div ion-fixed *ngIf="isNoData" class="text-chart-no-data">{{ \'graphic_statistics_page.chart_with_no_data\' | translate }}</div>\n\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/graphic-statistics/graphic-statistics.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_record_ride_record_ride__["a" /* RecordRideProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_activity_metrics_activity_metrics__["a" /* ActivityMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* Events */],
            __WEBPACK_IMPORTED_MODULE_11__providers_activity_controller_activity_controller__["a" /* ActivityControllerProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__["c" /* TranslateService */]])
    ], GraphicStatisticsPage);
    return GraphicStatisticsPage;
}());

//# sourceMappingURL=graphic-statistics.js.map

/***/ }),

/***/ 1511:
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_RESULT__;/*
 Highcharts JS v6.2.0 (2018-10-17)
 Annotations module

 (c) 2009-2018 Torstein Honsi

 License: www.highcharts.com/license
*/
(function(l){"object"===typeof module&&module.exports?module.exports=l: true?!(__WEBPACK_AMD_DEFINE_RESULT__ = (function(){return l}).call(exports, __webpack_require__, exports, module),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)):l(Highcharts)})(function(l){(function(f){var m=f.merge,l=f.addEvent,v=f.extend,n=f.each,D=f.isString,z=f.isNumber,p=f.defined,E=f.isObject,F=f.inArray,u=f.erase,G=f.find,H=f.format,w=f.pick,A=f.objectEach,I=f.uniqueKey,J=f.doc,K=f.splat,L=f.destroyObjectProperties,M=f.grep,B=f.Tooltip.prototype,N=f.Series.prototype,C=f.Chart.prototype,O={arrow:{tagName:"marker",
render:!1,id:"arrow",refY:5,refX:5,markerWidth:10,markerHeight:10,children:[{tagName:"path",d:"M 0 0 L 10 5 L 0 10 Z",strokeWidth:0}]}},q={markerSetter:function(a){return function(b){this.attr(a,"url(#"+b+")")}}};v(q,{markerEndSetter:q.markerSetter("marker-end"),markerStartSetter:q.markerSetter("marker-start")});f.SVGRenderer.prototype.definition=function(a){function b(a,d){var e;n(K(a),function(a){var g=c.createElement(a.tagName),f={};A(a,function(a,b){"tagName"!==b&&"children"!==b&&"textContent"!==
b&&(f[b]=a)});g.attr(f);g.add(d||c.defs);a.textContent&&g.element.appendChild(J.createTextNode(a.textContent));b(a.children||[],g);e=g});return e}var c=this;return b(a)};f.SVGRenderer.prototype.addMarker=function(a,b){var c={id:a},e={stroke:b.color||"none",fill:b.color||"rgba(0, 0, 0, 0.75)"};c.children=f.map(b.children,function(a){return m(e,a)});b=this.definition(m({markerWidth:20,markerHeight:20,refX:0,refY:0,orient:"auto"},b,c));b.id=a;return b};var x=f.MockPoint=function(a,b){this.mock=!0;this.series=
{visible:!0,chart:a,getPlotBox:N.getPlotBox};this.init(a,b)},P=f.mockPoint=function(a,b){return new x(a,b)};x.prototype={init:function(a,b){var c=b.xAxis,c=p(c)?a.xAxis[c]||a.get(c):null,e=b.yAxis;a=p(e)?a.yAxis[e]||a.get(e):null;c?(this.x=b.x,this.series.xAxis=c):this.plotX=b.x;a?(this.y=b.y,this.series.yAxis=a):this.plotY=b.y},translate:function(){var a=this.series,b=a.xAxis,a=a.yAxis;b&&(this.plotX=b.toPixels(this.x,!0));a&&(this.plotY=a.toPixels(this.y,!0));this.isInside=this.isInsidePane()},
alignToBox:function(a){a&&this.translate();a=this.plotX;var b=this.plotY,c;this.series.chart.inverted&&(c=a,a=b,b=c);return[a,b,0,0]},getLabelConfig:function(){return{x:this.x,y:this.y,point:this}},isInsidePane:function(){var a=this.plotX,b=this.plotY,c=this.series.xAxis,e=this.series.yAxis,d=!0;c&&(d=p(a)&&0<=a&&a<=c.len);e&&(d=d&&p(b)&&0<=b&&b<=e.len);return d}};f.defaultOptions.annotations=[];var y=f.Annotation=function(a,b){this.chart=a;this.labels=[];this.shapes=[];this.userOptions=b;this.options=
m(this.defaultOptions,b);this.init(a,b)};y.prototype={shapesWithoutBackground:["connector"],attrsMap:{backgroundColor:"fill",borderColor:"stroke",borderWidth:"stroke-width",dashStyle:"dashstyle",strokeWidth:"stroke-width",stroke:"stroke",fill:"fill",zIndex:"zIndex",width:"width",height:"height",borderRadius:"r",r:"r",padding:"padding"},defaultOptions:{visible:!0,labelOptions:{align:"center",allowOverlap:!1,backgroundColor:"rgba(0, 0, 0, 0.75)",borderColor:"black",borderRadius:3,borderWidth:1,className:"",
crop:!1,formatter:function(){return p(this.y)?this.y:"Annotation label"},overflow:"justify",padding:5,shadow:!1,shape:"callout",style:{fontSize:"11px",fontWeight:"normal",color:"contrast"},useHTML:!1,verticalAlign:"bottom",x:0,y:-16},shapeOptions:{stroke:"rgba(0, 0, 0, 0.75)",strokeWidth:1,fill:"rgba(0, 0, 0, 0.75)",r:0},zIndex:6},init:function(){var a=this;n(this.options.labels||[],this.initLabel,this);n(this.options.shapes||[],this.initShape,this);this.labelCollector=function(){return M(a.labels,
function(a){return!a.options.allowOverlap})};this.chart.labelCollectors.push(this.labelCollector)},redraw:function(){this.group||this.render();this.redrawItems(this.shapes);this.redrawItems(this.labels)},redrawItems:function(a){for(var b=a.length;b--;)this.redrawItem(a[b])},render:function(){var a=this.chart.renderer,b=this.group=a.g("annotation").attr({zIndex:this.options.zIndex,visibility:this.options.visible?"visible":"hidden"}).add();this.shapesGroup=a.g("annotation-shapes").add(b);this.labelsGroup=
a.g("annotation-labels").attr({translateX:0,translateY:0}).add(b);this.shapesGroup.clip(this.chart.plotBoxClip)},setVisible:function(a){var b=this.options;a=w(a,!b.visible);this.group.attr({visibility:a?"visible":"hidden"});b.visible=a},destroy:function(){var a=this.chart,b=function(a){a.destroy()};u(this.chart.labelCollectors,this.labelCollector);n(this.labels,b);n(this.shapes,b);L(this,a)},initShape:function(a){var b=this.chart.renderer;a=m(this.options.shapeOptions,a);var c=this.attrsFromOptions(a),
e=b[a.type]?a.type:"rect",b=b[e](0,-9E9,0,0);b.points=[];b.type=e;b.options=a;b.itemType="shape";"path"===e&&v(b,{markerStartSetter:q.markerStartSetter,markerEndSetter:q.markerEndSetter,markerStart:q.markerStart,markerEnd:q.markerEnd});b.attr(c);a.className&&b.addClass(a.className);this.shapes.push(b)},initLabel:function(a){a=m(this.options.labelOptions,a);var b=this.attrsFromOptions(a),c=this.chart.renderer.label("",0,-9E9,a.shape,null,null,a.useHTML,null,"annotation-label");c.points=[];c.options=
a;c.itemType="label";c.labelrank=a.labelrank;c.annotation=this;c.attr(b);b=a.style;"contrast"===b.color&&(b.color=this.chart.renderer.getContrast(-1<F(a.shape,this.shapesWithoutBackground)?"#FFFFFF":a.backgroundColor));c.css(b).shadow(a.shadow);a.className&&c.addClass(a.className);this.labels.push(c)},redrawItem:function(a){var b=this.linkPoints(a),c=a.options,e,d=this.chart.time;b.length?(a.parentGroup||this.renderItem(a),"label"===a.itemType&&(e=c.format||c.text,a.attr({text:e?H(e,b[0].getLabelConfig(),
d):c.formatter.call(b[0])})),"path"===a.type?this.redrawPath(a):this.alignItem(a,!a.placed)):this.destroyItem(a)},destroyItem:function(a){u(this[a.itemType+"s"],a);a.destroy()},pointItem:function(a,b){b&&null!==b.series||(E(a)?b=P(this.chart,a):D(a)&&(b=this.chart.get(a)||null));return b},linkPoints:function(a){var b=a.options.points||a.options.point&&f.splat(a.options.point),c=a.points,e=b&&b.length,d,t;for(d=0;d<e;d++){t=this.pointItem(b[d],c[d]);if(!t)return a.points=[];c[d]=t}return c},alignItem:function(a,
b){var c=this.itemAnchor(a,a.points[0]),e=this.itemPosition(a,c);e?(a.alignAttr=e,a.placed=!0,e.anchorX=c.absolutePosition.x,e.anchorY=c.absolutePosition.y,a[b?"attr":"animate"](e)):(a.placed=!1,a.attr({x:0,y:-9E9}))},redrawPath:function(a,b){var c=a.points,e=a["stroke-width"]||1,d=["M"],f=0,h=0,g=c&&c.length,k,r;if(g){do r=c[f],k=this.itemAnchor(a,r).absolutePosition,d[++h]=k.x,d[++h]=k.y,k=h%5,0===k&&(d[k+1]===d[k+4]&&(d[k+1]=d[k+4]=Math.round(d[k+1])-e%2/2),d[k+2]===d[k+5]&&(d[k+2]=d[k+5]=Math.round(d[k+
2])+e%2/2)),f<g-1&&(d[++h]="L"),r=r.series.visible;while(++f<g&&r)}if(r)a[b?"attr":"animate"]({d:d});else a.attr({d:"M 0 -9000000000"});a.placed=r},renderItem:function(a){a.add("label"===a.itemType?this.labelsGroup:this.shapesGroup);this.setItemMarkers(a)},setItemMarkers:function(a){var b=a.options,c=this.chart,e=c.options.defs,d=b.fill,f=p(d)&&"none"!==d?d:b.stroke;n(["markerStart","markerEnd"],function(d){var g=b[d],k,h,t;if(g){for(t in e)if(k=e[t],g===k.id&&"marker"===k.tagName){h=k;break}h&&(g=
a[d]=c.renderer.addMarker((b.id||I())+"-"+h.id,m(h,{color:f})),a.attr(d,g.attr("id")))}})},itemAnchor:function(a,b){a=b.series.getPlotBox();b=b.mock?b.alignToBox(!0):B.getAnchor.call({chart:this.chart},b);b={x:b[0],y:b[1],height:b[2]||0,width:b[3]||0};return{relativePosition:b,absolutePosition:m(b,{x:b.x+a.translateX,y:b.y+a.translateY})}},itemPosition:function(a,b){var c=this.chart,e=a.points[0],d=a.options,f=b.absolutePosition,h=b.relativePosition,g;if(b=e.series.visible&&x.prototype.isInsidePane.call(e))p(d.distance)||
d.positioner?g=(d.positioner||B.getPosition).call({chart:c,distance:w(d.distance,16)},a.width,a.height,{plotX:h.x,plotY:h.y,negative:e.negative,ttBelow:e.ttBelow,h:h.height||h.width}):(e={x:f.x,y:f.y,width:0,height:0},g=this.alignedPosition(v(d,{width:a.width,height:a.height}),e),"justify"===a.options.overflow&&(g=this.alignedPosition(this.justifiedOptions(a,d,g),e))),d.crop&&(d=g.x-c.plotLeft,e=g.y-c.plotTop,b=c.isInsidePlot(d,e)&&c.isInsidePlot(d+a.width,e+a.height));return b?g:null},alignedPosition:function(a,
b){var c=a.align,e=a.verticalAlign,d=(b.x||0)+(a.x||0),f=(b.y||0)+(a.y||0),h,g;"right"===c?h=1:"center"===c&&(h=2);h&&(d+=(b.width-(a.width||0))/h);"bottom"===e?g=1:"middle"===e&&(g=2);g&&(f+=(b.height-(a.height||0))/g);return{x:Math.round(d),y:Math.round(f)}},justifiedOptions:function(a,b,c){var e=this.chart,d=b.align,f=b.verticalAlign,h=a.box?0:a.padding||0,g=a.getBBox();a={align:d,verticalAlign:f,x:b.x,y:b.y,width:a.width,height:a.height};b=c.x-e.plotLeft;var k=c.y-e.plotTop;c=b+h;0>c&&("right"===
d?a.align="left":a.x=-c);c=b+g.width-h;c>e.plotWidth&&("left"===d?a.align="right":a.x=e.plotWidth-c);c=k+h;0>c&&("bottom"===f?a.verticalAlign="top":a.y=-c);c=k+g.height-h;c>e.plotHeight&&("top"===f?a.verticalAlign="bottom":a.y=e.plotHeight-c);return a},attrsFromOptions:function(a){var b=this.attrsMap,c={},e,d;for(e in a)(d=b[e])&&(c[d]=a[e]);return c}};f.extend(C,{addAnnotation:function(a,b){var c=new y(this,a);this.annotations.push(c);this.options.annotations.push(a);w(b,!0)&&c.redraw();return c},
removeAnnotation:function(a){var b=this.annotations,c=G(b,function(b){return b.options.id===a});c&&(u(this.options.annotations,c.userOptions),u(b,c),c.destroy())},drawAnnotations:function(){var a=this.plotBoxClip,b=this.plotBox;a?a.attr(b):this.plotBoxClip=this.renderer.clipRect(b);n(this.annotations,function(a){a.redraw()})}});C.callbacks.push(function(a){a.annotations=[];n(a.options.annotations,function(b){a.annotations.push(new y(a,b))});a.drawAnnotations();l(a,"redraw",a.drawAnnotations);l(a,
"destroy",function(){var b=a.plotBoxClip;b&&b.destroy&&b.destroy()})});l(f.Chart,"afterGetContainer",function(){this.options.defs=m(O,this.options.defs||{});A(this.options.defs,function(a){"marker"===a.tagName&&!1!==a.render&&this.renderer.addMarker(a.id,a)},this)});f.SVGRenderer.prototype.symbols.connector=function(a,b,c,e,d){var f=d&&d.anchorX;d=d&&d.anchorY;var h,g,k=c/2;z(f)&&z(d)&&(h=["M",f,d],g=b-d,0>g&&(g=-e-g),g<c&&(k=f<a+c/2?g:c-g),d>b+e?h.push("L",a+k,b+e):d<b?h.push("L",a+k,b):f<a?h.push("L",
a,b+e/2):f>a+c&&h.push("L",a+c,b+e/2));return h||[]}})(l)});
//# sourceMappingURL=annotations.js.map


/***/ })

});
//# sourceMappingURL=28.js.map