webpackJsonp([32],{

/***/ 1227:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TransferDetailPageModule", function() { return TransferDetailPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__transfer_detail__ = __webpack_require__(1602);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var TransferDetailPageModule = /** @class */ (function () {
    function TransferDetailPageModule() {
    }
    TransferDetailPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_3__transfer_detail__["a" /* TransferDetailPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_3__transfer_detail__["a" /* TransferDetailPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], TransferDetailPageModule);
    return TransferDetailPageModule;
}());

//# sourceMappingURL=transfer-detail.module.js.map

/***/ }),

/***/ 1602:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TransferDetailPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var leaflet = __webpack_require__(613);
var TransferDetailPage = /** @class */ (function () {
    function TransferDetailPage(navCtrl, navParams, viewCtrl, metrics, logger, modalCtrl) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.metrics = metrics;
        this.logger = logger;
        this.modalCtrl = modalCtrl;
        this.loading = true;
        this.displayLong = 0;
        this.displayEleDiff = 0;
        this.displayDuration = 0;
        this.displaySpeed = 0;
        this.trasfer = { options: {} };
        this.isOwnActivity = false;
        this.paddingTopFromMap = "";
    }
    TransferDetailPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.isOwnActivity = this.navParams.get("ownActivity");
        this.activityId = this.navParams.get("activityId");
        this.typology = this.navParams.get("typology");
        this.trasfer = this.navParams.get("localTransfer");
        this.logger.debug("transfer", this.trasfer);
        this.displayLong = this.trasfer.displayLong;
        this.displayDuration = this.trasfer.displayDuration;
        this.displaySpeed = this.metrics.getConvertedSpeed(this.trasfer.avgSpeed / 3.6);
        if (this.trasfer.elevationGain > this.trasfer.elevationLoss) {
            this.displayEleDiff = "+" + this.metrics.getConvertedElevation(this.trasfer.elevationGain);
        }
        else {
            this.displayEleDiff = "-" + this.metrics.getConvertedElevation(this.trasfer.elevationGain);
        }
        if (this.trasfer.displayDuration != 0) {
            this.loading = false;
        }
        else {
            this.loading = false;
        }
        setTimeout(function () {
            _this.initLeafletMap(_this.trasfer);
            _this.paddingTopFromMap =
                _this.transferMap.nativeElement.clientHeight + "px";
        }, 100);
    };
    TransferDetailPage.prototype.ionViewWillEnter = function () {
        this.backText = this.navParams.get("backText");
        if (this.backText && this.backText.length) {
            this.viewCtrl.setBackButtonText(this.backText);
        }
    };
    TransferDetailPage.prototype.ionViewWillUnload = function () {
        if (this.map) {
            this.map.remove();
        }
    };
    TransferDetailPage.prototype.getMomentTime = function (startTime) {
        return this.metrics.getMomentTimeHHMM(startTime);
    };
    TransferDetailPage.prototype.initLeafletMap = function (transfer) {
        var coordinates = [];
        for (var _i = 0, _a = transfer.coordinates; _i < _a.length; _i++) {
            var point = _a[_i];
            coordinates.push([point[2], point[1]]);
        }
        this.map = leaflet
            .map(this.transferMap.nativeElement, {
            zoomControl: false,
            attributionControl: false,
        })
            .setView({ lat: coordinates[0][0], lng: coordinates[0][1] }, 16);
        leaflet
            .tileLayer("https://maps-server.whip.live/styles/satellite-map-style/{z}/{x}/{y}@2x.png", {})
            .addTo(this.map);
        this._addLayer(coordinates);
    };
    TransferDetailPage.prototype._addLayer = function (coordinates) {
        var polyTransfer = leaflet
            .polyline(coordinates, {
            className: "transferbg",
            weight: 4,
            color: "#333333",
        })
            .addTo(this.map);
        leaflet
            .polyline(coordinates, {
            className: "transfer",
            weight: 2,
            color: "#ffffff",
        })
            .addTo(this.map);
        var startIcon = leaflet.icon({
            iconUrl: "https://static-media.whip.live/icons/triangle.png",
            iconSize: [16, 16],
            iconAnchor: [8, 8],
        });
        leaflet.marker(coordinates[0], { icon: startIcon }).addTo(this.map);
        var endIcon = leaflet.icon({
            iconUrl: "https://static-media.whip.live/icons/flag.png",
            iconSize: [20, 22],
            iconAnchor: [1, 22],
        });
        leaflet
            .marker(coordinates[coordinates.length - 1], { icon: endIcon })
            .addTo(this.map);
        this.map.fitBounds(polyTransfer.getBounds());
    };
    TransferDetailPage.prototype.goToAddNewSegment = function () {
        var _this = this;
        var callbackFromActivity = this.navParams.get("callback");
        var modalNewSegment = this.modalCtrl.create("NewSegmentPage", {
            activityId: this.activityId,
            allCoordinates: this.navParams.get('recordingCoordinates'),
            structureValues: {
                lower: this.trasfer.startIndex,
                upper: this.trasfer.endIndex,
            },
            typology: this.typology
        });
        modalNewSegment.present();
        modalNewSegment.onDidDismiss(function (data) {
            if (data && data.newSegmentHasBeenRefreshed) {
                _this.navCtrl.pop().then(function () { return callbackFromActivity({ newSegmentHasBeenRefreshed: true }).then(); });
            }
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("transfermap"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], TransferDetailPage.prototype, "transferMap", void 0);
    TransferDetailPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-transfer-detail",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/transfer-detail/transfer-detail.html"*/'<ion-header>\n\n  <ion-navbar>\n  </ion-navbar>\n\n</ion-header>\n\n<ion-content fullscreen>\n\n  <ion-spinner class="center" *ngIf="loading"></ion-spinner>\n\n  <div ion-fixed #transfermap class="transfer-map" *ngIf="!loading"></div>\n\n  <div class="general-info-container" *ngIf="!loading" [style.padding-top]="paddingTopFromMap">\n    <div class="aggregate-metrics">\n      <div class="info-row">\n        <div class="info-container r">\n          <div class="left-infos">\n            <div class="empty-item"></div>\n            <div class="icon"><span class="icon-whip-timer"></span></div>\n          </div>\n          <div class="right-infos">\n            <div class="text">{{ \'record_ride.time_text\' | translate }}</div>\n            <div class="value">\n              <div class="number">{{ displayDuration }}</div>\n              <span class="string">{{ fromTime }}</span>\n            </div>\n          </div>\n        </div>\n\n        <div class="info-container l">\n          <div class="left-infos">\n            <div class="empty-item"></div>\n            <div class="icon"><span class="icon-whip-path"></span></div>\n            \n          </div>\n          <div class="right-infos">\n            <div class="text">{{ \'record_ride.distance_text\' | translate }}</div>\n            <div class="value">\n              <span class="number">{{ displayLong }}</span>\n              <span class="string"> {{ fromLong }}</span>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n\n    <div class="aggregate-metrics" *ngIf="trasfer.guessed">\n      <div class="info-row">\n        <div class="info-container r">\n          <div class="left-infos">\n            <div class="empty-item"></div>\n            <div class="icon"><span class="icon-whip-fire"></span></div>\n          </div>\n          <div class="right-infos">\n            <div class="text">{{ \'trasfer_page.avg_speed\' | translate }}</div>\n            <div class="value">\n              <div class="number">{{ displaySpeed }}</div>\n              <span class="string">{{ fromTime }}</span>\n            </div>\n          </div>\n        </div>\n\n        <div class="info-container l">\n          <div class="left-infos">\n            <div class="empty-item"></div>\n            <div class="icon"><span class="icon-whip-mountain"></span></div>\n            \n          </div>\n          <div class="right-infos">\n            <div class="text">{{ \'trasfer_page.ele_difference\' | translate }}</div>\n            <div class="value">\n              <span class="number">{{ displayEleDiff }}</span>\n              <span class="string"> {{ fromLong }}</span>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n\n    <div class="trasfer element" [ngClass]="{ \'guessed\': trasfer.guessed, \'g-start\': trasfer.guessedStart, \'g-end\': trasfer.guessedEnd }">\n      <div class="line-container">\n        <div class="line-wrap">\n          <div class="line" [style.background]="trasfer.color">\n            <div class="bottom circle"></div>\n          </div>\n          <div class="top circle"></div>\n        </div>\n      </div>\n\n      <div class="moment start first">{{getMomentTime(trasfer.startTime*1000)}}</div>\n      <div class="moment end last">{{getMomentTime(trasfer.endTime*1000)}}</div>\n      <div class="text-container">\n        <div class="name">\n          <div class="part part-start" [ngClass]="{\'ele-icon\':trasfer.startNameEle}">\n            <span [ngClass]="trasfer.startIcon" class="wp-icon"></span>\n            <span *ngIf="trasfer.startNameEle" class="ele"><small>{{trasfer.startNameEle}}m</small> </span>\n            <span>{{trasfer.startName}}</span>\n            \n          </div>\n          \n          <div class="part part-end" [ngClass]="{\'ele-icon\': trasfer.endNameEle}">\n            <span [ngClass]="trasfer.endIcon" class="wp-icon"></span>\n            <span *ngIf="trasfer.endNameEle" class="ele"><small>{{trasfer.endNameEle}}m</small> </span>\n            <span>{{trasfer.endName}}</span>\n            \n          </div>\n        </div>\n\n        <div class="part part-center">\n          <div *ngIf="trasfer.guessed && trasfer.options && trasfer.options.showTime">{{trasfer.name}}</div>\n          <div class="time">\n            \n            <span class="badge" [style.color]="trasfer.color">\n              {{trasfer.displayPendence}}%\n              <span *ngIf="trasfer.pendence < 0">\n                <ion-icon name="md-arrow-round-down"></ion-icon>\n              </span>\n              <span *ngIf="trasfer.pendence > 0">\n                <ion-icon name="md-arrow-round-up"></ion-icon>\n              </span>\n            </span>\n          </div>\n        </div>\n\n      </div>\n    </div>\n  </div>\n\n</ion-content>\n\n<ion-footer class="transferdetail-footer" *ngIf="isOwnActivity">\n  <ion-toolbar>\n    <button class="general-wp-button" ion-button (click)="goToAddNewSegment()">\n      <span class="icon-whip-path wp-icon"></span>\n      <span class="text">{{ \'activity_timeline.new_segment\' | translate }}</span>\n    </button>\n  </ion-toolbar>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/transfer-detail/transfer-detail.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["n" /* ModalController */]])
    ], TransferDetailPage);
    return TransferDetailPage;
}());

//# sourceMappingURL=transfer-detail.js.map

/***/ })

});
//# sourceMappingURL=32.js.map