webpackJsonp([38],{

/***/ 1220:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignalPhotoUploadPageModule", function() { return SignalPhotoUploadPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__signal_photo_upload__ = __webpack_require__(1596);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var SignalPhotoUploadPageModule = /** @class */ (function () {
    function SignalPhotoUploadPageModule() {
    }
    SignalPhotoUploadPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__signal_photo_upload__["a" /* SignalPhotoUploadPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__signal_photo_upload__["a" /* SignalPhotoUploadPage */]),
            ],
        })
    ], SignalPhotoUploadPageModule);
    return SignalPhotoUploadPageModule;
}());

//# sourceMappingURL=signal-photo-upload.module.js.map

/***/ }),

/***/ 1596:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignalPhotoUploadPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_signal_signal__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(9);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var SignalPhotoUploadPage = /** @class */ (function () {
    function SignalPhotoUploadPage(navCtrl, navParams, translate, signalProvider, viewCtrl) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.translate = translate;
        this.signalProvider = signalProvider;
        this.viewCtrl = viewCtrl;
        this.pageId = 'photo';
        this.lang = '';
        this.signalVisibility = [];
        this.signalDescription = '';
        this.signalPhotos = [];
        // Retrieve data from the signal modal
        this.categorySelected = this.navParams.get('category');
        this.tagSelected = this.navParams.get('tag');
        this.signalDescription = this.navParams.get('description');
        this.signalVisibility = this.navParams.get('visibility');
        this.signalPhotos = this.navParams.get('photos');
        this.position = this.navParams.get('position');
        this.lang = __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* UtilsProvider */].getUserLanguage();
    }
    SignalPhotoUploadPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        console.log('SIGNAL PHOTO PAGE - ionViewDidLoad SignalPhotoUploadPage');
        // Subscribe to loading complete event
        this.loadingCompleteSub = this.signalProvider.onLoadingComplete.subscribe(function (page) {
            if (page === _this.pageId) {
                // Close modal when loading completes
                //this.sendSignal(); 
            }
        });
    };
    SignalPhotoUploadPage.prototype.ionViewDidEnter = function () {
        this.signalProvider.triggerButtonLoading(this.pageId);
    };
    SignalPhotoUploadPage.prototype.ionViewDidLeave = function () {
        this.signalProvider.stopLoading(this.pageId);
        this.signalProvider.signalPhotos = [];
    };
    SignalPhotoUploadPage.prototype.pauseLoading = function () {
        this.signalProvider.pauseLoading(this.pageId);
    };
    SignalPhotoUploadPage.prototype.resumeLoading = function () {
        this.signalProvider.resumeLoading(this.pageId);
    };
    SignalPhotoUploadPage.prototype.handleLoading = function (event) {
        console.log("HANDLE LOADING EVENT: ", event);
        if (event) {
            this.pauseLoading();
        }
    };
    SignalPhotoUploadPage.prototype.onPhotosUpdate = function (updatedPhotos) {
        this.signalPhotos = updatedPhotos;
        console.log('SIGNAL PHOTO PAGE -  received updated photos:', this.signalPhotos);
        this.resumeLoading();
    };
    SignalPhotoUploadPage.prototype.sendSignal = function () {
        var _this = this;
        var data = {
            categoryId: this.categorySelected.id,
            subCategoryId: this.tagSelected.id,
            showTo: this.signalVisibility,
            description: this.signalDescription,
            photos: this.signalPhotos,
            position: this.position
        };
        this.signalProvider.createSignal(data);
        this.navCtrl.popToRoot().then(function () {
            // Dismiss the entire modal from the root page
            _this.viewCtrl.dismiss();
        });
    };
    SignalPhotoUploadPage.prototype.ngOnDestroy = function () {
        // Unsubscribe to avoid memory leaks
        if (this.loadingCompleteSub) {
            this.loadingCompleteSub.unsubscribe();
        }
    };
    SignalPhotoUploadPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-signal-photo-upload',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/signal-photo-upload/signal-photo-upload.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-title *ngIf="categorySelected">{{ categorySelected.name[lang] }}</ion-title>\n  </ion-navbar>\n</ion-header>\n\n<ion-content padding>\n  <signal-photo-uploader [initPhotos]="signalPhotos" (loadingPaused)="handleLoading($event)" (photos)="onPhotosUpdate($event)"></signal-photo-uploader>\n</ion-content>\n\n<ion-footer>\n  <ion-buttons padding class="button-container">\n    <button id="loading-photo-button" ion-button (click)="sendSignal()">\n      {{ \'signal.send_report\' | translate }}\n    </button>\n  </ion-buttons>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/signal-photo-upload/signal-photo-upload.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */],
            __WEBPACK_IMPORTED_MODULE_3__providers_signal_signal__["a" /* SignalProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */]])
    ], SignalPhotoUploadPage);
    return SignalPhotoUploadPage;
}());

//# sourceMappingURL=signal-photo-upload.js.map

/***/ })

});
//# sourceMappingURL=38.js.map