webpackJsonp([49],{

/***/ 1206:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SearchRidersPageModule", function() { return SearchRidersPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__search_riders__ = __webpack_require__(1580);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var SearchRidersPageModule = /** @class */ (function () {
    function SearchRidersPageModule() {
    }
    SearchRidersPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__search_riders__["a" /* SearchRidersPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__search_riders__["a" /* SearchRidersPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], SearchRidersPageModule);
    return SearchRidersPageModule;
}());

//# sourceMappingURL=search-riders.module.js.map

/***/ }),

/***/ 1580:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchRidersPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_forms__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_operators__ = __webpack_require__(105);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_operators___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_operators__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_user_social_user_social__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_search_search__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_authentication_authentication__ = __webpack_require__(11);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var SearchRidersPage = /** @class */ (function () {
    //@ViewChildren("searchInput") searchInput: any;
    function SearchRidersPage(navParams, translate, social, searchProvider, viewCtrl, events, auth) {
        this.navParams = navParams;
        this.translate = translate;
        this.social = social;
        this.searchProvider = searchProvider;
        this.viewCtrl = viewCtrl;
        this.events = events;
        this.auth = auth;
        this.ridersSegment = {};
        this.searchbarCancelButton = "";
        this.searchbarPlaceholder = "";
        this.query = "";
        this.searchbarFocusEnable = false;
        this.searchedRidersValue = [];
        this.isError = false;
        this.isLoading = true;
        this.searchControl = new __WEBPACK_IMPORTED_MODULE_3__angular_forms__["b" /* FormControl */]();
    }
    SearchRidersPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.searchbarCancelButton = this.translate.instant("search.cancel_button");
        this.searchbarPlaceholder = this.translate.instant("search.title_search_riders_page");
        var isQuery = false;
        this.query = this.navParams.get("queryFromExplore");
        if (this.query && this.query.length > 0) {
            isQuery = true;
        }
        var fromPage = this.navParams.get("fromPage");
        if (fromPage === "explore") {
            var dataArrived_1 = false;
            this.events.subscribe("riders_from_explore", function (data) {
                _this.ridersSegment = data.riders;
                _this.latitude = data.latitude;
                _this.longitude = data.longitude;
                dataArrived_1 = true;
            });
            setTimeout(function () {
                if (!dataArrived_1) {
                    _this.ridersSegment = {};
                    _this.searchResultsNearYou();
                }
            }, 3000);
            this.ridersSegment = this.navParams.get("ridersSegment");
            this.latitude = this.navParams.get("latitude");
            this.longitude = this.navParams.get("longitude");
        }
        else if (!isQuery) {
            this.latitude = this.navParams.get("latitude");
            this.longitude = this.navParams.get("longitude");
            this.searchResultsNearYou();
        }
        else if (isQuery) {
            this.searchbar.writeValue(this.query);
            this.searchRiders(this.query);
        }
        else {
            this.isLoading = false;
        }
        if (fromPage == "home") {
            setTimeout(function () {
                _this.searchbar.setFocus();
            }, 1000);
        }
        this.searchControl.valueChanges
            .pipe(Object(__WEBPACK_IMPORTED_MODULE_4_rxjs_operators__["debounceTime"])(500))
            .subscribe(function (search) {
            _this.query = search;
            _this.searchRiders(search);
        });
    };
    SearchRidersPage.prototype.ionViewWillEnter = function () {
        this.viewCtrl.setBackButtonText("");
    };
    SearchRidersPage.prototype.searchRiders = function (query) {
        var _this = this;
        this.isError = false;
        this.isLoading = true;
        var activeParamsToRequest = {
            query: query,
        };
        if (this.latitude && this.longitude) {
            activeParamsToRequest.latitude = this.latitude;
            activeParamsToRequest.longitude = this.longitude;
        }
        this.searchProvider
            .searchingWithFilters(activeParamsToRequest, "/riders")
            .then(function (data) {
            _this.isLoading = false;
            _this.searchedRidersValue = data.riders;
        })
            .catch(function (e) {
            _this.isLoading = false;
            _this.isError = true;
        });
    };
    SearchRidersPage.prototype.openSearchbarContainer = function (e) {
        this.searchbarFocusEnable = true;
    };
    SearchRidersPage.prototype.clearSearchbarInput = function () {
        this.query = "";
        this.searchedRidersValue = [];
    };
    SearchRidersPage.prototype.cancelSearchbarInputAction = function () {
        this.searchbarFocusEnable = false;
        this.query = "";
        this.searchedRidersValue = [];
    };
    SearchRidersPage.prototype.inviteFriends = function () {
        this.social.inviteFriends();
    };
    SearchRidersPage.prototype.scrollHandlerStart = function (e) {
        if (window.Keyboard.isVisible) {
            window.Keyboard.hide();
        }
    };
    SearchRidersPage.prototype.isEmptyObject = function (obj) {
        if (Object.keys(obj).length > 0) {
            return true;
        }
        else {
            return false;
        }
    };
    SearchRidersPage.prototype.searchResultsNearYou = function () {
        var _this = this;
        this.isError = false;
        this.isLoading = true;
        var activeParamsToRequest = {};
        if (this.latitude && this.longitude) {
            activeParamsToRequest.latitude = this.latitude;
            activeParamsToRequest.longitude = this.longitude;
        }
        activeParamsToRequest.countryCode = this.auth.getDataUser().country;
        this.searchbar._elementRef.nativeElement.classList.remove("searchbar-active");
        this.searchbar._elementRef.nativeElement.classList.remove("ng-touched");
        this.searchbar._elementRef.nativeElement.classList.remove("searchbar-has-focus");
        this.searchbar.clearInput(null);
        this.query = "";
        this.searchbarFocusEnable = false;
        if (!Object.keys(this.ridersSegment).length) {
            this.searchProvider
                .searchingWithFilters(activeParamsToRequest, "/riders/segmented", true)
                .then(function (data) {
                _this.isLoading = false;
                _this.ridersSegment = data;
            })
                .catch(function (e) {
                _this.isLoading = false;
                _this.isError = true;
            });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("ersearchbar"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* Searchbar */])
    ], SearchRidersPage.prototype, "searchbar", void 0);
    SearchRidersPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-search-riders",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/search-riders/search-riders.html"*/'<ion-header>\n	\n	<ion-toolbar>\n		<ion-navbar>\n			<div class="searchbar-filters-container" [ngClass]="{\'edit-style\': searchbarFocusEnable}">\n				<ion-searchbar\n					class="searchbar-ios"\n					#ersearchbar\n					autocomplete="name"\n					autocorrect="off"\n					showCancelButton="false"\n					[cancelButtonText]="searchbarCancelButton"\n					[placeholder]="searchbarPlaceholder"\n					[formControl]="searchControl"\n					(tap)="openSearchbarContainer($event)"\n					(ionClear)="clearSearchbarInput($event)"\n					(ionCancel)="cancelSearchbarInputAction($event)"\n				></ion-searchbar>\n			</div>\n		</ion-navbar>\n	</ion-toolbar>\n</ion-header>\n\n<ion-content (ionScrollStart)="scrollHandlerStart($event)">\n	<div class="default-riders-container" *ngIf="!query.length">\n\n		<div *ngIf="isEmptyObject(ridersSegment) && !isLoading">\n			<div class="results-riders-container" *ngIf="ridersSegment.nearRiders && ridersSegment.nearRiders.length > 0">\n				<div class="separator-header">{{ ridersSegment.nearRidersTitleTranslate }}</div>\n				<div class="scroll-area-container">\n					<search-card *ngFor="let user of ridersSegment.nearRiders" [searchable]="user" [isUserCard]="\'true\'"></search-card>\n				</div>\n			</div>\n	\n			<div class="results-riders-container" *ngIf="ridersSegment.countryRiders && ridersSegment.countryRiders.length > 0">\n				<div class="separator-header">{{ ridersSegment.countryRidersTitleTranslate }}</div>\n				<div class="scroll-area-container">\n					<search-card *ngFor="let user of ridersSegment.countryRiders" [searchable]="user" [isUserCard]="\'true\'"></search-card>\n				</div>\n			</div>\n	\n			<div class="results-riders-container" *ngIf="ridersSegment.recommendedRiders && ridersSegment.recommendedRiders.length > 0">\n				<div class="separator-header">{{ ridersSegment.recommendedRidersTitleTranslate }}</div>\n				<div class="scroll-area-container">\n					<search-card *ngFor="let user of ridersSegment.recommendedRiders" [searchable]="user" [isUserCard]="\'true\'"></search-card>\n				</div>\n			</div>\n		</div>\n\n		<div *ngIf="isLoading">\n			<ion-spinner class="center"></ion-spinner>\n		</div>\n	</div>\n\n	<div class="search-riders-container" *ngIf="query.length > 0">\n		<ion-list>\n			<search-card *ngFor="let user of searchedRidersValue" [searchable]="user"></search-card>\n		</ion-list>\n\n		<div *ngIf="isLoading">\n			<ion-spinner class="center"></ion-spinner>\n		</div>\n		\n		<div class="no-riders-found-container" *ngIf="!searchedRidersValue.length && !isLoading">\n			<h3 class="no-riders-found">{{\'search.no_riders_found\' | translate}}</h3>\n			<button ion-button (click)="searchResultsNearYou()">{{\'search.search_near_you\' | translate}}</button>\n		</div>\n	</div>\n\n</ion-content>\n\n<ion-footer>\n	<ion-toolbar>\n		<button ion-button (click)="inviteFriends()">\n			<div class="container">\n				<ion-icon name="ios-people"></ion-icon>\n				<span class="text">{{\'search.invite_friends_search_rider\' | translate}}</span>\n			</div>\n		</button>\n	</ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/search-riders/search-riders.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_user_social_user_social__["a" /* UserSocialProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_search_search__["a" /* SearchProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* Events */],
            __WEBPACK_IMPORTED_MODULE_7__providers_authentication_authentication__["a" /* AuthenticationProvider */]])
    ], SearchRidersPage);
    return SearchRidersPage;
}());

//# sourceMappingURL=search-riders.js.map

/***/ })

});
//# sourceMappingURL=49.js.map