webpackJsonp([75],{

/***/ 1172:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "NotificationPageModule", function() { return NotificationPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__notification__ = __webpack_require__(1543);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var NotificationPageModule = /** @class */ (function () {
    function NotificationPageModule() {
    }
    NotificationPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__notification__["a" /* NotificationPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__notification__["a" /* NotificationPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], NotificationPageModule);
    return NotificationPageModule;
}());

//# sourceMappingURL=notification.module.js.map

/***/ }),

/***/ 1543:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NotificationPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_notification_notification__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_analytics_analytics__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_check_gps_check_gps__ = __webpack_require__(220);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var NotificationPage = /** @class */ (function () {
    function NotificationPage(navCtrl, modalCtrl, navParams, notificationProvider, analyticsProvider, auth, checkGps, translate) {
        this.navCtrl = navCtrl;
        this.modalCtrl = modalCtrl;
        this.navParams = navParams;
        this.notificationProvider = notificationProvider;
        this.analyticsProvider = analyticsProvider;
        this.auth = auth;
        this.checkGps = checkGps;
        this.translate = translate;
        this.notifications = [];
    }
    NotificationPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.checkGps
            .forciblyAskLocalNotificationPermission()
            .then(function (permissions) {
            if (permissions && !permissions.requestLocalNotificationPermission) {
                _this.analyticsProvider.initPushNotification(_this.auth.getDataUser());
                var userNotifications = _this.navParams.get("userNotifications");
                _this.processNotifications(userNotifications, true);
            }
        })
            .catch();
    };
    NotificationPage.prototype.doRefreshNotifications = function (refresher, doNotificationUpdate) {
        var _this = this;
        this.notificationProvider
            .checkNotificationsUpdate()
            .then(function (notifications) {
            refresher.complete();
            _this.processNotifications(notifications, doNotificationUpdate);
        })
            .catch(function (error) {
            refresher.complete();
        });
    };
    NotificationPage.prototype.goToMenu = function () {
        var urlToEmbed = "https://www.whip.live/notifications?is-inapp=true&token=" + this.auth.getToken();
        this.navCtrl.push("InappPage", { urlToEmbed: urlToEmbed, pageTitle: this.translate.instant('menu_page.notifications') });
    };
    NotificationPage.prototype.processNotifications = function (userNotifications, doNotificationUpdate) {
        if (userNotifications && userNotifications.outHomeNotifications.length) {
            this.notifications = userNotifications.outHomeNotifications;
            this.notificationProvider.setLastTimeNotificationUpdate(userNotifications.lastCheckHash);
            var callback = this.navParams.get("callback");
            if (callback)
                callback.then({ hideNotificationBadge: true });
        }
        else if (doNotificationUpdate) {
            this.refresher._beginRefresh();
            this.doRefreshNotifications(this.refresher, false);
        }
    };
    NotificationPage.prototype.openNotification = function (notification) {
        this.notificationProvider.addExternalEvent(notification.link, true);
    };
    NotificationPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-notification",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/notification/notification.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-title>{{ \'notification_page.title\' | translate }}</ion-title>\n    <ion-buttons end>\n      <button ion-button (click)="goToMenu()">\n        <ion-icon md="md-settings" ios="md-settings"></ion-icon>\n      </button>\n    </ion-buttons>\n  </ion-navbar>\n</ion-header>\n\n<ion-content>\n  <ion-refresher (ionRefresh)="doRefreshNotifications($event, false)">\n    <ion-refresher-content></ion-refresher-content>\n  </ion-refresher>\n\n  <p class="no-notifications-info" *ngIf="!notifications.length">{{ \'notification_page.no_notifications_provided\' | translate }}</p>\n  \n  <ion-list *ngIf="notifications.length">\n    <help-card *ngFor="let notification of notifications" [cardType]="\'notification\'" [data]="notification" (click)="openNotification(notification)"></help-card>\n  </ion-list>\n</ion-content>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/notification/notification.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["n" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_3__providers_notification_notification__["a" /* NotificationProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_analytics_analytics__["a" /* AnalyticsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_check_gps_check_gps__["a" /* CheckGpsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], NotificationPage);
    return NotificationPage;
}());

//# sourceMappingURL=notification.js.map

/***/ })

});
//# sourceMappingURL=75.js.map