webpackJsonp([83],{

/***/ 1158:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LeaderboardPageModule", function() { return LeaderboardPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__leaderboard__ = __webpack_require__(1527);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var LeaderboardPageModule = /** @class */ (function () {
    function LeaderboardPageModule() {
    }
    LeaderboardPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__leaderboard__["a" /* LeaderboardPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__leaderboard__["a" /* LeaderboardPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], LeaderboardPageModule);
    return LeaderboardPageModule;
}());

//# sourceMappingURL=leaderboard.module.js.map

/***/ }),

/***/ 1527:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LeaderboardPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_segment_segment__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_loader_loader__ = __webpack_require__(72);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var LeaderboardPage = /** @class */ (function () {
    function LeaderboardPage(navCtrl, navParams, viewCtrl, segmentProvider, metricsProvider, loader) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.segmentProvider = segmentProvider;
        this.metricsProvider = metricsProvider;
        this.loader = loader;
        this.loading = true;
        this.segmentName = "";
        this.showBeTheFirstContainer = false;
    }
    LeaderboardPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        var leaderboard = this.navParams.get("leaderboard");
        this.leaderboardTitle = leaderboard.name;
        this.segmentName = leaderboard.segmentName;
        if (!leaderboard.isFakeSegment) {
            this.segmentProvider
                .getLeaderboard(leaderboard.filtersNames, leaderboard.filtersValues)
                .then(function (leaderboardData) {
                var leaderboardDataLength = leaderboardData.length;
                for (var i = 0; i < leaderboardDataLength; i++) {
                    if (i == 0) {
                        leaderboardData[i].show_backgrond = true;
                        leaderboardData[i].color_difference = "#00B288";
                        leaderboardData[i].difference = _this.compareTimeDifference(leaderboardData[i].personal_record -
                            leaderboardData[i].personal_record);
                        leaderboardData[i].display_personal_record = _this.onFormatTime(_this.metricsProvider.getDisplayTime(leaderboardData[i].personal_record, true))[0];
                        leaderboardData[i].display_tenths = _this.onFormatTime(_this.metricsProvider.getDisplayTime(leaderboardData[i].personal_record, true))[1];
                    }
                    else {
                        leaderboardData[i].show_backgrond = false;
                        leaderboardData[i].color_difference = "red";
                        leaderboardData[i].difference = _this.compareTimeDifference(leaderboardData[i].personal_record -
                            leaderboardData[0].personal_record);
                        leaderboardData[i].display_personal_record = _this.onFormatTime(_this.metricsProvider.getDisplayTime(leaderboardData[i].personal_record, true))[0];
                        leaderboardData[i].display_tenths = _this.onFormatTime(_this.metricsProvider.getDisplayTime(leaderboardData[i].personal_record, true))[1];
                    }
                }
                _this.loading = false;
                _this.leaderboardRiders = leaderboardData;
            })
                .catch(function (error) { });
        }
        else {
            this.loading = false;
            this.showBeTheFirstContainer = true;
        }
    };
    LeaderboardPage.prototype.onSelectRider = function (riderSelect, index) {
        for (var _i = 0, _a = this.leaderboardRiders; _i < _a.length; _i++) {
            var rider = _a[_i];
            rider.show_backgrond = false;
            rider.difference = this.compareTimeDifference(rider.personal_record - riderSelect.personal_record);
            rider.color_difference = this.color;
        }
        this.leaderboardRiders[index].show_backgrond = true;
    };
    LeaderboardPage.prototype.compareTimeDifference = function (time) {
        if (time !== 0) {
            if (time > 0) {
                var diff = this.metricsProvider.getDisplayTime(Math.abs(time), true);
                this.color = "red";
                return "+ " + diff;
            }
            else if (time < 0) {
                var diff = this.metricsProvider.getDisplayTime(Math.abs(time), true);
                this.color = "#00B288";
                return "- " + diff;
            }
        }
        else {
            var diff = "+ 00:00.0";
            this.color = "#00B288";
            return diff;
        }
    };
    LeaderboardPage.prototype.onFormatTime = function (stringTime) {
        var lastIndex = stringTime.indexOf(".");
        var time = stringTime.substring(0, (lastIndex += 1));
        var tenths = stringTime.substring(lastIndex, stringTime.length);
        return [time, tenths];
    };
    LeaderboardPage.prototype.goToRelatedActivity = function (rider) {
        var _this = this;
        this.loader.showLoader();
        this.segmentProvider
            .getMatchingSegment(rider.matching_id)
            .then(function (segmentInfo) {
            _this.loader.hideLoader();
            _this.navCtrl.push("ActivityPage", {
                currentActivity: { id: segmentInfo.activity_id },
            });
        })
            .catch(function (error) {
            _this.loader.hideLoader();
        });
    };
    LeaderboardPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-leaderboard",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/leaderboard/leaderboard.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-title>{{segmentName}}</ion-title>\n  </ion-navbar>\n</ion-header>\n\n\n<ion-content>\n  <h1 class="page-title">{{leaderboardTitle}}</h1>\n\n  <ion-spinner class="center" *ngIf="loading"></ion-spinner>\n\n  <ion-list *ngIf="!loading && !showBeTheFirstContainer">\n    <ion-item class="rider-container" *ngFor="let rider of leaderboardRiders; index as i;">\n      <div class="info">\n        <div class="user-info">\n          <div class="rank-background" [ngClass]="{ \'show-rank-background-color\': rider.show_backgrond &&  rider.rank > 1}">\n            <a (click)="onSelectRider(rider, i)">\n              <div class="rank">\n                <span *ngIf="rider.rank == 1" class="icon-whip-leaderboard-kom whip-icon"></span>\n                <span *ngIf="rider.rank != 1">{{ rider.rank }}</span>\n              </div>\n            </a>\n          </div>\n          <a (click)="goToRelatedActivity(rider)">\n            <compact-user-info [isbadge]="true" [user]="rider.user" [display]="\'leaderboard\'" [tags]="rider.recording_tags"></compact-user-info>\n          </a>\n        </div>\n        <div class="time-and-diff-time">\n          <a (click)="goToRelatedActivity(rider)">\n            <div class="time">\n              <span>{{rider.display_personal_record}}</span><span class="tenths-time">{{rider.display_tenths}}</span>\n            </div>\n            <div class="diff-time" [ngStyle]="{ \'color\': rider.color_difference }">{{rider.difference}}</div>\n          </a>\n        </div>\n      </div>\n    </ion-item>      \n  </ion-list>\n  \n  <p *ngIf="showBeTheFirstContainer" class="be-the-first-text">{{\'leaderboard_page.be_the_first\' | translate}}</p>\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/leaderboard/leaderboard.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__providers_segment_segment__["a" /* SegmentProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_loader_loader__["a" /* LoaderProvider */]])
    ], LeaderboardPage);
    return LeaderboardPage;
}());

//# sourceMappingURL=leaderboard.js.map

/***/ })

});
//# sourceMappingURL=83.js.map