webpackJsonp([88],{

/***/ 1148:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GraphicSettingsPageModule", function() { return GraphicSettingsPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__graphic_settings__ = __webpack_require__(1509);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var GraphicSettingsPageModule = /** @class */ (function () {
    function GraphicSettingsPageModule() {
    }
    GraphicSettingsPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__graphic_settings__["a" /* GraphicSettingsPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__graphic_settings__["a" /* GraphicSettingsPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
        })
    ], GraphicSettingsPageModule);
    return GraphicSettingsPageModule;
}());

//# sourceMappingURL=graphic-settings.module.js.map

/***/ }),

/***/ 1509:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GraphicSettingsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var GraphicSettingsPage = /** @class */ (function () {
    function GraphicSettingsPage(navCtrl, navParams, translate, viewCtrl) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.translate = translate;
        this.viewCtrl = viewCtrl;
    }
    GraphicSettingsPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.map_layers = this.navParams.get("data").map_style;
        this.show_columns = this.navParams.get("data").show_columns;
        this.show_maxElevation = this.navParams.get("data").show_max_elevation;
        this.show_maxVelocity = this.navParams.get("data").show_max_speed;
        this.translate.get("modal_settings.title").subscribe(function (title) {
            _this._chartSetting = title;
            _this.translate.get("modal_settings.close").subscribe(function (close) {
                _this._close = close;
                _this.translate.get("modal_settings.show_text_1").subscribe(function (text1) {
                    _this._columnText = text1;
                    _this.translate
                        .get("modal_settings.show_text_2")
                        .subscribe(function (text2) {
                        _this._maxElevationText = text2;
                        _this.translate
                            .get("modal_settings.show_text_3")
                            .subscribe(function (text3) {
                            _this._maxVelocityText = text3;
                        });
                    });
                });
            });
        });
    };
    GraphicSettingsPage.prototype.closeModal = function () {
        var data = {
            show_columns: this.show_columns,
            show_max_speed: this.show_maxVelocity,
            show_max_elevation: this.show_maxElevation,
        };
        this.viewCtrl.dismiss(data);
    };
    GraphicSettingsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-graphic-settings",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/graphic-settings/graphic-settings.html"*/'<ion-header>\n\n  <ion-navbar>\n    <ion-buttons start>\n      <button ion-button icon-only (click)="closeModal()">{{ \'graphic_setting_page.close_button_text\' | translate }}</button>\n    </ion-buttons>\n  </ion-navbar>\n\n</ion-header>\n\n\n<ion-content>\n  <div class="wh-divider margin-bottom">\n    <div class="title">{{_chartSetting}}</div>\n  </div>\n  <ion-list>\n    <ion-item>\n      <ion-label>{{_columnText}}</ion-label>\n      <ion-checkbox [(ngModel)]="show_columns"></ion-checkbox>\n    </ion-item>\n  \n    <!-- <ion-item>\n      <ion-label>{{_maxElevationText}}</ion-label>\n      <ion-checkbox [(ngModel)]="show_maxElevation"></ion-checkbox>\n    </ion-item>\n  \n    <ion-item>\n      <ion-label>{{_maxVelocityText}}</ion-label>\n      <ion-checkbox [(ngModel)]="show_maxVelocity"></ion-checkbox>\n    </ion-item> -->\n  </ion-list>\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/graphic-settings/graphic-settings.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */]])
    ], GraphicSettingsPage);
    return GraphicSettingsPage;
}());

//# sourceMappingURL=graphic-settings.js.map

/***/ })

});
//# sourceMappingURL=88.js.map