webpackJsonp([92],{

/***/ 1146:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GoalPageModule", function() { return GoalPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__goal__ = __webpack_require__(1507);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var GoalPageModule = /** @class */ (function () {
    function GoalPageModule() {
    }
    GoalPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__goal__["a" /* GoalPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__goal__["a" /* GoalPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */]
            ],
        })
    ], GoalPageModule);
    return GoalPageModule;
}());

//# sourceMappingURL=goal.module.js.map

/***/ }),

/***/ 1507:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GoalPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_forms__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_category_category__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_user_social_user_social__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var GoalPage = /** @class */ (function () {
    function GoalPage(viewCtrl, translate, convertMetrics, userSocialProvider, toastCtrl, categoryProvider, formBuilder, logger, navParams) {
        this.viewCtrl = viewCtrl;
        this.translate = translate;
        this.convertMetrics = convertMetrics;
        this.userSocialProvider = userSocialProvider;
        this.toastCtrl = toastCtrl;
        this.categoryProvider = categoryProvider;
        this.formBuilder = formBuilder;
        this.logger = logger;
        this.navParams = navParams;
        this.regularities = [
            {
                name: this.translate.instant("goal_page.regularity_weekly"),
                isSelect: true,
                key: "WEEKLY_GOAL",
            },
            {
                name: this.translate.instant("goal_page.regularity_monthly"),
                isSelect: false,
                key: "MONTHLY_GOAL",
            },
            {
                name: this.translate.instant("goal_page.regularity_yearly"),
                isSelect: false,
                key: "YEARLY_GOAL",
            },
        ];
        this.typologies = [
            {
                name: this.translate.instant("goal_page.typology_distance"),
                isSelect: true,
                key: "DISTANCE",
            },
            {
                name: this.translate.instant("goal_page.typology_time"),
                isSelect: false,
                key: "DURATION",
            },
            {
                name: this.translate.instant("goal_page.typology_drop"),
                isSelect: false,
                key: "ELEVATION",
            },
        ];
        this.isTimeTypologySelected = false;
        this.isDistanceTypologySelected = true;
        this.isElevationTypologySelected = false;
        this.hoursPlaceholder = "0 h";
        this.minutesPlaceholder = "0 m";
        this.distancePlaceholder = "0 m";
        this.elevationPlaceholder = "0 m";
        this.displayDistanceELevationValue = "";
        this.rawValue = "";
        this.rawHoursValue = "";
        this.rawMinutesValue = "";
        this.displayHoursValue = "";
        this.displayMinutesValue = "";
        this.selectedTags = [];
        this.macroTypologies = [];
        this.subtypologiesMOTO = [];
        this.subtypologiesMTB = [];
        this.subtypologiesROAD = [];
        this.subtypologiesFOOT = [];
        this.showSubcategoryFakeAlert = false;
        this.categoryTypologies = [];
        this.creatingGoal = false;
        this.goalCreatedSuccess = false;
        this.inputFired = false;
        this.formInputsGroup = this.formBuilder.group({
            distanceElevation: [""],
            hours: [""],
            minutes: [""],
        });
    }
    GoalPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        var dataEle = this.convertMetrics.convertElevationInCurrentSystemMetrics(0);
        this.elevationPlaceholder = dataEle.value + " " + dataEle.uom;
        var dataDist = this.convertMetrics.getDisplayHorizontalLongArray(0);
        this.distancePlaceholder = dataDist[0] + " " + dataDist[1];
        this.macroTypologies = this.categoryProvider.getMacroCategories();
        this.subtypologiesMOTO = this.categoryProvider.getMOTOCategory();
        this.subtypologiesMTB = this.categoryProvider.getMTBCategory();
        this.subtypologiesROAD = this.categoryProvider.getROADCategory();
        this.subtypologiesFOOT = this.categoryProvider.getFOOTCategory();
        this.goalToEdit = this.navParams.get("goalToEdit");
        if (this.goalToEdit) {
            setTimeout(function () {
                _this.flagTypologiesSelected();
                switch (_this.goalToEdit.goalDurationType) {
                    case "MONTHLY_GOAL":
                        _this.regularities[0].isSelect = false;
                        _this.regularities[1].isSelect = true;
                        break;
                    case "YEARLY_GOAL":
                        _this.regularities[0].isSelect = false;
                        _this.regularities[2].isSelect = true;
                        break;
                }
                if (_this.goalToEdit.goalType === "DURATION") {
                    _this.typologies[0].isSelect = false;
                    _this.typologies[2].isSelect = true;
                    var hoursVal = _this.goalToEdit.displayGoalTarget.indexOf("h");
                    if (hoursVal) {
                        var hoursStringVal = _this.goalToEdit.displayGoalTarget.substring(0, _this.goalToEdit.displayGoalTarget.indexOf("h") + 1);
                        _this.rawHoursValue = hoursStringVal.substring(0, hoursStringVal.indexOf(" "));
                        _this.displayHoursValue = hoursStringVal;
                        _this.formInputsGroup.patchValue({ hours: _this.displayHoursValue });
                    }
                    if (_this.goalToEdit.displayGoalTarget.indexOf("m")) {
                        var minutesStringVal = void 0;
                        if (hoursVal) {
                            minutesStringVal = _this.goalToEdit.displayGoalTarget.substring(hoursVal + 1, _this.goalToEdit.displayGoalTarget.length);
                        }
                        else {
                            minutesStringVal = _this.goalToEdit.displayGoalTarget;
                        }
                        _this.rawMinutesValue = minutesStringVal.substring(0, minutesStringVal.indexOf(" "));
                        _this.displayMinutesValue = minutesStringVal;
                        _this.formInputsGroup.patchValue({
                            minutes: _this.displayHoursValue,
                        });
                    }
                }
                else {
                    if (_this.goalToEdit.goalType === "ELEVATION") {
                        _this.typologies[0].isSelect = false;
                        _this.typologies[2].isSelect = true;
                        _this.isDistanceTypologySelected = false;
                        _this.isElevationTypologySelected = true;
                    }
                    _this.rawValue = _this.goalToEdit.displayGoalTarget.substring(0, _this.goalToEdit.displayGoalTarget.indexOf(" "));
                    _this.displayDistanceELevationValue = _this.goalToEdit.displayGoalTarget;
                    _this.formInputsGroup.patchValue({
                        distanceElevation: _this.displayDistanceELevationValue,
                    });
                }
            }, 1000);
        }
    };
    GoalPage.prototype.closeModal = function () {
        this.viewCtrl.dismiss();
    };
    GoalPage.prototype.showCategoryTypologies = function (typology) {
        this.currentMacroTypologySelected = typology;
        if (typology.tags.includes("moto")) {
            this.categoryTypologies = this.subtypologiesMOTO;
        }
        else if (typology.tags.includes("mtb")) {
            this.categoryTypologies = this.subtypologiesMTB;
        }
        else if (typology.tags.includes("road")) {
            this.categoryTypologies = this.subtypologiesROAD;
        }
        else if (typology.tags.includes("foot")) {
            this.categoryTypologies = this.subtypologiesFOOT;
        }
        this.showSubcategoryFakeAlert = true;
    };
    GoalPage.prototype.onSelectTypo = function (typo) {
        if (typo.is_select) {
            typo.is_select = false;
        }
        else {
            typo.is_select = true;
        }
    };
    GoalPage.prototype.selectTypologies = function () {
        var generalStatus = [];
        this.currentMacroTypologySelected.is_select = true;
        var _loop_1 = function (i) {
            var typology = this_1.categoryTypologies[i];
            generalStatus.push(typology.is_select);
            if (typology.is_select) {
                var sameTags = this_1.selectedTags.find(function (_item) {
                    return _item.id === typology.id;
                });
                if (!sameTags) {
                    this_1.selectedTags.push({ tags: typology.tags, id: typology.id });
                }
            }
            else {
                var sameTagsIndex = this_1.selectedTags.findIndex(function (_item) {
                    return _item.id === typology.id;
                });
                if (sameTagsIndex >= 0) {
                    this_1.selectedTags.splice(sameTagsIndex, 1);
                    i--;
                }
            }
            out_i_1 = i;
        };
        var this_1 = this, out_i_1;
        for (var i = 0; i < this.categoryTypologies.length; i++) {
            _loop_1(i);
            i = out_i_1;
        }
        this.closeSubcategoriesFakeAlert();
        if (generalStatus.every(function (currentStatus) { return !currentStatus; })) {
            this.currentMacroTypologySelected.is_select = false;
        }
        else {
            this.currentMacroTypologySelected.is_select = true;
        }
    };
    GoalPage.prototype.closeSubcategoriesFakeAlert = function () {
        this.showSubcategoryFakeAlert = false;
        if (!this.currentMacroTypologySelected.is_select) {
            for (var _i = 0, _a = this.categoryTypologies; _i < _a.length; _i++) {
                var typology = _a[_i];
                typology.is_select = false;
            }
        }
        this.categoryTypologies = [];
    };
    GoalPage.prototype.selectRegularutyBox = function (index) {
        if (!this.regularities[index].isSelect) {
            for (var _i = 0, _a = this.regularities; _i < _a.length; _i++) {
                var type = _a[_i];
                type.isSelect = false;
            }
            this.regularities[index].isSelect = true;
        }
    };
    GoalPage.prototype.selectTypologyBox = function (index) {
        if (!this.typologies[index].isSelect) {
            for (var _i = 0, _a = this.typologies; _i < _a.length; _i++) {
                var type = _a[_i];
                type.isSelect = false;
            }
            this.typologies[index].isSelect = true;
            if (this.typologies[index].key === "DURATION") {
                this.isTimeTypologySelected = true;
                this.isDistanceTypologySelected = false;
                this.isElevationTypologySelected = false;
            }
            else {
                this.isTimeTypologySelected = false;
                if (this.typologies[index].key === "DISTANCE") {
                    this.isDistanceTypologySelected = true;
                    this.isElevationTypologySelected = false;
                }
                if (this.typologies[index].key === "ELEVATION") {
                    this.isElevationTypologySelected = true;
                    this.isDistanceTypologySelected = false;
                }
            }
            this.formInputsGroup.setValue({
                distanceElevation: "",
                hours: "",
                minutes: "",
            });
            this.displayDistanceELevationValue = "";
            this.displayHoursValue = "";
            this.displayMinutesValue = "";
            this.rawValue = "";
            this.rawHoursValue = "";
            this.rawMinutesValue = "";
        }
    };
    GoalPage.prototype.numberOnlyValidation = function (event, target) {
        var _this = this;
        if (!this.inputFired) {
            this.inputFired = true;
            this.logger.debug("numberOnlyValidation", event, target);
            var valueRecentlyAdded = "";
            if (!event.data) {
                valueRecentlyAdded = "backspace";
            }
            else if (event.data.length === 1) {
                valueRecentlyAdded = event.data;
            }
            else if (event.data.length > 1) {
                valueRecentlyAdded = event.data.slice(0, -1);
            }
            if (valueRecentlyAdded.match(/[0-9]*/)[0].length) {
                if (target === "hours") {
                    if (this.displayHoursValue.length < 6) {
                        if (this.rawHoursValue) {
                            this.rawHoursValue += valueRecentlyAdded;
                        }
                        else {
                            this.rawHoursValue = valueRecentlyAdded;
                        }
                        this.displayHoursValue = this.rawHoursValue + " h";
                        this.formInputsGroup.patchValue({ hours: this.displayHoursValue });
                    }
                    else {
                        this.handleLettersOrNumbers(target);
                    }
                }
                else if (target === "minutes") {
                    if (this.displayMinutesValue.length < 4) {
                        if (this.rawMinutesValue) {
                            this.rawMinutesValue += valueRecentlyAdded;
                        }
                        else {
                            this.rawMinutesValue = valueRecentlyAdded;
                        }
                        this.displayMinutesValue = this.rawMinutesValue + " m";
                        this.formInputsGroup.patchValue({
                            minutes: this.displayMinutesValue,
                        });
                    }
                    else {
                        this.handleLettersOrNumbers(target);
                    }
                }
                else if (target === "distance") {
                    if (this.displayDistanceELevationValue.length < 12) {
                        if (this.rawValue) {
                            this.rawValue += valueRecentlyAdded;
                        }
                        else {
                            this.rawValue = valueRecentlyAdded;
                        }
                        if (this.isDistanceTypologySelected) {
                            var data = this.convertMetrics.getDisplayHorizontalLongArray(parseInt(this.rawValue));
                            this.displayDistanceELevationValue = data[0] + " " + data[1];
                        }
                        else {
                            var data = this.convertMetrics.convertElevationInCurrentSystemMetrics(parseInt(this.rawValue));
                            this.displayDistanceELevationValue = data.value + " " + data.uom;
                        }
                        this.formInputsGroup.patchValue({
                            distanceElevation: this.displayDistanceELevationValue,
                        });
                    }
                    else {
                        this.handleLettersOrNumbers(target);
                    }
                }
            }
            else if (valueRecentlyAdded === "backspace") {
                if (target === "hours") {
                    if (this.displayHoursValue.length === 3) {
                        this.displayHoursValue = "";
                        this.rawHoursValue = "";
                        this.formInputsGroup.patchValue({ hours: "" });
                    }
                    else if (this.rawHoursValue) {
                        this.rawHoursValue = this.rawHoursValue.slice(0, -1);
                        this.displayHoursValue = this.rawHoursValue + " h";
                        this.formInputsGroup.patchValue({ hours: this.displayHoursValue });
                    }
                }
                else if (target === "minutes") {
                    if (this.displayMinutesValue.length === 3) {
                        this.displayMinutesValue = "";
                        this.rawMinutesValue = "";
                        this.formInputsGroup.patchValue({ minutes: "" });
                    }
                    else if (this.rawMinutesValue) {
                        this.rawMinutesValue = this.rawMinutesValue.slice(0, -1);
                        this.displayMinutesValue = this.rawMinutesValue + " m";
                        this.formInputsGroup.patchValue({
                            minutes: this.displayMinutesValue,
                        });
                    }
                }
                else if (target === "distance") {
                    if (this.displayDistanceELevationValue.length === 3) {
                        this.displayDistanceELevationValue = "";
                        this.rawValue = "";
                        this.formInputsGroup.patchValue({ distanceElevation: "" });
                    }
                    else if (this.rawValue) {
                        this.rawValue = this.rawValue.slice(0, -1);
                        if (this.isDistanceTypologySelected) {
                            var data = this.convertMetrics.getDisplayHorizontalLongArray(parseInt(this.rawValue));
                            this.displayDistanceELevationValue = data[0] + " " + data[1];
                        }
                        else {
                            var data = this.convertMetrics.convertElevationInCurrentSystemMetrics(parseInt(this.rawValue));
                            this.displayDistanceELevationValue = data.value + " " + data.uom;
                        }
                        this.formInputsGroup.patchValue({
                            distanceElevation: this.displayDistanceELevationValue,
                        });
                    }
                }
            }
            else {
                this.handleLettersOrNumbers(target);
            }
            // this hack serves as workaround because (input) event is fired twice
            setTimeout(function () {
                _this.inputFired = false;
            }, 50);
        }
    };
    GoalPage.prototype.handleLettersOrNumbers = function (target) {
        if (target === "hours") {
            var formatVal = this.formInputsGroup.get("hours").value;
            var tempVal = this.checkIfLastCharIsLetter(formatVal);
            if (!tempVal) {
                formatVal = this.checkIfLastCharIsNumber(formatVal);
            }
            else {
                formatVal = tempVal;
            }
            this.displayHoursValue = formatVal ? formatVal : "";
            this.formInputsGroup.patchValue({ hours: this.displayHoursValue });
        }
        else if (target === "minutes") {
            var formatVal = this.formInputsGroup.get("minutes").value;
            var tempVal = this.checkIfLastCharIsLetter(formatVal);
            if (!tempVal) {
                formatVal = this.checkIfLastCharIsNumber(formatVal);
            }
            else {
                formatVal = tempVal;
            }
            this.displayMinutesValue = formatVal ? formatVal : "";
            this.formInputsGroup.patchValue({ minutes: this.displayMinutesValue });
        }
        else if (target === "distance") {
            var formatVal = this.formInputsGroup.get("distanceElevation").value;
            var tempVal = this.checkIfLastCharIsLetter(formatVal);
            if (!tempVal) {
                formatVal = this.checkIfLastCharIsNumber(formatVal);
            }
            else {
                formatVal = tempVal;
            }
            this.displayDistanceELevationValue = formatVal ? formatVal : "";
            this.formInputsGroup.patchValue({
                distanceElevation: this.displayDistanceELevationValue,
            });
        }
    };
    GoalPage.prototype.checkIfLastCharIsNumber = function (val) {
        var lastChar = val.charAt(val.length - 1);
        if (!isNaN(parseInt(lastChar))) {
            return val.slice(0, -1);
        }
        return false;
    };
    GoalPage.prototype.checkIfLastCharIsLetter = function (val) {
        var lastChar = val.charAt(val.length - 1);
        if (isNaN(parseInt(lastChar))) {
            return val.slice(0, -1);
        }
        return false;
    };
    GoalPage.prototype.createTheGoal = function () {
        var _this = this;
        var goalTargetUnit, goalTarget, goalDurationType, goalType;
        var rawMinutesInMilli = 0;
        var rawHoursInMilli = 0;
        var totalInSeconds = 0;
        var totalInMeters = 0;
        var regularityFound = this.regularities.find(function (_item) { return _item.isSelect; });
        var typologyFound = this.typologies.find(function (_item) { return _item.isSelect; });
        if (!this.selectedTags.length) {
            this.showToastError("goal_page.select_one_typology");
            return;
        }
        if (typologyFound.key === "DURATION") {
            if (!this.displayHoursValue && !this.displayMinutesValue) {
                this.showToastError("goal_page.insert_a_valid_value");
                return;
            }
            goalTargetUnit = "SECONDS";
            if (this.displayMinutesValue) {
                rawMinutesInMilli = parseInt(this.displayMinutesValue) * 60000;
            }
            if (this.displayHoursValue) {
                rawHoursInMilli = parseInt(this.displayMinutesValue) * 3600000;
            }
            totalInSeconds = (rawHoursInMilli + rawMinutesInMilli) / 1000;
            goalTarget = totalInSeconds;
        }
        else {
            if (!this.displayDistanceELevationValue.length) {
                this.showToastError("goal_page.insert_a_valid_value");
                return;
            }
            goalTargetUnit = "METERS";
            totalInMeters = parseInt(this.rawValue);
            if (this.displayDistanceELevationValue.includes("mi")) {
                totalInMeters = Math.round(parseInt(this.displayDistanceELevationValue) /
                    this.convertMetrics.getMilesMultiply());
            }
            else if (this.displayDistanceELevationValue.includes("ft")) {
                totalInMeters = Math.round(parseInt(this.displayDistanceELevationValue) /
                    this.convertMetrics.getFeetMultiply());
            }
            goalTarget = totalInMeters;
        }
        this.creatingGoal = true;
        var categoryTypologies = [];
        for (var _i = 0, _a = this.selectedTags; _i < _a.length; _i++) {
            var item = _a[_i];
            categoryTypologies.push(item.tags);
        }
        goalDurationType = regularityFound.key;
        goalType = typologyFound.key;
        this.logger.debug("data to send to create a goal", categoryTypologies, goalTargetUnit, goalTarget, goalDurationType, goalType);
        if (this.goalToEdit) {
            this.userSocialProvider
                .editAGoal(this.goalToEdit.id, categoryTypologies, goalTargetUnit, goalTarget, goalDurationType, goalType)
                .then(function (succ) {
                var toast = _this.toastCtrl.create({
                    message: _this.translate.instant("goal_page.goal_modify_success"),
                    duration: 3000,
                    position: "top",
                    showCloseButton: true,
                });
                toast.present().then(function () { return _this.viewCtrl.dismiss({ editGoal: true }); });
                _this.creatingGoal = false;
            })
                .catch(function (error) { return (_this.creatingGoal = false); });
        }
        else {
            this.userSocialProvider
                .setAGoal(categoryTypologies, goalTargetUnit, goalTarget, goalDurationType, goalType)
                .then(function (succ) {
                var toast = _this.toastCtrl.create({
                    message: _this.translate.instant("goal_page.create_goal_success"),
                    duration: 3000,
                    position: "top",
                    showCloseButton: true,
                });
                toast.present().then(function () { return _this.viewCtrl.dismiss(); });
                _this.creatingGoal = false;
            })
                .catch(function (error) { return (_this.creatingGoal = false); });
        }
    };
    GoalPage.prototype.showToastError = function (textToShow) {
        var toast = this.toastCtrl.create({
            message: this.translate.instant(textToShow),
            duration: 3000,
            position: "top",
            cssClass: "error",
            showCloseButton: true,
        });
        toast.present();
    };
    GoalPage.prototype.flagTypologiesSelected = function () {
        var _loop_2 = function (typology) {
            if (typology.includes("moto")) {
                this_2.macroTypologies[1].is_select = true;
                var typologyFound = this_2.subtypologiesMOTO.find(function (_item) {
                    return (_item.tags.includes(typology[0]) && _item.tags.includes(typology[1]));
                });
                if (typologyFound) {
                    typologyFound.is_select = true;
                    this_2.selectedTags.push({ tags: typology, id: typologyFound.id });
                }
            }
            if (typology.includes("mtb")) {
                this_2.macroTypologies[0].is_select = true;
                var typologyFound = this_2.subtypologiesMTB.find(function (_item) {
                    return (_item.tags.includes(typology[0]) && _item.tags.includes(typology[1]));
                });
                if (typologyFound) {
                    typologyFound.is_select = true;
                    this_2.selectedTags.push({ tags: typology, id: typologyFound.id });
                }
            }
            if (typology.includes("road")) {
                this_2.macroTypologies[2].is_select = true;
                var typologyFound = this_2.subtypologiesROAD.find(function (_item) {
                    return (_item.tags.includes(typology[0]) && _item.tags.includes(typology[1]));
                });
                if (typologyFound) {
                    typologyFound.is_select = true;
                    this_2.selectedTags.push({ tags: typology, id: typologyFound.id });
                }
            }
        };
        var this_2 = this;
        for (var _i = 0, _a = this.goalToEdit.tags; _i < _a.length; _i++) {
            var typology = _a[_i];
            _loop_2(typology);
        }
    };
    GoalPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-goal",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/goal/goal.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-title>{{ \'goal_page.title\' | translate }}</ion-title>\n    <ion-buttons end>\n      <button ion-button clear (click)="closeModal()">\n        {{ \'close_button_text\' | translate }}\n      </button>\n    </ion-buttons>\n  </ion-navbar>\n</ion-header>\n\n<ion-content>\n  <div ion-fixed class="fake-alert-container" [ngClass]="{\'show-container\': showSubcategoryFakeAlert}">\n    <a (click)="closeSubcategoriesFakeAlert()" class="close-container"></a>\n\n    <div class="alert-container" [ngClass]="{\'show-container\': showSubcategoryFakeAlert}">\n      <div class="title-container">\n        <p>{{\'save_route_page.fake_alert_title\' | translate}}</p>\n      </div>\n      <div class="subtypologies-container">\n        <div class="container" *ngFor="let typology of categoryTypologies;">\n          <a (click)="onSelectTypo(typology)">\n            <div class="icon-container" [style.background-color]="typology.color" [ngClass]="{\'category-selected\': typology.is_select}">\n              <span class="icon" [ngClass]="typology.icon"></span>\n              <span class="icon-whip-checkmark checkmark" *ngIf="typology.is_select"></span>\n            </div>\n            <div class="text-container"><span>{{typology.name}}</span></div>\n          </a>\n        </div>\n      </div>\n      <div class="button-container">\n        <button ion-button clear (click)="selectTypologies()">{{\'save_route_page.select_typologies_button_text\' | translate}}</button>\n      </div>\n    </div>\n  </div>\n\n  <div class="categories-container">\n    <h6 class="title">{{ \'goal_page.sport\' | translate }}</h6>\n    <div class="macro-typology-container">\n      <div class="container" *ngFor="let typology of macroTypologies;">\n        <a (click)="showCategoryTypologies(typology)">\n          <div class="icon-container" [ngClass]="{\'typology-selected\': typology.is_select}" [ngStyle]="{\'background-color\': typology.color}">\n            <span class="icon" [ngClass]="typology.icon"></span>\n            <span class="icon-whip-checkmark checkmark" *ngIf="typology.is_select"></span>\n          </div>\n          <div class="text-container"><span>{{typology.name}}</span></div>\n        </a>\n      </div>\n    </div>\n  </div>\n\n  <div class="regularity-container">\n    <h6 class="title">{{ \'goal_page.regularity\' | translate }}</h6>\n    <div class="boxes-container">\n      <div *ngFor="let type of regularities; index as i;" [ngClass]="{ \'selected\': type.isSelect }" class="box">\n        <a (click)="selectRegularutyBox(i)">\n          <p>{{ type.name }}</p>\n        </a>\n      </div>\n    </div>\n  </div>\n\n  <div class="typology-container">\n    <h6 class="title">{{ \'goal_page.typology\' | translate }}</h6>\n    <div class="boxes-container">\n      <div *ngFor="let type of typologies; index as i;" [ngClass]="{ \'selected\': type.isSelect }" class="box">\n        <a (click)="selectTypologyBox(i)">\n          <p>{{ type.name }}</p>\n        </a>\n      </div>\n    </div>\n\n    <form class="form" [formGroup]="formInputsGroup" (ngSubmit)="createTheGoal()">\n      <div class="distance-elevation-container" *ngIf="!isTimeTypologySelected">\n        <ion-item>\n          <ion-input (input)="numberOnlyValidation($event, \'distance\')" [placeholder]="distancePlaceholder" formControlName="distanceElevation" type="text" inputmode="decimal"></ion-input>\n        </ion-item>\n      </div>\n  \n      <div class="time-inputs-container" *ngIf="isTimeTypologySelected">\n        <ion-item class="input-number">\n          <ion-input (input)="numberOnlyValidation($event, \'hours\')" [placeholder]="hoursPlaceholder" formControlName="hours" type="text" inputmode="decimal"></ion-input>\n        </ion-item>\n        <ion-item class="input-number">\n          <ion-input (input)="numberOnlyValidation($event, \'minutes\')" [placeholder]="minutesPlaceholder" formControlName="minutes" type="text" inputmode="decimal"></ion-input>\n        </ion-item>\n      </div>\n    </form>\n  </div>\n</ion-content>\n\n<ion-footer>\n  <ion-toolbar>\n    <div class="button-container">\n      <button ion-button block (click)="createTheGoal()" [disabled]="creatingGoal">\n        <span *ngIf="!creatingGoal">{{ \'goal_page.save_the_goal\' | translate }}</span>\n        <ion-spinner *ngIf="creatingGoal"></ion-spinner>\n      </button>\n    </div>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/goal/goal.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_user_social_user_social__["a" /* UserSocialProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["z" /* ToastController */],
            __WEBPACK_IMPORTED_MODULE_4__providers_category_category__["a" /* CategoryProvider */],
            __WEBPACK_IMPORTED_MODULE_3__angular_forms__["a" /* FormBuilder */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["q" /* NavParams */]])
    ], GoalPage);
    return GoalPage;
}());

//# sourceMappingURL=goal.js.map

/***/ })

});
//# sourceMappingURL=92.js.map