webpackJsonp([94],{

/***/ 1142:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GarminSyncPageModule", function() { return GarminSyncPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__garmin_sync__ = __webpack_require__(1473);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var GarminSyncPageModule = /** @class */ (function () {
    function GarminSyncPageModule() {
    }
    GarminSyncPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__garmin_sync__["a" /* GarminSyncPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__garmin_sync__["a" /* GarminSyncPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */]
            ],
        })
    ], GarminSyncPageModule);
    return GarminSyncPageModule;
}());

//# sourceMappingURL=garmin-sync.module.js.map

/***/ }),

/***/ 1473:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GarminSyncPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_social_login_social_login__ = __webpack_require__(598);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_internal_url_resolver_url_resolver__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_on_boarding_on_boarding__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_analytics_analytics__ = __webpack_require__(50);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











var GarminSyncPage = /** @class */ (function () {
    function GarminSyncPage(socialLogin, navCtrl, navParams, translate, auth, http, url, alertCtrl, logger, onBoardingProvider, metrics, analyticsProvider) {
        this.socialLogin = socialLogin;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.translate = translate;
        this.auth = auth;
        this.http = http;
        this.url = url;
        this.alertCtrl = alertCtrl;
        this.logger = logger;
        this.onBoardingProvider = onBoardingProvider;
        this.metrics = metrics;
        this.analyticsProvider = analyticsProvider;
        this.stravaSyncProcessing = false;
        this.isLoading = true;
        this.isError = false;
        this.isStravaLogged = false;
        this.showAllActivitiesToSync = false;
        this.canSelectAll = false;
        this.stravaActivitiesToSync = [];
        this.activitiesToSyncNr = 0;
        this.stravaUser = {};
        this.lastReloadPageTime = 0;
        this.isInOnboarding = false;
        this.hasNextOnboarding = false;
        this.hasPrevOnboarding = false;
    }
    GarminSyncPage.prototype.ionViewWillEnter = function () {
        this.logger.debug("ionViewWillEnter GarminSynchPage", this.isInOnboarding);
        this._checkPageRefresh();
        this.isInOnboarding = this.onBoardingProvider.isInOnboardingProcess();
        this.hasNextOnboarding = this.onBoardingProvider.hasNextOnboarding();
        this.hasPrevOnboarding = this.onBoardingProvider.hasPrevOnboarding();
    };
    GarminSyncPage.prototype._checkPageRefresh = function () {
        var now = new Date().getTime();
        if ((now - this.lastReloadPageTime) > (10 * 60 * 1000)) {
            this.initPage();
        }
        this.lastReloadPageTime = new Date().getTime();
    };
    GarminSyncPage.prototype.goToNext = function () {
        this.onBoardingProvider.goToNext();
    };
    GarminSyncPage.prototype.goToPrev = function () {
        this.onBoardingProvider.goToPrev();
    };
    GarminSyncPage.prototype.initPage = function () {
        var _this = this;
        this.isLoading = true;
        this.isError = false;
        this.socialLogin.getGarminAccessToken(false).then(function (garminData) {
            _this.logger.debug("garmin data retrieved", garminData);
            _this.isStravaLogged = true;
            _this.stravaUser.id = garminData.id;
            _this._getGarminActivities();
        }).catch(function (error) {
            _this.logger.debug("error to get garmin token", error);
            _this.isStravaLogged = false;
            _this.isLoading = false;
        });
    };
    GarminSyncPage.prototype._getGarminActivities = function () {
        var _this = this;
        this.analyticsProvider.trackEventMixpanel("Open Garmin page - user logged");
        var token = this.auth.getToken();
        this.stravaActivitiesToSync = [];
        this.http.get(this.url.getGeoV3EndPoint() + "/ext/garmin/activities?prevent-error-shown=true", {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["g" /* HttpHeaders */]().set('Authorization', 'JWT ' + token)
        }).subscribe(function (response) {
            for (var _i = 0, response_1 = response; _i < response_1.length; _i++) {
                var activity = response_1[_i];
                if (activity.activityExternalId) {
                    activity.canOpenActivity = true;
                }
                if (!activity.name) {
                    activity.name = " - ";
                }
                activity.isSynced = true;
                activity.isSelected = false;
                activity.activityStartDate = _this.metrics.getMomentFullDate(new Date(activity.date).getTime());
                activity.duration = _this.metrics.getDisplayTime(activity.duration, false);
                activity.meters = _this.metrics.getDisplayHorizontalLong(activity.meters);
                _this.stravaActivitiesToSync.push(activity);
            }
            _this.isLoading = false;
        }, function (error) {
            if (error && error.status >= 400 && error.status < 500) {
                _this.socialLogin.cleanGarminAccessToken();
                _this.alertCtrl.create({
                    title: _this.translate.instant("garmin_sync_page.error_permission"),
                    subTitle: _this.translate.instant("garmin_sync_page.error_permission_description"),
                    enableBackdropDismiss: false,
                    buttons: [
                        {
                            text: "Ok",
                            role: 'cancel'
                        }
                    ]
                }).present();
                _this.isStravaLogged = false;
                _this.isError = false;
            }
            else {
                _this.isError = true;
            }
            _this.isLoading = false;
        });
    };
    GarminSyncPage.prototype.changeGarminUser = function () {
        var _this = this;
        this.alertCtrl.create({
            title: this.translate.instant("garmin_sync_page.remove_user"),
            subTitle: this.translate.instant("garmin_sync_page.remove_user_description"),
            enableBackdropDismiss: false,
            buttons: [
                {
                    text: this.translate.instant('garmin_sync_page.proceed'),
                    handler: function () {
                        var token = _this.auth.getToken();
                        _this.socialLogin.cleanGarminAccessToken();
                        _this.isLoading = true;
                        _this.http.post(_this.url.getGeoV3EndPoint() + "/ext/garmin/user/remove", {}, {
                            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["g" /* HttpHeaders */]().set('Authorization', 'JWT ' + token)
                        }).subscribe(function (response) {
                            _this.isStravaLogged = false;
                            _this.stravaActivitiesToSync = [];
                            _this.isLoading = false;
                        }, function (error) {
                            _this.isLoading = false;
                        });
                    }
                },
                {
                    text: this.translate.instant('garmin_sync_page.cancel'),
                    role: 'cancel'
                }
            ]
        }).present();
    };
    GarminSyncPage.prototype.onChangeActivity = function (activity) {
        this.logger.debug("onChangeActivity");
        this.goToActivity(activity.id);
    };
    GarminSyncPage.prototype.goToActivity = function (activityId) {
        this.navCtrl.push('ActivityPage', { currentActivity: { id: activityId } });
    };
    GarminSyncPage.prototype.goGarminLogin = function () {
        var _this = this;
        this.stravaSyncProcessing = true;
        this.socialLogin.getGarminAccessToken(true).then(function (garminToken) {
            _this.logger.debug("garmin token retrieved", garminToken);
            _this.stravaSyncProcessing = false;
            _this.isStravaLogged = true;
            _this.isLoading = true;
            _this._getGarminActivities();
        }).catch(function (error) {
            _this.logger.debug("error to get strava token", error);
            _this.stravaSyncProcessing = false;
            _this.isStravaLogged = false;
        });
    };
    GarminSyncPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-garmin-sync',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/garmin-sync/garmin-sync.html"*/'<ion-header>\n\n  <ion-navbar class="ios-fix-padding">\n\n    <ion-title>{{\'garmin_sync_page.info\' | translate}}</ion-title>\n\n    <ion-buttons *ngIf="isInOnboarding && hasNextOnboarding" end>\n      <button ion-button (click)="goToNext()">{{\'onboarding.next\' | translate}}</button>\n    </ion-buttons>\n    <ion-buttons *ngIf="isInOnboarding && !hasNextOnboarding" end>\n      <button ion-button (click)="goToNext()">{{\'onboarding.done\' | translate}}</button>\n    </ion-buttons>\n  </ion-navbar>\n\n</ion-header>\n\n<ion-content padding [ngClass]="{\'no-footer\': isStravaLogged}">\n\n  <div ion-fixed  *ngIf="isLoading" class="loading-container">\n    <ion-spinner></ion-spinner>\n  </div>\n\n  <div ion-fixed class="retry-container" *ngIf="isError">\n    <help-no-internet [button]="true" (refreshActivity)="initPage()"></help-no-internet>\n  </div>\n\n  <div class="transfer-data-container-image" *ngIf="isStravaLogged == false && !isLoading">\n    \n    <div class="strava-text">\n      \n      <p>{{"garmin_sync_page.info_text" | translate}}</p>\n    </div>\n    <div class="strava-image-container">\n      <div class="strava-image"></div>\n    </div>\n  </div>\n\n  <div class="scroll-container">\n    \n    <div class="strava-user" *ngIf="stravaUser.id">\n      <div class="strava-user-name">\n        <div class="strava-user-more">\n          {{"garmin_sync_page.garmin_connect_text" | translate}} <br>\n          <button end (click)="changeGarminUser()">{{"garmin_sync_page.log_out" | translate}}</button></div>\n      </div>\n      \n    </div>\n\n    <ion-list *ngIf="stravaActivitiesToSync.length" class="full-size">\n      <ion-item class="strava-activity activity-done" *ngFor="let activity of stravaActivitiesToSync">\n        <ion-label>\n          <h3>{{activity.activityName}}</h3>\n          <p>{{activity.activityStartDate}} • {{activity.meters}} • {{activity.duration}} </p>\n          <ion-icon class="done-icon" ios="md-checkmark" md="md-checkmark"></ion-icon>\n          <ion-icon class="forward-icon" ios="ios-arrow-forward" md="ios-arrow-forward"></ion-icon>\n        </ion-label>\n        <ion-checkbox [(ngModel)]="activity.isSelected" color="primary" (ionChange)="onChangeActivity(activity)"></ion-checkbox>\n      </ion-item>\n    </ion-list>\n\n    <div class="no-activities" [ngClass]="{\'hidden\': isLoading || isError || !isStravaLogged}" *ngIf="stravaActivitiesToSync.length == 0">\n      <p>{{"garmin_sync_page.no_activities_sync_info" | translate}}</p>\n    </div>\n\n  </div>\n</ion-content>\n\n<ion-footer [ngClass]="{\'hidden\': isLoading || isError || isStravaLogged}">\n\n  <ion-toolbar *ngIf="isStravaLogged == false">\n    <button ion-button class="success-button big-text" [disabled]="stravaSyncProcessing" (click)="goGarminLogin()">\n      <span>{{"garmin_sync_page.log_in" | translate}}</span>&nbsp;&nbsp;<ion-spinner *ngIf="stravaSyncProcessing"></ion-spinner>\n    </button>\n  </ion-toolbar>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/garmin-sync/garmin-sync.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_social_login_social_login__["a" /* SocialLoginProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_6__providers_internal_url_resolver_url_resolver__["a" /* UrlResolverProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_on_boarding_on_boarding__["a" /* OnBoardingProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_analytics_analytics__["a" /* AnalyticsProvider */]])
    ], GarminSyncPage);
    return GarminSyncPage;
}());

//# sourceMappingURL=garmin-sync.js.map

/***/ })

});
//# sourceMappingURL=94.js.map