webpackJsonp([110],{

/***/ 1125:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EnduSyncPageModule", function() { return EnduSyncPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__endu_sync__ = __webpack_require__(1456);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var EnduSyncPageModule = /** @class */ (function () {
    function EnduSyncPageModule() {
    }
    EnduSyncPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__endu_sync__["a" /* EnduSyncPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__endu_sync__["a" /* EnduSyncPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */]
            ],
        })
    ], EnduSyncPageModule);
    return EnduSyncPageModule;
}());

//# sourceMappingURL=endu-sync.module.js.map

/***/ }),

/***/ 1456:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnduSyncPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_endu_endu__ = __webpack_require__(604);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_internal_url_resolver_url_resolver__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_on_boarding_on_boarding__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_analytics_analytics__ = __webpack_require__(50);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











var EnduSyncPage = /** @class */ (function () {
    function EnduSyncPage(enduProvider, navCtrl, navParams, translate, auth, http, url, viewCtrl, alertCtrl, logger, onBoardingProvider, metrics, analyticsProvider) {
        this.enduProvider = enduProvider;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.translate = translate;
        this.auth = auth;
        this.http = http;
        this.url = url;
        this.viewCtrl = viewCtrl;
        this.alertCtrl = alertCtrl;
        this.logger = logger;
        this.onBoardingProvider = onBoardingProvider;
        this.metrics = metrics;
        this.analyticsProvider = analyticsProvider;
        this.isLoading = true;
        this.isError = false;
        this.isEnduLogged = false;
        this.lastReloadPageTime = 0;
        this.enduUser = {};
        this.isInOnboarding = false;
        this.hasNextOnboarding = false;
        this.hasPrevOnboarding = false;
        this.forceOpenLogin = false;
        this.isModal = true;
    }
    EnduSyncPage.prototype.ionViewWillEnter = function () {
        this.logger.debug("ionViewWillEnter EnduSyncPage", this.isInOnboarding);
        var openLogin = this.navParams.data.openLogin || false;
        this.isModal = this.navParams.data.isModal || false;
        this.forceOpenLogin = openLogin;
        this._checkPageRefresh(openLogin);
        this.isInOnboarding = this.onBoardingProvider.isInOnboardingProcess();
        this.hasNextOnboarding = this.onBoardingProvider.hasNextOnboarding();
        this.hasPrevOnboarding = this.onBoardingProvider.hasPrevOnboarding();
    };
    EnduSyncPage.prototype._checkPageRefresh = function (openLogin) {
        var now = new Date().getTime();
        if ((now - this.lastReloadPageTime) > (10 * 60 * 1000)) {
            this.initPage(openLogin);
        }
        this.lastReloadPageTime = new Date().getTime();
    };
    EnduSyncPage.prototype.goToNext = function () {
        this.onBoardingProvider.goToNext();
    };
    EnduSyncPage.prototype.goToPrev = function () {
        this.onBoardingProvider.goToPrev();
    };
    EnduSyncPage.prototype.initPage = function (openLogin) {
        var _this = this;
        this.isLoading = true;
        this.isError = false;
        this.enduProvider.getEnduData(openLogin, function () {
            //on browser closed
            _this.isLoading = false;
            _this.isEnduLogged = false;
        }).then(function (enduData) {
            if (enduData) {
                _this.logger.debug("endu data retrieved", enduData);
                _this.isEnduLogged = true;
                _this.enduUser = enduData;
                _this.isLoading = false;
                if (_this.forceOpenLogin) {
                    _this.closeModal(true, enduData);
                }
                _this.forceOpenLogin = false;
            }
            else {
                _this.logger.debug("endu token null");
                _this.isEnduLogged = false;
                _this.isLoading = false;
                if (_this.forceOpenLogin) {
                    _this.closeModal(false);
                }
                _this.forceOpenLogin = false;
            }
        }).catch(function (error) { });
    };
    EnduSyncPage.prototype.ionViewDidLeave = function () {
        this.enduProvider.unsubscribeToRedirect();
    };
    EnduSyncPage.prototype.closeModal = function (logged, enduData) {
        this.enduProvider.unsubscribeToRedirect();
        this.viewCtrl.dismiss({ isAddedRoute: false, logged: logged, enduData: enduData });
    };
    EnduSyncPage.prototype.changeEnduUser = function () {
        var _this = this;
        this.alertCtrl.create({
            title: this.translate.instant("endu_sync_page.log_out"),
            subTitle: this.translate.instant("endu_sync_page.remove_user_description"),
            enableBackdropDismiss: true,
            buttons: [
                {
                    role: "destructive",
                    text: this.translate.instant('garmin_sync_page.proceed'),
                    handler: function () {
                        _this.isLoading = true;
                        _this.enduProvider.removeEnduData(_this.enduUser).then(function () {
                            _this.isEnduLogged = false;
                            _this.isLoading = false;
                        }).catch(function () {
                            _this.isLoading = false;
                        });
                    }
                }, {
                    text: this.translate.instant('garmin_sync_page.cancel'),
                    role: 'cancel'
                }
            ]
        }).present();
    };
    EnduSyncPage.prototype.goEnduLogin = function () {
        var _this = this;
        this.isLoading = true;
        this.enduProvider.getEnduData(true, function () {
            //on browser closed
            _this.isLoading = false;
            _this.isEnduLogged = false;
        }).then(function (enduData) {
            if (enduData) {
                _this.logger.debug("endu data retrieved", enduData);
                _this.isEnduLogged = true;
                _this.enduUser = enduData;
                _this.isLoading = false;
            }
            else {
                _this.logger.debug("endu token null");
                _this.isEnduLogged = false;
                _this.isLoading = false;
            }
        }).catch(function (error) { });
    };
    EnduSyncPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-endu-sync',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/endu-sync/endu-sync.html"*/'<ion-header>\n\n  <ion-navbar class="ios-fix-padding">\n\n    <ion-buttons class="close-button-container" end *ngIf="isModal">\n      <button ion-button (click)="closeModal()"><ion-icon name="md-close-circle"></ion-icon></button>\n    </ion-buttons>\n\n    <ion-title>{{\'endu_sync_page.info\' | translate}}</ion-title>\n\n    <ion-buttons *ngIf="isInOnboarding && hasNextOnboarding" end>\n      <button ion-button (click)="goToNext()">{{\'onboarding.next\' | translate}}</button>\n    </ion-buttons>\n    <ion-buttons *ngIf="isInOnboarding && !hasNextOnboarding" end>\n      <button ion-button (click)="goToNext()">{{\'onboarding.done\' | translate}}</button>\n    </ion-buttons>\n  </ion-navbar>\n\n</ion-header>\n\n<ion-content padding [ngClass]="{\'no-footer\': isEnduLogged}">\n\n  <div ion-fixed  *ngIf="isLoading" class="loading-container">\n    <ion-spinner></ion-spinner>\n  </div>\n\n  <div ion-fixed class="retry-container" *ngIf="isError">\n    <help-no-internet [button]="true" (refreshActivity)="initPage()"></help-no-internet>\n  </div>\n\n  <div class="transfer-data-container-image" *ngIf="isEnduLogged == false && !isLoading">\n    \n    <div class="strava-text">\n      \n      <p>{{"endu_sync_page.info_text" | translate}}</p>\n    </div>\n    <div class="strava-image-container">\n      <div class="strava-image"></div>\n    </div>\n  </div>\n  \n  <div class="strava-text" *ngIf="enduUser.id && isEnduLogged">\n    <p>{{"endu_sync_page.endu_text" | translate}}</p>\n  </div>\n\n  <div class="scroll-container">\n\n    <div class="strava-user" *ngIf="enduUser.id && isEnduLogged">\n      <div class="strava-user-avatar" [style.backgroundImage]="\'url(\' + enduUser.avatarUrl + \')\'"></div>\n      <div class="strava-user-name">\n        {{enduUser.firstName}}&nbsp;{{enduUser.lastName}}<br>\n        <small>{{enduUser.email}}</small><br>\n        <div class="strava-user-more">\n          {{ \'strava_sync_page.is_your_account\' | translate }} <button end (click)="changeEnduUser()">{{ \'endu_sync_page.log_out\' | translate }}</button></div>\n      </div>\n    </div>\n\n  </div>\n</ion-content>\n\n<ion-footer [ngClass]="{\'hidden\': isLoading || isError || isEnduLogged}">\n\n  <ion-toolbar *ngIf="isEnduLogged == false">\n    <button ion-button class="success-button big-text" (click)="goEnduLogin()">\n      <span>{{"endu_sync_page.log_in" | translate}}</span>\n    </button>\n  </ion-toolbar>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/endu-sync/endu-sync.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_endu_endu__["a" /* EnduProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_6__providers_internal_url_resolver_url_resolver__["a" /* UrlResolverProvider */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_on_boarding_on_boarding__["a" /* OnBoardingProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_analytics_analytics__["a" /* AnalyticsProvider */]])
    ], EnduSyncPage);
    return EnduSyncPage;
}());

//# sourceMappingURL=endu-sync.js.map

/***/ })

});
//# sourceMappingURL=110.js.map