webpackJsonp([30],{

/***/ 1232:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UserSegmentsPageModule", function() { return UserSegmentsPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user_segments__ = __webpack_require__(1608);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var UserSegmentsPageModule = /** @class */ (function () {
    function UserSegmentsPageModule() {
    }
    UserSegmentsPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__user_segments__["a" /* UserSegmentsPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__user_segments__["a" /* UserSegmentsPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
            ],
        })
    ], UserSegmentsPageModule);
    return UserSegmentsPageModule;
}());

//# sourceMappingURL=user-segments.module.js.map

/***/ }),

/***/ 1608:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserSegmentsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_storage__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_authentication_authentication__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_segment_segment__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_notification_notification__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var UserSegmentsPage = /** @class */ (function () {
    function UserSegmentsPage(navCtrl, navParams, auth, segmentProvider, metricsProvider, utils, viewCtrl, storage, events, notificationProvider) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.auth = auth;
        this.segmentProvider = segmentProvider;
        this.metricsProvider = metricsProvider;
        this.utils = utils;
        this.viewCtrl = viewCtrl;
        this.storage = storage;
        this.events = events;
        this.notificationProvider = notificationProvider;
        this.usersSegments = [];
        this.usersSegmentsError = false;
        this.segmentsWhereUserIsPassed = [];
        this.segmentsError = false;
        this.loaderUsersSegment = true;
        this.loadeSegmentsWhereUserPass = true;
        this.isModal = false;
        this.case = "";
        this.isFromFriendsRoutePage = false;
        this.refreshCurrentActivity = false;
    }
    UserSegmentsPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.isFromFriendsRoutePage = this.navParams.get("isFromFriendsRoutePage");
        var segmentsToSee = this.navParams.get("case");
        if (segmentsToSee) {
            this.case = segmentsToSee;
        }
        var masterSegment = this.navParams.get("masterSegment");
        if (masterSegment) {
            this.incomingNewSegment = masterSegment;
            this.storage.set("incoming_new_segments", this.incomingNewSegment);
        }
        else {
            this.storage.get("incoming_new_segments").then(function (val) {
                if (val) {
                    _this.incomingNewSegment = val;
                }
            });
        }
        var userId = this.auth.getDataUser().id;
        var friendId = this.navParams.get("friendUserId");
        if (friendId) {
            userId = friendId;
        }
        this.segmentsSideActive = "user";
        var isModal = this.navParams.get("isModal");
        if (isModal) {
            this.isModal = true;
        }
        if (this.case === "own") {
            this.getOwnSegments(userId);
            this.events.subscribe("refresh_users_segments", function () {
                _this.getOwnSegments(_this.auth.getDataUser().id);
                _this.incomingNewSegment = null;
                _this.refreshCurrentActivity = true;
            });
        }
        else {
            var params = { limit: 100 };
            if (this.case === 'uphill') {
                params.isUphill = true;
            }
            if (this.case === 'downhill') {
                params.isDownhill = true;
            }
            this.segmentProvider
                .getSegmentsWhereUserIsPassed(userId, params)
                .then(function (segments) {
                _this.loadeSegmentsWhereUserPass = false;
                for (var _i = 0, segments_1 = segments; _i < segments_1.length; _i++) {
                    var segment = segments_1[_i];
                    var parseMeta = JSON.parse(segment.metaJson);
                    segment.color = __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* UtilsProvider */].getPendenceColor(parseMeta.elevation_pendence).fgColor;
                    segment.pendence = parseMeta.elevation_pendence;
                    segment.segmentType = _this.utils.getSegmentType(segment.pendence);
                    segment.displayLong = _this.metricsProvider.getDisplayHorizontalLong(segment.statDistance);
                }
                _this.segmentsWhereUserIsPassed = segments;
            })
                .catch(function (error) {
                _this.segmentsError = true;
                _this.loadeSegmentsWhereUserPass = false;
            });
        }
    };
    UserSegmentsPage.prototype.getOwnSegments = function (userId) {
        var _this = this;
        this.segmentProvider
            .getUsersSegment(userId)
            .then(function (usersSegments) {
            _this.loaderUsersSegment = false;
            for (var _i = 0, usersSegments_1 = usersSegments; _i < usersSegments_1.length; _i++) {
                var segment = usersSegments_1[_i];
                var parseMeta = JSON.parse(segment.metaJson);
                segment.color = __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* UtilsProvider */].getPendenceColor(parseMeta.elevation_pendence).fgColor;
                segment.pendence = parseMeta.elevation_pendence;
                segment.segmentType = _this.utils.getSegmentType(segment.pendence);
                segment.displayLong = _this.metricsProvider.getDisplayHorizontalLong(segment.statDistance);
            }
            _this.usersSegments = usersSegments;
        })
            .catch(function (error) {
            _this.loaderUsersSegment = false;
            _this.usersSegmentsError = true;
        });
    };
    UserSegmentsPage.prototype.ionViewWillUnload = function () {
        this.events.unsubscribe("refresh_users_segments");
    };
    UserSegmentsPage.prototype.goToSegment = function (segment, segmentIndex) {
        var _this = this;
        if (this.isModal) {
            this.refreshCurrentActivity = false;
            this.closeModal();
            this.notificationProvider.addExternalEvent("https://link.whip.live/segment?id=" + segment.id);
        }
        else {
            try {
                segment.metaJson = JSON.parse(segment.metaJson);
                segment.metaCoordinates = JSON.parse(segment.metaCoordinates);
            }
            catch (_a) { }
            var returnData = function (data) {
                return new Promise(function (resolve) {
                    if (data && data.segmentDeleted) {
                        _this.usersSegments.splice(segmentIndex, 1);
                    }
                });
            };
            this.navCtrl.push("SegmentPage", {
                segment: segment,
                fromPage: 'UserSegmentsPage',
                callback: returnData
            });
        }
    };
    UserSegmentsPage.prototype.closeModal = function () {
        if (this.refreshCurrentActivity) {
            this.viewCtrl.dismiss({ newSegmentHasBeenRefreshed: true });
        }
        else {
            this.viewCtrl.dismiss();
        }
    };
    UserSegmentsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-user-segments",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/user-segments/user-segments.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-buttons start *ngIf="isModal">\n      <button ion-button clear class="close-button" (click)="closeModal()">{{ "close_button_text" | translate }}</button>\n    </ion-buttons>\n  </ion-navbar>\n</ion-header>\n\n<ion-content>\n  <h1 class="title" *ngIf="case === \'own\' && !isFromFriendsRoutePage">{{\'user_segments_page.see_your_segments_button\' | translate}}</h1>\n  <h1 class="title" *ngIf="case === \'own\' && isFromFriendsRoutePage">{{\'user_segments_page.see_segments_not_yours_button\' | translate}}</h1>\n  <h1 class="title" *ngIf="case === \'whereYouArePass\' && !isFromFriendsRoutePage">{{\'user_segments_page.see_segments_where_you_are_pass_button\' | translate}}</h1>\n  <h1 class="title" *ngIf="case === \'whereYouArePass\' && isFromFriendsRoutePage">{{\'user_segments_page.see_segments_not_yours_where_are_you_pass_button\' | translate}}</h1>\n  <h1 class="title" *ngIf="case === \'downhill\'">{{\'user_segments_page.see_downhill_segments_where_you_are_pass_button\' | translate}}</h1>\n  <h1 class="title" *ngIf="case === \'uphill\'">{{\'user_segments_page.see_uphill_segments_not_yours_where_are_you_pass_button\' | translate}}</h1>\n\n  <div *ngIf="case === \'own\'">\n    <ion-spinner class="center" *ngIf="loaderUsersSegment"></ion-spinner>\n  \n    <div class="empty-zones" *ngIf="!usersSegments.length && !loaderUsersSegment">\n      <span class="icon-whip-searchnone icon"></span>\n      <div class="text">{{ \'user_segments_page.no_segemnts_yours\' | translate }}</div>\n    </div>\n  \n    <ion-list *ngIf="usersSegments.length || incomingNewSegment">\n      <p class="incoming-segment-title" *ngIf="incomingNewSegment">{{ \'user_segments_page.incoming_segment_title\' | translate }}</p>\n      <ion-item class="incoming-new-segment-loading-container" *ngIf="incomingNewSegment">\n        <div class="trasfer element" [ngClass]="{ \'segment\': incomingNewSegment.searchType === \'segment\' }">\n          <ion-spinner class="center"></ion-spinner>\n          <div class="line-container">\n            <div class="line-wrap">\n              <div class="line" [style.background]="incomingNewSegment.color">\n                <div class="bottom circle"></div>\n              </div>\n              <div class="top circle"></div>\n            </div>\n          </div>\n  \n          <div class="text-container">\n            <div class="part part-center">\n              <div class="badge-title">{{incomingNewSegment.segmentType}}</div>\n              <div>{{incomingNewSegment.name}}</div>\n  \n              <div class="time">\n                <span *ngIf="incomingNewSegment.displayLong" class="l">{{incomingNewSegment.displayLong}}</span>\n              </div>\n            </div>\n          </div>\n        </div>\n      </ion-item>\n\n      <ion-item *ngFor="let element of usersSegments; index as i;" (click)="goToSegment(element, i)">\n        <div class="trasfer element" [ngClass]="{ \'segment\': element.searchType === \'segment\' }">\n          <div class="line-container">\n            <div class="line-wrap">\n              <div class="line" [style.background]="element.color">\n                <div class="bottom circle"></div>\n              </div>\n              <div class="top circle"></div>\n            </div>\n          </div>\n  \n          <div class="text-container">\n            <div class="part part-center">\n              <div class="badge-title">{{element.segmentType}}</div>\n              <div>{{element.name}}</div>\n  \n              <div class="time">\n                <span *ngIf="element.displayLong" class="l">{{element.displayLong}}</span>\n                <span class="positive-elevation"><ion-icon name="md-arrow-round-up"></ion-icon> {{element.positiveElevation}}m </span>\n                <span class="negative-elevation"><ion-icon name="md-arrow-round-down"></ion-icon> {{element.negativeElevation}}m </span>\n              </div>\n            </div>\n          </div>\n        </div>\n      </ion-item>\n    </ion-list>\n  </div>\n\n  <div *ngIf="case !== \'own\'">\n    <ion-spinner class="center" *ngIf="loadeSegmentsWhereUserPass"></ion-spinner>\n  \n    <div class="empty-zones" *ngIf="!segmentsWhereUserIsPassed.length && !loadeSegmentsWhereUserPass">\n      <span class="icon-whip-searchnone icon"></span>\n      <div class="text">{{ \'user_segments_page.no_segemnts_where_you_pass\' | translate }}</div>\n    </div>\n  \n    <ion-list *ngIf="segmentsWhereUserIsPassed.length">\n      <ion-item *ngFor="let element of segmentsWhereUserIsPassed;" (click)="goToSegment(element)">\n        <div class="trasfer element" [ngClass]="{ \'segment\': element.searchType === \'segment\' }">\n          <div class="line-container">\n            <div class="line-wrap">\n              <div class="line" [style.background]="element.color">\n                <div class="bottom circle"></div>\n              </div>\n              <div class="top circle"></div>\n            </div>\n          </div>\n  \n          <div class="text-container">\n            <div class="part part-center">\n              <div class="badge-title">{{element.segmentType}}</div>\n              <div>{{element.name}}</div>\n  \n              <div class="time">\n                <span *ngIf="element.displayLong" class="l">{{element.displayLong}}</span>\n                <span class="positive-elevation"><ion-icon name="md-arrow-round-up"></ion-icon> {{element.positiveElevation}}m </span>\n                <span class="negative-elevation"><ion-icon name="md-arrow-round-down"></ion-icon> {{element.negativeElevation}}m </span>\n              </div>\n            </div>\n          </div>\n        </div>\n      </ion-item>\n    </ion-list>\n  </div>\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/user-segments/user-segments.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_3__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_segment_segment__["a" /* SegmentProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* UtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* Events */],
            __WEBPACK_IMPORTED_MODULE_7__providers_notification_notification__["a" /* NotificationProvider */]])
    ], UserSegmentsPage);
    return UserSegmentsPage;
}());

//# sourceMappingURL=user-segments.js.map

/***/ })

});
//# sourceMappingURL=30.js.map