webpackJsonp([40],{

/***/ 1218:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignalCategorySelectionPageModule", function() { return SignalCategorySelectionPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__signal_category_selection__ = __webpack_require__(1594);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var SignalCategorySelectionPageModule = /** @class */ (function () {
    function SignalCategorySelectionPageModule() {
    }
    SignalCategorySelectionPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__signal_category_selection__["a" /* SignalCategorySelectionPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__signal_category_selection__["a" /* SignalCategorySelectionPage */]),
            ],
        })
    ], SignalCategorySelectionPageModule);
    return SignalCategorySelectionPageModule;
}());

//# sourceMappingURL=signal-category-selection.module.js.map

/***/ }),

/***/ 1594:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignalCategorySelectionPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_signal_signal__ = __webpack_require__(75);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var SignalCategorySelectionPage = /** @class */ (function () {
    function SignalCategorySelectionPage(viewCtrl, navParams, translate, signalProvider, navCtrl) {
        this.viewCtrl = viewCtrl;
        this.navParams = navParams;
        this.translate = translate;
        this.signalProvider = signalProvider;
        this.navCtrl = navCtrl;
        this.pageId = 'cat';
        this.categories = [];
        // Retrieve position lon lat for the signal localization
        this.position = this.navParams.get('position');
        // Get categories
        this.categories = this.signalProvider.signalCategories;
    }
    SignalCategorySelectionPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        console.log('Signal cat page - ionViewDidLoad SignalCategorySelectionPage');
        // Subscribe to loading complete event
        this.loadingCompleteSub = this.signalProvider.onLoadingComplete.subscribe(function (page) {
            if (page === _this.pageId) {
                // Close modal when loading completes
                // this.closeModal(); 
            }
        });
    };
    SignalCategorySelectionPage.prototype.ionViewDidEnter = function () {
        this.signalProvider.triggerButtonLoading(this.pageId);
    };
    SignalCategorySelectionPage.prototype.ionViewDidLeave = function () {
        this.signalProvider.stopLoading(this.pageId);
    };
    SignalCategorySelectionPage.prototype.pauseLoading = function () {
        this.signalProvider.pauseLoading(this.pageId);
    };
    SignalCategorySelectionPage.prototype.resumeLoading = function () {
        this.signalProvider.resumeLoading(this.pageId);
    };
    SignalCategorySelectionPage.prototype.closeModal = function () {
        this.viewCtrl.dismiss();
    };
    SignalCategorySelectionPage.prototype.selectCategory = function (category) {
        this.navCtrl.push("SignalTagSelectionPage", {
            category: category,
            position: this.position
        });
    };
    SignalCategorySelectionPage.prototype.openSOS = function () {
        this.viewCtrl.dismiss({ action: "openSOS" });
    };
    SignalCategorySelectionPage.prototype.ngOnDestroy = function () {
        // Unsubscribe to avoid memory leaks
        if (this.loadingCompleteSub) {
            this.loadingCompleteSub.unsubscribe();
        }
    };
    SignalCategorySelectionPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-signal-category-selection',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/signal-category-selection/signal-category-selection.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-title>{{ \'signal_category_page.title\' | translate }}</ion-title>\n    <ion-buttons end class="sos-button-container">\n      <button ion-button class="sos-button" (click)="openSOS()">\n        <img src="../assets/img/icons/sos.png" />\n      </button>\n    </ion-buttons>\n  </ion-navbar>\n</ion-header>\n\n<ion-content padding>\n  <div class="signal-category-icon-container" *ngIf="categories.length">\n    <signal-category-icon *ngFor="let category of categories" (click)="selectCategory(category)" [category]="category" (touchcancel)="resumeLoading()"\n    (mouseenter)="pauseLoading()" (mouseleave)="resumeLoading()" (touchstart)="pauseLoading()" (touchend)="resumeLoading()"></signal-category-icon>\n  </div>\n</ion-content>\n\n<ion-footer>\n  <ion-buttons padding class="button-container">\n    <button id="loading-cat-button" ion-button (click)="closeModal()">\n      {{ \'signal.cancel_send\' | translate }}\n    </button>\n  </ion-buttons>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/signal-category-selection/signal-category-selection.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_signal_signal__["a" /* SignalProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */]])
    ], SignalCategorySelectionPage);
    return SignalCategorySelectionPage;
}());

//# sourceMappingURL=signal-category-selection.js.map

/***/ })

});
//# sourceMappingURL=40.js.map