webpackJsonp([42],{

/***/ 1224:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SettingsPageModule", function() { return SettingsPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__settings__ = __webpack_require__(1599);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var SettingsPageModule = /** @class */ (function () {
    function SettingsPageModule() {
    }
    SettingsPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_3__settings__["a" /* SettingsPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_3__settings__["a" /* SettingsPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
        })
    ], SettingsPageModule);
    return SettingsPageModule;
}());

//# sourceMappingURL=settings.module.js.map

/***/ }),

/***/ 1599:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_category_category__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_authentication_authentication__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_record_ride_settings_record_ride_settings__ = __webpack_require__(612);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_all_events_all_events__ = __webpack_require__(19);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var SettingsPage = /** @class */ (function () {
    function SettingsPage(navParams, viewCtrl, auth, allEvents, categoryProvider, recordRideSettingsProvider) {
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.auth = auth;
        this.allEvents = allEvents;
        this.categoryProvider = categoryProvider;
        this.recordRideSettingsProvider = recordRideSettingsProvider;
        this.settings = {};
        this.autopauseState = "disable";
        this.darkState = false;
        this.tripMasterState = false;
        this.lastPortraitOrientation = true;
        this.lastTripMaster = false;
        this.showMacroTypologies = false;
        this.macroTypologies = [];
        this.settings = this.recordRideSettingsProvider.getDefaultSettings();
    }
    SettingsPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        if (this.navParams.get("darkMode")) {
            this.darkState = true;
        }
        if (this.navParams.get("autopauseEnabled")) {
            this.autopauseState = "active";
        }
        this.tripMasterState = this.navParams.get("tripMasterMode");
        this.lastTripMaster = this.tripMasterState;
        this.allEvents.subscribePageEvent("settingsPage", "on_back_button", function (data) {
            _this.onCloseModal();
            data.callback(true);
        });
        this.macroTypologies = this.categoryProvider.getGenericTypologiesForDirections();
        this.recordRideSettingsProvider.load().then(function (settings) {
            _this.settings = settings;
            for (var _i = 0, _a = _this.macroTypologies; _i < _a.length; _i++) {
                var typology = _a[_i];
                if (_this.settings.rerouting_typology.rerouting_macro && typology.vehicle == _this.settings.rerouting_typology.rerouting_macro.vehicle) {
                    typology.is_select = true;
                }
                else {
                    typology.is_select = false;
                }
            }
        });
    };
    SettingsPage.prototype.ionViewWillUnload = function () {
        this.allEvents.unsubscribePageEvent("settingsPage", "on_back_button");
    };
    SettingsPage.prototype.onCloseModal = function () {
        this.viewCtrl.dismiss({
            darkMode: this.darkState,
            tripMasterMode: this.tripMasterState,
        });
    };
    SettingsPage.prototype.onAutoPauseClick = function () {
        if (this.autopauseState === "active") {
            this.auth.setAutoPauseStateDisabled();
            this.autopauseState = "disable";
        }
        else {
            this.auth.setAutoPauseStateActivated();
            this.autopauseState = "active";
        }
    };
    SettingsPage.prototype.onDarkClick = function () {
        this.darkState = !this.darkState;
    };
    SettingsPage.prototype.onDimmerClick = function () {
        this.settings = this.recordRideSettingsProvider.changeDimmer();
    };
    SettingsPage.prototype.onZoomClick = function () {
        this.settings = this.recordRideSettingsProvider.changeZoom();
    };
    SettingsPage.prototype.onSpeedUnlockOrientation = function () {
        this.settings = this.recordRideSettingsProvider.changeSpeedUnlockOrientation();
    };
    SettingsPage.prototype.onReroutingModeClick = function () {
        this.settings = this.recordRideSettingsProvider.changeReroutingMode();
    };
    SettingsPage.prototype.onReroutingTypologyClick = function () {
        this.openTypologySelect();
    };
    SettingsPage.prototype.onTripMaster = function () {
        this.tripMasterState = !this.tripMasterState;
    };
    SettingsPage.prototype.openTypologySelect = function () {
        this.showMacroTypologies = true;
    };
    SettingsPage.prototype.closeSelectTypology = function () {
        this.showMacroTypologies = false;
    };
    SettingsPage.prototype.selectTypology = function (typology) {
        for (var _i = 0, _a = this.macroTypologies; _i < _a.length; _i++) {
            var typology_1 = _a[_i];
            typology_1.is_select = false;
        }
        typology.is_select = true;
    };
    SettingsPage.prototype.confirmTypology = function () {
        var typologyFound = this.macroTypologies.find(function (item) {
            return item.is_select;
        });
        this.showMacroTypologies = false;
        this.settings = this.recordRideSettingsProvider.changeReroutingTypology(typologyFound);
    };
    SettingsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-settings",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/settings/settings.html"*/'<ion-header [ngClass]="{\'is-dark\': darkState}">\n\n  <ion-toolbar>\n    <ion-title>{{ \'record_ride.settings_button\' | translate }}</ion-title>\n    <ion-buttons end>\n      <button ion-button clear (click)="onCloseModal()">\n        {{ \'record_ride.close_button\' | translate }}\n      </button>\n    </ion-buttons>\n  </ion-toolbar>\n\n</ion-header>\n\n<ion-content [ngClass]="{\'is-dark\': darkState}">\n  <div class="flex-box-container">\n    <div class="square">\n      <a (click)="onAutoPauseClick()" class="auto-pause-link">\n        <div class="auto-pause-container" [ngClass]="[autopauseState]">\n          <div class="circle-container">\n            <ion-icon name="ios-play" style="margin-left: -10px"></ion-icon>\n            <ion-icon name="ios-pause" style="margin-left: 10px"></ion-icon>\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.auto_pause\' | translate }}</p>\n            <p class="active" *ngIf="autopauseState === \'active\'">{{ \'settings_page.active\' | translate }}</p>\n            <p class="nonactive" *ngIf="autopauseState === \'disable\'">{{ \'settings_page.non_active\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    <div class="square">\n      <a (click)="onDarkClick()" class="auto-pause-link">\n        <div class="auto-pause-container dark">\n          <div class="circle-container">\n            <ion-icon name="ios-moon"></ion-icon>\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.dark_mode\' | translate }}</p>\n            <p class="active" *ngIf="darkState">{{ \'settings_page.active\' | translate }}</p>\n            <p class="nonactive" *ngIf="!darkState">{{ \'settings_page.non_active\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    <div class="square" *ngIf="settings.dimmer">\n      <a (click)="onDimmerClick()" class="auto-pause-link">\n        <div class="auto-pause-container dimmer">\n          <div class="circle-container">\n            <ion-icon name="ios-sunny"></ion-icon>\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.dimmer\' | translate }}</p>\n            <p class="nonactive" *ngIf="settings.dimmer.is_auto">{{ \'settings_page.dimmer_auto\' | translate }}</p>\n            <p class="active" *ngIf="settings.dimmer.is_always">{{ \'settings_page.dimmer_always\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    <div class="square">\n      <a (click)="onZoomClick()" class="auto-pause-link">\n        <div class="auto-pause-container zoom">\n          <div class="circle-container">\n            <div class="image-icon"></div>\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.zoom\' | translate }}</p>\n            <p class="active" *ngIf="settings.zoom.is_auto">{{ \'settings_page.zoom_auto\' | translate }}</p>\n            <p class="nonactive" *ngIf="settings.zoom.is_manual">{{ \'settings_page.zoom_manual\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    \n    <div class="square">\n      <a (click)="onSpeedUnlockOrientation()" class="auto-pause-link">\n        <div class="auto-pause-container orientation-lock" [ngClass]="{\'active\': settings.is_speed_unlock_orientation.is_enabled}">\n          <div class="circle-container">\n            <div class="image-icon"></div>\n          </div>\n          <div class="title-container">\n            <p [innerHTML]="\'settings_page.device_screen_orientation\' | translate"></p>\n            <p class="nonactive" *ngIf="settings.is_speed_unlock_orientation.is_disabled">{{ \'settings_page.portrait_orientation_text\' | translate }}</p>\n            <p class="active" *ngIf="settings.is_speed_unlock_orientation.is_enabled">{{ \'settings_page.landscape_orientation_text\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    \n  </div>\n  \n\n  <h1 class="title">\n    {{ \'settings_page.navigation_settings\' | translate }}\n  </h1>\n\n  <div class="flex-box-container">\n    <div class="square">\n      <a (click)="onReroutingModeClick()" class="auto-pause-link">\n        <div class="auto-pause-container rerouting-mode">\n          <div class="circle-container">\n            <div class="image-icon"></div>\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.rerouting_mode\' | translate }}</p>\n            <p class="active" *ngIf="settings.rerouting_mode.to_route">{{ \'settings_page.rerouting_mode_route\' | translate }}</p>\n            <p class="active" *ngIf="settings.rerouting_mode.to_destination">{{ \'settings_page.rerouting_mode_destination\' | translate }}</p>\n            <p class="active" *ngIf="settings.rerouting_mode.to_nearest_route">{{ \'settings_page.rerouting_mode_route_nearest\' | translate }}</p>\n            <p class="nonactive" *ngIf="settings.rerouting_mode.disabled">{{ \'settings_page.rerouting_mode_disabled\' | translate }}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n    <div class="square">\n      <a (click)="onReroutingTypologyClick()" class="auto-pause-link">\n        <div class="auto-pause-container rerouting-typology">\n          <div class="circle-container">\n            <span *ngIf="settings.rerouting_typology.rerouting_macro" [class]="settings.rerouting_typology.rerouting_macro.icon" [style.background-color]="settings.rerouting_typology.rerouting_macro.color"></span>\n\n          </div>\n          <div class="title-container">\n            <p>{{ \'settings_page.rerouting_typology\' | translate }}</p>\n            <p *ngIf="settings.rerouting_typology.rerouting_macro" class="active">{{settings.rerouting_typology.rerouting_macro.name}}</p>\n          </div>\n        </div>\n      </a>\n    </div>\n  </div>\n\n  <div ion-fixed class="typology-container" [ngClass]="{\'show-container\': showMacroTypologies}">\n    <a class="close-container" (click)="closeSelectTypology()"></a>\n\n    <div class="macro-typology-container" [ngClass]="{\'show-container\': showMacroTypologies}">\n      <p class="title">{{\'settings_page.directions_typologies_title\' | translate}}</p>\n      <div class="typologies-container">\n        <div class="container" *ngFor="let typology of macroTypologies;">\n          <a (click)="selectTypology(typology)">\n            <div class="icon-container" [ngClass]="{\'typology-selected\': typology.is_select}" [style.background-color]="typology.color">\n              <span class="icon" [ngClass]="typology.icon"></span>\n              <span class="icon-whip-checkmark checkmark" *ngIf="typology.is_select"></span>\n            </div>\n            <div class="text-container"><span>{{typology.name}}</span></div>\n          </a>\n        </div>\n      </div>\n      <button ion-button (click)="confirmTypology()">{{\'route_configurator_page.select_button\' | translate}}</button>\n      <p class="info-text" [innerHTML]="\'route_configurator_page.select_new_category_info\' | translate"></p>\n    </div>\n  </div>\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/settings/settings.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_3__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_all_events_all_events__["a" /* AllEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_category_category__["a" /* CategoryProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_record_ride_settings_record_ride_settings__["a" /* RecordRideSettingsProvider */]])
    ], SettingsPage);
    return SettingsPage;
}());

//# sourceMappingURL=settings.js.map

/***/ })

});
//# sourceMappingURL=42.js.map