webpackJsonp([44],{

/***/ 1214:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SelectCountryPageModule", function() { return SelectCountryPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__select_country__ = __webpack_require__(1588);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var SelectCountryPageModule = /** @class */ (function () {
    function SelectCountryPageModule() {
    }
    SelectCountryPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__select_country__["a" /* SelectCountryPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__select_country__["a" /* SelectCountryPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], SelectCountryPageModule);
    return SelectCountryPageModule;
}());

//# sourceMappingURL=select-country.module.js.map

/***/ }),

/***/ 1588:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SelectCountryPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_common_http__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var SelectCountryPage = /** @class */ (function () {
    function SelectCountryPage(navCtrl, navParams, viewCtrl, http, logger) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.http = http;
        this.logger = logger;
        this.showFlags = false;
        this.loading = true;
    }
    SelectCountryPage.prototype.ionViewDidLoad = function () {
        this.readCountriesData();
    };
    SelectCountryPage.prototype.ionViewDidEnter = function () {
        var _this = this;
        setTimeout(function () {
            _this.searchInput.setFocus();
        }, 200);
    };
    SelectCountryPage.prototype.closeModal = function () {
        this.viewCtrl.dismiss();
    };
    SelectCountryPage.prototype.readCountriesData = function () {
        var _this = this;
        this.http.get("assets/fixtures/countries.json").subscribe(function (data) {
            _this.countries = data;
            _this.countriesList = data;
            _this.loading = false;
            setTimeout(function () {
                _this.showFlags = true;
            }, 200);
        }, function (error) {
            _this.logger.debug("error to get countries list", error);
        });
    };
    SelectCountryPage.prototype.countrySelected = function (countryCode) {
        this.viewCtrl.dismiss(countryCode);
    };
    SelectCountryPage.prototype.onInput = function (e) {
        var name = this.capitalizeFirstLetter(this.myCountry);
        this.countriesList = [];
        for (var _i = 0, _a = this.countries; _i < _a.length; _i++) {
            var country = _a[_i];
            if (country.name.includes(name)) {
                this.countriesList.push(country);
            }
        }
    };
    SelectCountryPage.prototype.capitalizeFirstLetter = function (string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("countrysearch"),
        __metadata("design:type", Object)
    ], SelectCountryPage.prototype, "searchInput", void 0);
    SelectCountryPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-select-country",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/select-country/select-country.html"*/'\n<ion-header>\n\n  <ion-navbar>\n    <ion-buttons start  class="close-button-container">\n      <button ion-button (click)="closeModal()">{{\'select_country_page.close_text\' | translate}}</button>\n    </ion-buttons>\n  </ion-navbar>\n\n</ion-header>\n\n\n<ion-content padding>\n  <ion-searchbar #countrysearch ion-fixed\n    [(ngModel)]="myCountry"\n    [autocomplete]="on"\n    placeholder="{{ \'select_country_page.placeholder_text\' | translate }}"\n    [showCancelButton]="true"\n    [debounce]="500"\n    (ionInput)="onInput($event)">\n  </ion-searchbar>\n\n  <ion-spinner class="center" *ngIf="loading" ></ion-spinner>\n\n  <ion-list *ngIf="!loading">\n    <a *ngFor="let country of countriesList;" (click)="countrySelected(country.code)">\n      <ion-item class="country-container" [ngClass]="{\'sc-show-flags\': showFlags}">\n        <flag-wrapper [countrycode]="country.code"></flag-wrapper>\n        <div class="country-name">{{country.name}}</div>\n      </ion-item>    \n    </a>\n  </ion-list>\n\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/select-country/select-country.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__["a" /* LoggerProvider */]])
    ], SelectCountryPage);
    return SelectCountryPage;
}());

//# sourceMappingURL=select-country.js.map

/***/ })

});
//# sourceMappingURL=44.js.map