webpackJsonp([48],{

/***/ 1209:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SegmentPageModule", function() { return SegmentPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__segment_tab_overview__ = __webpack_require__(1583);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var SegmentPageModule = /** @class */ (function () {
    function SegmentPageModule() {
    }
    SegmentPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__segment_tab_overview__["a" /* SegmentTabOverviewPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__segment_tab_overview__["a" /* SegmentTabOverviewPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], SegmentPageModule);
    return SegmentPageModule;
}());

//# sourceMappingURL=segment-tab-overview.module.js.map

/***/ }),

/***/ 1583:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SegmentTabOverviewPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3__turf_turf__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_segment_segment__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_loader_loader__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_authentication_authentication__ = __webpack_require__(11);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var SegmentTabOverviewPage = /** @class */ (function () {
    function SegmentTabOverviewPage(navCtrl, navParams, segmentProvider, metrics, events, actionSheetCtrl, alertCtrl, translate, loader, viewCtrl, logger, modalCtrl, auth, toastCtrl) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.segmentProvider = segmentProvider;
        this.metrics = metrics;
        this.events = events;
        this.actionSheetCtrl = actionSheetCtrl;
        this.alertCtrl = alertCtrl;
        this.translate = translate;
        this.loader = loader;
        this.viewCtrl = viewCtrl;
        this.logger = logger;
        this.modalCtrl = modalCtrl;
        this.auth = auth;
        this.toastCtrl = toastCtrl;
        this.localSegment = {
            metaJson: {
                owner: {},
            },
        };
        this.localInfo = {};
        this.coordinates = [];
        this.yourSegment = false;
        this.chartReady = false;
        this.subsegments = [];
        this.statisticsInfo = [];
    }
    SegmentTabOverviewPage.prototype.ionViewDidLoad = function () {
        this.localSegment = this.navParams.get("segmentInfo");
        this.logger.debug("segment in info page", this.localSegment);
        if (this.localSegment.coordinates &&
            this.localSegment.coordinates.geometry) {
            this.coordinates = this.localSegment.coordinates.geometry.coordinates;
        }
        if (this.localSegment.metaCoordinates) {
            this.coordinates = this.localSegment.metaCoordinates.coordinates;
        }
        if (this.localSegment.formattedCoordinates) {
            this.coordinates = this.localSegment.formattedCoordinates;
        }
        this.localInfo = {
            elevation_start: this.localSegment.metaJson.elevation_start,
            elevation_end: this.localSegment.metaJson.elevation_end,
            elevation_difference: this.localSegment.metaJson.elevation_difference,
            color: this.localSegment.color
                ? this.localSegment.color
                : this.localSegment.pendenceColor,
        };
        this.statisticsInfo = [
            {
                name: this.translate.instant("segment_page.total_length"),
                value: this.metrics.getDisplayHorizontalLong(this.localSegment.distance),
                icon: "icon-whip-path",
            },
            {
                name: this.translate.instant("segment_page.avg_pendece"),
                value: this.localSegment.avgPendence,
                icon: "icon-whip-mountain",
            },
        ];
        var loggedUser = this.auth.getDataUser();
        this.yourSegment =
            loggedUser.id === this.localSegment.metaJson.owner.id ? true : false;
        var subsegmentsInfo = this.localSegment.metaJson.superSegmentInfo &&
            this.localSegment.metaJson.superSegmentInfo.subsegmentinfo
            ? this.localSegment.metaJson.superSegmentInfo.subsegmentinfo
            : [];
        for (var s = 0; s < subsegmentsInfo.length; s++) {
            var currentSubsegment = subsegmentsInfo[s];
            var lastPoint = void 0, dist = 0, startDist = 0;
            if (!currentSubsegment.isMaster) {
                var startIndex = currentSubsegment.startIndex - (this.localSegment.startIndex || 0);
                var endIndex = startIndex +
                    (currentSubsegment.endIndex - currentSubsegment.startIndex);
                for (var i = 0; i < startIndex; i++) {
                    var pointLngLat = [this.coordinates[i][0], this.coordinates[i][1]];
                    var currentPoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"](pointLngLat);
                    if (lastPoint) {
                        startDist += __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](lastPoint, currentPoint, {
                            units: "meters",
                        });
                    }
                    lastPoint = currentPoint;
                }
                for (var i = startIndex; i <= endIndex; i++) {
                    if (endIndex < this.coordinates.length) {
                        var pointLngLat = [this.coordinates[i][0], this.coordinates[i][1]];
                        var currentPoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"](pointLngLat);
                        if (lastPoint) {
                            dist += __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](lastPoint, currentPoint, {
                                units: "meters",
                            });
                        }
                        lastPoint = currentPoint;
                    }
                }
                this.subsegments.push({
                    name: currentSubsegment.name,
                    range: [
                        this.metrics.getDisplayHorizontalLongArray(startDist),
                        this.metrics.getDisplayHorizontalLongArray(dist),
                    ],
                });
            }
        }
        this.localSegment.tags = this.localSegment.metaJson.tagsCouples;
        this.localSegment.typologies = this.localSegment.typologies;
    };
    SegmentTabOverviewPage.prototype.onShowAllTypologies = function () {
        var showListItemsModal = this.modalCtrl.create("ShowListItemsPage", {
            listToRender: this.localSegment.tags,
            title: this.translate.instant("segment_page.segment_creates_for"),
            showTypologies: true,
        }, { cssClass: "overlay-small-down" });
        showListItemsModal.present();
    };
    SegmentTabOverviewPage.prototype.chartIsReady = function (e) {
        var _this = this;
        setTimeout(function () {
            _this.chartReady = true;
        }, 500);
    };
    SegmentTabOverviewPage.prototype.deleteThisSegment = function () {
        var _this = this;
        var alert = this.alertCtrl.create({
            title: this.translate.instant("segment_page.action_sheet_delete_segment_title"),
            message: this.translate.instant("segment_page.action_sheet_delete_segment_subtitle"),
            buttons: [
                {
                    text: this.translate.instant("close_button_text"),
                    role: "cancel",
                },
                {
                    text: this.translate.instant("segment_page.action_sheet_delete_segment_button"),
                    cssClass: "critical-action",
                    handler: function () {
                        _this.loader.showLoader();
                        _this.segmentProvider
                            .deleteSegment(_this.localSegment.segmentId || _this.localSegment.id)
                            .then(function (succ) {
                            _this.logger.debug("segment delete correctly", succ);
                            _this.loader.hideLoader();
                            _this.navCtrl
                                .pop()
                                .then(function () { return _this.events.publish("segment_deleted"); });
                        })
                            .catch(function (err) {
                            _this.logger.debug("error to delete segment", err);
                            _this.loader.hideLoader();
                            var toast = _this.toastCtrl.create({
                                message: _this.translate.instant("segment_page.delete_segment_error"),
                                duration: 3000,
                                position: 'top',
                                showCloseButton: true,
                                cssClass: "error"
                            });
                            toast.present();
                        });
                    },
                },
            ],
        });
        alert.present();
    };
    SegmentTabOverviewPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-segment-tab-overview",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/segment-tab-overview/segment-tab-overview.html"*/'<ion-header>\n  <ion-navbar>\n  </ion-navbar>	\n</ion-header>\n\n<ion-content>\n  <div class="segment-info-container">\n    <h1 class="segment-name">{{localSegment.name}}</h1>\n    <span class="description" *ngIf="localSegment.description">{{localSegment.description}}</span>\n\n    <div class="row-container">\n      <div class="privacy-date">\n        <ion-icon name="md-globe" *ngIf="localSegment.isPublic"></ion-icon>\n        <ion-icon name="lock" *ngIf="!localSegment.isPublic"></ion-icon>\n        <span class="creation-date">{{localSegment.creationDate}}</span>\n      </div>\n  \n      <div class="typologies-container">\n        <button ion-item (click)="onShowAllTypologies()">\n          <div class="typology-container" *ngFor="let typology of localSegment.typologies;" [style.background-color]="typology.color">\n            <span [class]="typology.icon"></span>\n          </div>\n        </button>\n      </div>\n    </div>\n  </div>\n\n  <div class="graph-elevations-container" [ngClass]="{\'show-chart-container\': chartReady}">\n    <show-elevation-chart [rawcoordinates]="coordinates" [info]="localInfo" (onChartReady)="chartIsReady($event)"></show-elevation-chart>\n  </div>\n\n  <ion-list class="statistics-container">\n    <ion-list-header>{{\'segment_page.statistics_text\' | translate}}</ion-list-header>\n    <ion-item *ngFor="let info of statisticsInfo;">\n      <span [class]="info.icon" item-start></span>\n      <span class="name">{{info.name}}</span>\n      <span class="value">{{info.value}}</span>\n    </ion-item>\n  </ion-list>\n\n  <ion-list class="subsegments-container" *ngIf="subsegments.length">\n    <ion-list-header>{{\'segment_page.subsegments_text\' | translate}}</ion-list-header>\n    <ion-item *ngFor="let sector of subsegments;">\n      <span class="icon-whip-path" item-start></span>\n      <span class="subsegment-name">{{sector.name}}</span>\n      <div class="subsegment-range-container">\n        <span class="range" *ngFor="let value of sector.range">\n          <span class="number">{{value[0]}}</span>\n          <span class="uom">{{value[1]}}</span>\n          <span class="divider"> - </span>\n        </span>\n      </div>\n    </ion-item>\n  </ion-list>\n\n  <div class="owner-container">\n    <div class="user-container" *ngIf="!yourSegment">\n      <h5 class="title">{{\'segment_page.non_own_segment\' | translate}}</h5>\n      <user-link [user]="localSegment.metaJson.owner">\n        <compact-user-info [user]="localSegment.metaJson.owner"></compact-user-info>\n      </user-link>\n    </div>\n\n    <div *ngIf="yourSegment" class="your-segment-container">\n      <h6 class="name">{{\'segment_page.own_segment\' | translate}}</h6>\n      <button ion-item (click)="deleteThisSegment()">{{\'segment_page.delete_segment_button\' | translate}}</button>\n    </div>\n  </div>\n\n</ion-content>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/segment-tab-overview/segment-tab-overview.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_4__providers_segment_segment__["a" /* SegmentProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* Events */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["a" /* ActionSheetController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_6__providers_loader_loader__["a" /* LoaderProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["n" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_8__providers_authentication_authentication__["a" /* AuthenticationProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["z" /* ToastController */]])
    ], SegmentTabOverviewPage);
    return SegmentTabOverviewPage;
}());

//# sourceMappingURL=segment-tab-overview.js.map

/***/ })

});
//# sourceMappingURL=48.js.map