webpackJsonp([58],{

/***/ 1195:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RouteCollectionPageModule", function() { return RouteCollectionPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__route_collection__ = __webpack_require__(1568);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var RouteCollectionPageModule = /** @class */ (function () {
    function RouteCollectionPageModule() {
    }
    RouteCollectionPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__route_collection__["a" /* RouteCollectionPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__route_collection__["a" /* RouteCollectionPage */]),
            ],
        })
    ], RouteCollectionPageModule);
    return RouteCollectionPageModule;
}());

//# sourceMappingURL=route-collection.module.js.map

/***/ }),

/***/ 1568:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RouteCollectionPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_preset_route_preset_route__ = __webpack_require__(231);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_analytics_analytics__ = __webpack_require__(50);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var RouteCollectionPage = /** @class */ (function () {
    function RouteCollectionPage(navCtrl, navParams, utils, sr, modalCtrl, viewCtrl, componentFactoryResolver, injector, appRef, analyticsProvider) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.utils = utils;
        this.sr = sr;
        this.modalCtrl = modalCtrl;
        this.viewCtrl = viewCtrl;
        this.componentFactoryResolver = componentFactoryResolver;
        this.injector = injector;
        this.appRef = appRef;
        this.analyticsProvider = analyticsProvider;
        this.routeCollection = {};
        this.owner = {
            first_name: "",
            last_name: "",
            avatar: "",
            id: "",
            country: "",
        };
        this.isModal = false;
    }
    RouteCollectionPage.prototype.fixImagePrefix = function (img) {
        return __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* UtilsProvider */].fixImagePrefix(img);
    };
    RouteCollectionPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.id = this.navParams.get("id");
        this.routeCollection = this.navParams.get("data");
        this.isModal = this.navParams.get("isModal");
        this.analyticsProvider.trackWithEventPropertiesMixpanel("Route Collection Page", {
            id: this.routeCollection.id,
        });
        var nameTranslate = this.routeCollection.nameTranslate;
        if (!nameTranslate) {
            nameTranslate = this.routeCollection.title_translate;
        }
        this.routeCollection.title = this.utils.getTranslatedFromMap(nameTranslate, "title");
        var bodyTranslate = this.routeCollection.bodyTranslate;
        if (!bodyTranslate) {
            bodyTranslate = this.routeCollection.body_translate;
        }
        this.routeCollection.body = this.utils.getTranslatedFromMap(bodyTranslate, "body");
        if (this.routeCollection.carousel) {
            for (var i = 0; i < this.routeCollection.carousel.length; i++) {
                var image = this.routeCollection.carousel[i];
                image = image + "?w=1200&h=1200";
            }
        }
        this.owner = {
            first_name: this.routeCollection.owner
                ? this.routeCollection.owner.name
                : this.routeCollection.ownerName,
            last_name: "",
            avatar: this.routeCollection.owner
                ? this.routeCollection.owner.avatarUrl
                : this.routeCollection.ownerImage,
            id: this.routeCollection.owner
                ? this.routeCollection.owner.id
                : this.routeCollection.ownerId,
            country: "",
        };
        var parser = new DOMParser();
        var htmlDoc = parser.parseFromString(this.routeCollection.body, "text/html");
        var routes = htmlDoc.querySelectorAll("[route]");
        var _loop_1 = function (i) {
            var route = routes[i];
            var routeId = route.getAttribute("route-id");
            var routeData = null;
            if (this_1.routeCollection.routesData) {
                routeData = this_1.routeCollection.routesData[routeId];
                if (routeData) {
                    var factory = this_1.componentFactoryResolver.resolveComponentFactory(__WEBPACK_IMPORTED_MODULE_4__components_preset_route_preset_route__["a" /* PresetRouteComponent */]);
                    var componentRef = factory.create(this_1.injector);
                    this_1.appRef.attachView(componentRef.hostView);
                    componentRef.instance.presetRoute = routeData;
                    componentRef.instance.isToCache = false;
                    var callbackOutside_1 = this_1.navParams.get("callback");
                    var callback_1 = function (data) {
                        return new Promise(function (resolve) {
                            if (callbackOutside_1) {
                                callbackOutside_1(data);
                            }
                            if (data && (data.navigateRoute || data.isAddedRoute) && _this.isModal) {
                                _this.closeModal();
                            }
                        });
                    };
                    componentRef.instance.onCardClicked.subscribe(function (selectedRoute) {
                        var options = {
                            routeDetail: selectedRoute.routeClicked,
                            callback: callback_1,
                            isModal: _this.isModal,
                            context: "route-collection",
                            fromPage: _this.navParams.get("fromPage")
                        };
                        if (_this.isModal) {
                            var routeModal = _this.modalCtrl.create("MyRoutesDetailPage", options);
                            routeModal.onDidDismiss(function (data) {
                                callback_1(data);
                            });
                            routeModal.present();
                        }
                        else {
                            _this.navCtrl.push("MyRoutesDetailPage", options);
                        }
                    });
                    var domElem_1 = componentRef.hostView
                        .rootNodes[0];
                    setTimeout(function () {
                        //[name='login']
                        var element = document.querySelector("[route-id='" + routeId + "']");
                        if (element) {
                            element.appendChild(domElem_1);
                        }
                    }, 200);
                    //route.innerHTML = '<preset-route [route]="routeCollection.routesData[\''+routeId+'\']" (onCardClicked)="navigateToDetail($event)"></preset-route>';
                    //this.routeCollection.body += '<preset-route [route]="routeCollection.routesData[\''+routeId+'\']" (onCardClicked)="navigateToDetail($event)"></preset-route>';
                }
            }
        };
        var this_1 = this;
        for (var i = 0; i < routes.length; i++) {
            _loop_1(i);
        }
        this.routeCollection.title = this.sr.bypassSecurityTrustHtml(this.routeCollection.title);
        this.routeCollection.body = this.sr.bypassSecurityTrustHtml(this.routeCollection.body);
    };
    RouteCollectionPage.prototype.closeModal = function () {
        this.viewCtrl.dismiss();
    };
    RouteCollectionPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-route-collection",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/route-collection/route-collection.html"*/'<ion-header transparent no-border>\n\n  <ion-navbar>\n\n	<ion-buttons end *ngIf="isModal">\n		<button ion-button class="close-button" (click)="closeModal()">{{\'close_button_text\' | translate}}</button>\n	</ion-buttons>\n  </ion-navbar>\n\n</ion-header>\n\n\n<ion-content>\n\n	<ion-slides class="slider" *ngIf="routeCollection.carousel && routeCollection.carousel.length > 0" pager="true">\n		<ion-slide *ngFor="let imageUrl of routeCollection.carousel">\n			<div class="slide-image" [style.backgroundImage]="\'url(\' + fixImagePrefix(imageUrl) + \')\'"></div>\n		</ion-slide>\n    </ion-slides>\n    <div class="route-collection-container">\n    	<div class="spacer" *ngIf="!routeCollection.carousel || routeCollection.carousel.length == 0"></div>\n    	<div class="owner-container">\n	    	<user-link [user]="owner">\n	            <div class="thumbnail" [ngStyle]="{\'background-image\': \'url(\'+ fixImagePrefix(owner.avatar) +\')\'}"></div>\n	            <compact-user-info [isbadge]="true" [display]="\'textonly\'" [user]="owner"></compact-user-info>\n	        </user-link>\n	    </div>\n    	<div class="title-container">\n	    	<h1 [innerHtml]="routeCollection.title"></h1>\n	    </div>\n	    \n	    <div class="body-container" [innerHtml]="routeCollection.body"></div>\n    </div>\n    \n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/route-collection/route-collection.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* UtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__["c" /* DomSanitizer */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["n" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["ComponentFactoryResolver"],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["ApplicationRef"],
            __WEBPACK_IMPORTED_MODULE_5__providers_analytics_analytics__["a" /* AnalyticsProvider */]])
    ], RouteCollectionPage);
    return RouteCollectionPage;
}());

//# sourceMappingURL=route-collection.js.map

/***/ })

});
//# sourceMappingURL=58.js.map