webpackJsonp([59],{

/***/ 1194:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResizeActivityPageModule", function() { return ResizeActivityPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__resize_activity__ = __webpack_require__(1567);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var ResizeActivityPageModule = /** @class */ (function () {
    function ResizeActivityPageModule() {
    }
    ResizeActivityPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__resize_activity__["a" /* ResizeActivityPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__resize_activity__["a" /* ResizeActivityPage */]),
                __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */]
            ],
        })
    ], ResizeActivityPageModule);
    return ResizeActivityPageModule;
}());

//# sourceMappingURL=resize-activity.module.js.map

/***/ }),

/***/ 1567:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ResizeActivityPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var ResizeActivityPage = /** @class */ (function () {
    function ResizeActivityPage(navCtrl, navParams, viewCtrl, translate) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.translate = translate;
        this.currentStep = 1;
        this._mapReady = false;
        this.allCoordinates = [];
        this.showMapSlider = false;
        this.structureValues = {};
        this.routeItemEdited = {};
    }
    ResizeActivityPage.prototype.ionViewWillEnter = function () {
        this.viewCtrl.setBackButtonText(this.translate.instant("back_button_text"));
    };
    ResizeActivityPage.prototype.ionViewDidLoad = function () {
        this.resizeAction = this.navParams.get("action");
        this.allCoordinates = this.navParams.get("totalCoordinates");
        var oldFromPathIndex = this.navParams.get("oldFromPathIndex");
        var oldToPathIndex = this.navParams.get("oldToPathIndex");
        if (oldFromPathIndex && oldToPathIndex) {
            this.structureValues = {
                lower: oldFromPathIndex,
                upper: oldToPathIndex
            };
        }
        this.showMapSlider = true;
    };
    ResizeActivityPage.prototype.doRefreshPath = function (e) {
        this.structureValues.lower = e.structure_lower;
        this.structureValues.upper = e.structure_upper;
    };
    ResizeActivityPage.prototype.BackToStep1 = function () {
        this.currentStep = 1;
        this.structureValues.lower = this.lastSplittedValue.lower;
        this.structureValues.upper = this.lastSplittedValue.upper;
        this.structureValues.step = "1";
    };
    ResizeActivityPage.prototype.closeModal = function () {
        this.viewCtrl.dismiss();
    };
    ResizeActivityPage.prototype.splitActivity = function () {
        if (this.currentStep === 1) {
            this.lastSplittedValue = {
                lower: this.structureValues.lower,
                upper: this.structureValues.upper
            };
            var oldFromPathIndex2 = this.navParams.get("oldFromPathIndex2");
            var oldToPathIndex2 = this.navParams.get("oldToPathIndex2");
            if (oldFromPathIndex2 && oldToPathIndex2) {
                this.structureValues.lower = oldFromPathIndex2;
                this.structureValues.upper = oldToPathIndex2;
            }
            else {
                this.structureValues.lower = this.structureValues.upper;
                this.structureValues.upper = this.allCoordinates.length - 1;
            }
            this.structureValues.step = "2";
            this.currentStep = 2;
        }
        else {
            this.routeItemEdited = {
                fromPathIndex: this.lastSplittedValue.lower,
                toPathIndex: this.lastSplittedValue.upper,
                fromPathIndex2: this.structureValues.lower,
                toPathIndex2: this.structureValues.upper
            };
            this.viewCtrl.dismiss(this.routeItemEdited);
        }
    };
    ResizeActivityPage.prototype.resizeActivity = function () {
        this.routeItemEdited = {
            fromPathIndex: this.structureValues.lower,
            toPathIndex: this.structureValues.upper
        };
        this.viewCtrl.dismiss(this.routeItemEdited);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("maptoresizeorsplit"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], ResizeActivityPage.prototype, "mapContainer", void 0);
    ResizeActivityPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-resize-activity",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/resize-activity/resize-activity.html"*/'<ion-header>\n  <ion-navbar>\n    <ion-buttons start *ngIf="currentStep == 2">\n      <button class="step-back" ion-button (click)="BackToStep1()">\n        <ion-icon class="arrow-left-icon" name="arrow-back"></ion-icon>{{ "back_button_text" | translate }}\n      </button>\n    </ion-buttons>\n    <ion-title *ngIf="currentStep == 1 && resizeAction === \'split-track\'">{{ "resize_activity_page.step_of_text" | translate }} <span class="number">1</span> {{ "resize_activity_page.of_text" | translate }} <span class="number">2</span></ion-title>\n    <ion-title *ngIf="currentStep == 2 && resizeAction === \'split-track\'">{{ "resize_activity_page.step_of_text" | translate }} <span class="number">2</span> {{ "resize_activity_page.of_text" | translate }} <span class="number">2</span></ion-title>\n    <ion-title *ngIf="resizeAction === \'resize-track\'">{{ "resize_activity_page.resize_activity_button" | translate }}</ion-title>\n    <ion-buttons end>\n      <button ion-button class="close-button-container" (click)="closeModal()">{{ "close_button_text" | translate }}</button>\n    </ion-buttons>\n  </ion-navbar>\n</ion-header>\n\n<ion-content>\n  <div class="resize-activity-container" *ngIf="showMapSlider">\n    <map-slider [targetCoordinates]="allCoordinates" [staticStructure]="structureValues" [hideError]="true" (refreshPath)="doRefreshPath($event)"></map-slider>\n  </div>\n</ion-content>\n\n<ion-footer>\n  <button ion-button block (click)="splitActivity()" *ngIf="currentStep == 1 && resizeAction === \'split-track\'">{{ \'resize_activity_page.split_activity_button_part_1\' | translate }}</button>\n  <button ion-button block (click)="splitActivity()" *ngIf="currentStep == 2 && resizeAction === \'split-track\'">{{ \'resize_activity_page.split_activity_button_part_2\' | translate }}</button>    \n  <button ion-button block (click)="resizeActivity()" *ngIf="resizeAction === \'resize-track\'">{{ \'resize_activity_page.resize_activity_button\' | translate }}</button>    \n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/resize-activity/resize-activity.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], ResizeActivityPage);
    return ResizeActivityPage;
}());

//# sourceMappingURL=resize-activity.js.map

/***/ })

});
//# sourceMappingURL=59.js.map