webpackJsonp([62],{

/***/ 1189:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RecordRideTabsPageModule", function() { return RecordRideTabsPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__record_ride_tabs__ = __webpack_require__(1562);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var RecordRideTabsPageModule = /** @class */ (function () {
    function RecordRideTabsPageModule() {
    }
    RecordRideTabsPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__record_ride_tabs__["a" /* RecordRideTabsPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__record_ride_tabs__["a" /* RecordRideTabsPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], RecordRideTabsPageModule);
    return RecordRideTabsPageModule;
}());

//# sourceMappingURL=record-ride-tabs.module.js.map

/***/ }),

/***/ 1562:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RecordRideTabsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var RecordRideTabsPage = /** @class */ (function () {
    function RecordRideTabsPage(navCtrl, logger, navParams, viewCtrl) {
        this.navCtrl = navCtrl;
        this.logger = logger;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.tab1 = "RecordRideSafetyTrackingPage";
        this.tab2 = "RecordRideLiveTrackingPage";
        this.isLinkLoading = true;
        this.showActivationButton = false;
        this.showCloseButton = true;
        this.isTabInitialized = false;
        this._subscriptionArray = [];
        this.tab1Params = this.navParams.get("safetyTrackingData") || {};
        this.tab2Params = this.navParams.get("liveTrackingData") || {};
        this.tab1Params.viewCtrl = this.viewCtrl;
        this.tab2Params.viewCtrl = this.viewCtrl;
    }
    RecordRideTabsPage.prototype.ionViewDidLoad = function () {
    };
    RecordRideTabsPage.prototype.ionViewDidLeave = function () {
        this._unsubscribeAll();
    };
    RecordRideTabsPage.prototype.initTab = function (index) {
        var _this = this;
        this._unsubscribeAll();
        switch (index) {
            case 1:
                var safetyTracking = this._getInstanceTabActive();
                this.showCloseButton = safetyTracking.showCloseButton;
                this.showActivationButton = safetyTracking.showActivationButton;
                this.isLinkLoading = safetyTracking.isLinkLoading;
                this._subscriptionArray.push(safetyTracking.emitter.subscribe(function (event) { return _this[event.property] = event.value; }));
                break;
            case 2:
                var liveTracking = this._getInstanceTabActive();
                this.showCloseButton = liveTracking.showCloseButton;
                this.showActivationButton = false;
                this.isLinkLoading = false;
                this._subscriptionArray.push(liveTracking.emitter.subscribe(function (event) { return _this[event.property] = event.value; }));
                break;
        }
        this.isTabInitialized = true;
    };
    RecordRideTabsPage.prototype._unsubscribeAll = function () {
        this._subscriptionArray.forEach(function (subscription) { return subscription.unsubscribe(); });
        this._subscriptionArray = [];
    };
    RecordRideTabsPage.prototype._getInstanceTabActive = function () {
        return this.tabsContainer.getActiveChildNavs()[0].getViews()[0].instance;
    };
    RecordRideTabsPage.prototype.startRecording = function () {
        this.logger.debug("[Record ride tabs] start recording");
        this._getInstanceTabActive().startRecording();
    };
    RecordRideTabsPage.prototype.activeLiveTracking = function () {
        this._getInstanceTabActive().activeLiveTracking();
    };
    RecordRideTabsPage.prototype.closePage = function () {
        this.viewCtrl.dismiss();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("tabsContainer"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* Tabs */])
    ], RecordRideTabsPage.prototype, "tabsContainer", void 0);
    RecordRideTabsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-record-ride-tabs',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/record-ride-tabs/record-ride-tabs.html"*/'<ion-tabs #tabsContainer>\n  <ion-tab (ionSelect)="initTab(1)" [root]="tab1" [rootParams]="tab1Params" tabTitle="{{ \'safety_tracking_page.share_tab_title\' | translate}}"></ion-tab>\n  <ion-tab (ionSelect)="initTab(2)" [root]="tab2" [rootParams]="tab2Params" tabTitle="{{ \'safety_tracking_page.shared_with_you_tab_title\' | translate}}"></ion-tab>\n</ion-tabs>\n\n<ion-footer *ngIf="isTabInitialized">\n  <ion-toolbar>\n    <button ion-button round (click)="startRecording()" [disabled]="isLinkLoading" *ngIf="!showCloseButton && !showActivationButton">\n      <span *ngIf="!isLinkLoading" class="big-font">{{ \'safety_tracking_page.start\' | translate }}</span>\n      <span *ngIf="!isLinkLoading" class="icon-whip-fire wp-icon"></span>\n\n      <ion-spinner *ngIf="isLinkLoading"></ion-spinner>\n    </button>\n\n    <button ion-button round (click)="activeLiveTracking()" [disabled]="isLinkLoading" *ngIf="!showCloseButton && showActivationButton">\n      <span *ngIf="!isLinkLoading">{{ \'safety_tracking_page.send_link\' | translate }}</span>\n\n      <ion-spinner *ngIf="isLinkLoading"></ion-spinner>\n    </button>\n\n    <button class="close" ion-button round (click)="closePage()" *ngIf="showCloseButton">\n      <span class="big-font">{{ \'close_button_text\' | translate }}</span>\n    </button>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/record-ride-tabs/record-ride-tabs.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_2__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */]])
    ], RecordRideTabsPage);
    return RecordRideTabsPage;
}());

//# sourceMappingURL=record-ride-tabs.js.map

/***/ })

});
//# sourceMappingURL=62.js.map