webpackJsonp([73],{

/***/ 1174:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OfflineListMapPageModule", function() { return OfflineListMapPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__offline_map_list__ = __webpack_require__(1545);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(595);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var OfflineListMapPageModule = /** @class */ (function () {
    function OfflineListMapPageModule() {
    }
    OfflineListMapPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__offline_map_list__["a" /* OfflineMapListPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__offline_map_list__["a" /* OfflineMapListPage */]),
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* ComponentsModule */]
            ],
        })
    ], OfflineListMapPageModule);
    return OfflineListMapPageModule;
}());

//# sourceMappingURL=offline-map-list.module.js.map

/***/ }),

/***/ 1545:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OfflineMapListPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__turf_turf___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3__turf_turf__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_storage__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger_logger__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_plus_plus__ = __webpack_require__(38);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var MAX_NUMBER_OF_TILES_ALLOWED = 20000;
var OfflineMapListPage = /** @class */ (function () {
    function OfflineMapListPage(navCtrl, navParams, logger, translate, viewCtrl, alertCtrl, ngZone, platform, plusProvider, events, storage, utilsProvider) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.logger = logger;
        this.translate = translate;
        this.viewCtrl = viewCtrl;
        this.alertCtrl = alertCtrl;
        this.ngZone = ngZone;
        this.platform = platform;
        this.plusProvider = plusProvider;
        this.events = events;
        this.storage = storage;
        this.utilsProvider = utilsProvider;
        this.MAP_ID = 0;
        this.POLYGON_SOURCE_ID = "wh-offline-rect";
        this.POLYGON_LAYER_ID = "wh-offline-rect_layer";
        this.offlineRegions = [];
        this.permissionModal = true;
        this.mapReady = false;
        this.isAlertShown = false;
        this.offlineRegionsTotalSize = 0;
        this.isAlertForBigAreaShown = false;
        this.isPlusUser = false;
        this.isAddedPolygon = false;
    }
    OfflineMapListPage.prototype.ionViewDidEnter = function () {
        var _this = this;
        if (this.mapReady) {
            Mapbox.setClickable(false, this.MAP_ID);
        }
        else {
            this.plusProvider.isPlusUser(function (status) {
                _this.isPlusUser = status;
                if (!_this.mapReady) {
                    _this.currentMapStyleSelected = {
                        type: "light",
                        styleURL: _this.utilsProvider.getMapStyleFromType("light", true),
                    };
                    Mapbox.show({
                        domContainer: _this.hiddenMapContainer.nativeElement,
                        style: _this.currentMapStyleSelected.styleURL,
                        cameraPosition: {
                            target: [41.9028, 12.4964],
                            tilt: 0,
                            zoom: 12,
                            maxZoom: 14 // zoom in
                        },
                        sources: [],
                        showUserLocation: false,
                        hideAttribution: true,
                        hideLogo: true,
                        hideCompass: true,
                        disableRotation: false,
                        disableScroll: false,
                        disableZoom: false,
                        disablePitch: true,
                        enableUserTrackingMode: true
                    }, _this.MAP_ID, function () {
                        _this.logger.debug("native map is ready to do some stuff");
                        if (!_this.platform.is('ios')) {
                            // this property serve in initialization phase at the RecordRidePage
                            _this.storage.set('primary_map_style_setted_' + _this.currentMapStyleSelected.type, true);
                        }
                        _this.ngZone.run(function () {
                            _this.mapReady = true;
                        });
                        Mapbox.addOnDidFinishLoadingStyleListener(function () {
                            Mapbox.getBounds(_this.MAP_ID, function (bounds) {
                                _this.ngZone.run(function () {
                                    _this.logger.debug("show box offline");
                                    _this.actualBounds = _this.fromBoundsToRect(bounds);
                                    _this.drawOfflineRect(_this.actualBounds);
                                });
                            });
                        }, _this.MAP_ID);
                        Mapbox.setClickable(false, _this.MAP_ID);
                        Mapbox.getOfflineRegionList(_this.currentMapStyleSelected.styleURL, _this.MAP_ID, function (remoteOfflineRegions) {
                            _this.ngZone.run(function () {
                                if (_this.platform.is("ios")) {
                                    _this.formatOfflineRegionList(remoteOfflineRegions);
                                }
                                else {
                                    for (var _i = 0, remoteOfflineRegions_1 = remoteOfflineRegions; _i < remoteOfflineRegions_1.length; _i++) {
                                        var region = remoteOfflineRegions_1[_i];
                                        _this.formatOfflineRegionList(region);
                                    }
                                }
                            });
                        });
                        var cameraDeBounceTimeout = null;
                        var drawDeBounceTimeout = null;
                        Mapbox.addOnCameraShouldChangeListener(function () {
                            _this.logger.debug("[addOnCameraShouldChangeListener] native map event");
                            if (cameraDeBounceTimeout != null) {
                                clearTimeout(cameraDeBounceTimeout);
                                cameraDeBounceTimeout = null;
                            }
                            if (drawDeBounceTimeout != null) {
                                clearTimeout(drawDeBounceTimeout);
                                drawDeBounceTimeout = null;
                            }
                            cameraDeBounceTimeout = setTimeout(function () {
                                cameraDeBounceTimeout = null;
                                Mapbox.getCenter(function (centerCoordinates) {
                                    Mapbox.easeTo({
                                        duration: 100,
                                        bearing: 0,
                                        pitch: 0,
                                        center: [centerCoordinates.lng, centerCoordinates.lat],
                                        northBlock: true,
                                        moved: true
                                    });
                                    drawDeBounceTimeout = setTimeout(function () {
                                        drawDeBounceTimeout = null;
                                        Mapbox.getBounds(function (bounds) {
                                            _this.ngZone.run(function () {
                                                _this.logger.debug("show box offline");
                                                _this.actualBounds = _this.fromBoundsToRect(bounds);
                                                _this.drawOfflineRect(_this.actualBounds);
                                            });
                                        });
                                    });
                                }, 500);
                            }, 200);
                        }, _this.MAP_ID);
                    }, function (err) {
                        _this.logger.debug("error to show native map", err);
                        _this.ngZone.run(function () {
                            _this.mapReady = true;
                        });
                    });
                }
            }, "OfflineMapListPage");
        }
    };
    OfflineMapListPage.prototype.drawOfflineRect = function (bounds) {
        var _this = this;
        var rect = [bounds.nw, bounds.ne, bounds.se, bounds.sw, bounds.nw];
        if (this.isAddedPolygon) {
            Mapbox.removeLayer(this.POLYGON_LAYER_ID, this.MAP_ID);
            Mapbox.removeSource(this.POLYGON_SOURCE_ID, this.MAP_ID);
        }
        var geoJsonOfflineRect = {
            type: "geojson",
            data: {
                type: "FeatureCollection",
                features: [
                    {
                        type: "Feature",
                        geometry: {
                            type: "Polygon",
                            coordinates: [rect],
                        },
                    },
                ],
            },
        };
        Mapbox.addSource(this.POLYGON_SOURCE_ID, geoJsonOfflineRect, this.MAP_ID, function (_done) {
            console.log("add source on map offline --> ", geoJsonOfflineRect);
            Mapbox.addLayer({
                id: _this.POLYGON_LAYER_ID,
                type: "fill",
                source: _this.POLYGON_SOURCE_ID,
                layout: {},
                paint: {
                    "fill-color": "#0000FF",
                    "fill-opacity": 0.2,
                },
            }, _this.MAP_ID);
        });
        this.isAddedPolygon = true;
    };
    OfflineMapListPage.prototype.fromBoundsToRect = function (bounds) {
        var boxBounds = {};
        var topHoriz = this._findBoxLine(bounds.nw, bounds.ne, 45);
        var lineArray = [topHoriz[0], topHoriz[1]];
        var lineString = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["lineString"](lineArray);
        var lineLength = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["length"](lineString, { units: 'kilometers' });
        console.log("ne lineLength", lineLength);
        var rightVert = this._findBoxLine(bounds.ne, bounds.se, Math.min(lineLength, 45));
        var nw = topHoriz[0];
        var ne = topHoriz[1];
        var ne2 = rightVert[0];
        var se = rightVert[1];
        var sw = JSON.parse(JSON.stringify(rightVert[1]));
        nw.splice(1, 1, ne2[1]);
        ne.splice(1, 1, ne2[1]);
        se.splice(0, 1, ne[0]);
        sw.splice(0, 1, nw[0]);
        boxBounds.nw = nw;
        boxBounds.ne = ne;
        boxBounds.se = se;
        boxBounds.sw = sw;
        return boxBounds;
    };
    OfflineMapListPage.prototype._findBoxLine = function (from, to, maxKm) {
        var lineArray = [from, to];
        var lineString = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["lineString"](lineArray);
        var lineLength = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["length"](lineString, { units: 'kilometers' });
        var originalLineLength = lineLength;
        var boxLineLength = lineLength * 0.8;
        if (boxLineLength > maxKm) {
            boxLineLength = maxKm;
        }
        console.log("boxLineLength", boxLineLength, "(originalLineLength - boxLineLength)/2", (originalLineLength - boxLineLength) / 2);
        var firstBoxPoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["along"](lineString, ((originalLineLength - boxLineLength) / 2), { units: 'kilometers' });
        var secondBoxPoint = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["along"](lineString, (((originalLineLength - boxLineLength) / 2) + boxLineLength), { units: 'kilometers' });
        return [firstBoxPoint.geometry.coordinates, secondBoxPoint.geometry.coordinates];
    };
    OfflineMapListPage.prototype.ionViewWillUnload = function () {
        Mapbox.removeListener("isChangingListener", this.MAP_ID);
        Mapbox.destroy(this.MAP_ID);
        this.plusProvider.removePlusStateListener("OfflineMapListPage");
        this.events.unsubscribe("offline_map_style: changed");
        this.unregisterBackButtonAction();
    };
    OfflineMapListPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.calculateOccupiedPacksSpace();
        this.initializeBackButtonCustomHandler();
        this.events.subscribe("offline_map_style: changed", function (mapStyle) {
            _this.currentMapStyleSelected = mapStyle;
        });
    };
    OfflineMapListPage.prototype.initializeBackButtonCustomHandler = function () {
        var _this = this;
        this.unregisterBackButtonAction = this.platform.registerBackButtonAction(function (event) {
            if (_this.mapReady) {
                _this.onCloseModal();
            }
        }, 101);
    };
    OfflineMapListPage.prototype.goToFullMapPage = function () {
        var _this = this;
        var onStartDownloadRegion = function (regionInfo) {
            return new Promise(function (resolve) {
                if (regionInfo) {
                    Mapbox.getBounds(_this.MAP_ID, function (quadBounds) {
                        Mapbox.getZoom(_this.MAP_ID, function (currentZoom) {
                            Mapbox.getCameraPosition(_this.MAP_ID, function (cameraPosition) {
                                quadBounds = _this.actualBounds;
                                if (!quadBounds) {
                                    resolve({});
                                }
                                else {
                                    var lineArray = [quadBounds.nw, quadBounds.ne];
                                    var lineString = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["lineString"](lineArray);
                                    var lineLength = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["length"](lineString, { units: 'kilometers' });
                                    var saveZoomLevel = 14;
                                    if (lineLength > 15) {
                                        saveZoomLevel = 13;
                                    }
                                    if (lineLength > 40) {
                                        saveZoomLevel = 12;
                                    }
                                    if (lineLength > 50) {
                                        saveZoomLevel = 11;
                                    }
                                    if (lineLength > 100) {
                                        saveZoomLevel = 5;
                                    }
                                    console.log("saveZoomLevel", saveZoomLevel, "lineLength", lineLength);
                                    Mapbox.downloadRegion({
                                        toZoomLevel: saveZoomLevel,
                                        sw: quadBounds.sw,
                                        ne: quadBounds.ne,
                                        styleUrl: regionInfo.styleUrl,
                                        regionInfo: {
                                            id: __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].IDGenerator(),
                                            name: regionInfo.name,
                                            style: regionInfo.style,
                                            center: regionInfo.center,
                                            zoom: currentZoom,
                                            sw: quadBounds.sw,
                                            ne: quadBounds.ne,
                                            se: quadBounds.se,
                                            nw: quadBounds.nw,
                                            bearing: Math.abs(cameraPosition.bearing),
                                        },
                                    }, _this.MAP_ID, function (_statusProgress) {
                                        _this.ngZone.run(function () {
                                            if (_statusProgress.region_id) {
                                                _this.formatOfflineRegionList(_statusProgress);
                                            }
                                        });
                                    }, function (_errorDownload) {
                                        _this.logger.debug("download progress error", _errorDownload);
                                    });
                                }
                            });
                        });
                    }, function (error) {
                        _this.logger.debug("[getBounds] error", error);
                    });
                }
                resolve({});
            });
        };
        if (this.mapReady) {
            setTimeout(function () {
                Mapbox.getBounds(_this.MAP_ID, function (bounds) {
                    _this.ngZone.run(function () {
                        _this.logger.debug("show box offline");
                        _this.actualBounds = _this.fromBoundsToRect(bounds);
                        _this.drawOfflineRect(_this.actualBounds);
                    });
                });
            }, 500);
        }
        this.navCtrl.push("GetOfflineMapPage", {
            showContainer: "map",
            callback: onStartDownloadRegion,
            mapStyleObj: this.currentMapStyleSelected,
        });
    };
    OfflineMapListPage.prototype.onCloseModal = function () {
        var _this = this;
        var alert = this.alertCtrl.create({
            title: this.translate.instant("offline_map_list_page.alert_title_close_page"),
            subTitle: this.translate.instant("offline_map_list_page.alert_subtitle_close_page"),
            buttons: [
                {
                    text: this.translate.instant("offline_map_list_page.alert_close_page_button"),
                    handler: function () {
                        _this.viewCtrl.dismiss();
                    },
                },
                {
                    text: this.translate.instant("offline_map_list_page.wait_button"),
                    role: "cancel",
                },
            ],
        });
        var downloadingOfflinePack = this.offlineRegions.find(function (_item) { return _item.region_state === "active"; });
        if (this.offlineRegions.length && downloadingOfflinePack) {
            alert.present();
        }
        else {
            this.viewCtrl.dismiss();
        }
    };
    OfflineMapListPage.prototype.formatOfflineRegionList = function (remoteOfflineRegion) {
        var _this = this;
        if (!this.offlineRegions.length) {
            this.offlineRegions.push(remoteOfflineRegion);
        }
        // first check if that region is already added, in case added it
        var isAlreadyRegionAdded = this.offlineRegions.find(function (_item) {
            return _item.region_id === remoteOfflineRegion.region_id;
        });
        if (!isAlreadyRegionAdded) {
            this.offlineRegions.push(remoteOfflineRegion);
        }
        // then i'm sure that all remote regions is added and now elabourate them
        var localOfflineRegion = this.offlineRegions.find(function (_item) {
            return _item.region_id === remoteOfflineRegion.region_id;
        });
        localOfflineRegion.region_state = remoteOfflineRegion.region_state;
        localOfflineRegion.download_progress =
            remoteOfflineRegion.download_progress;
        localOfflineRegion.count_of_bytes = remoteOfflineRegion.count_of_bytes;
        localOfflineRegion.lower_resources_expected =
            remoteOfflineRegion.lower_resources_expected;
        if (!localOfflineRegion.squareKm) {
            var topLeft = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([
                localOfflineRegion.nw[0],
                localOfflineRegion.nw[1],
            ]);
            var bottomLeft = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([
                localOfflineRegion.sw[0],
                localOfflineRegion.sw[1],
            ]);
            var height = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](topLeft, bottomLeft, {
                units: "kilometers",
            });
            var bottomRight = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["point"]([
                localOfflineRegion.se[0],
                localOfflineRegion.se[1],
            ]);
            var width = __WEBPACK_IMPORTED_MODULE_3__turf_turf__["distance"](bottomLeft, bottomRight, {
                units: "kilometers",
            });
            localOfflineRegion.squareKm = (height * width).toFixed(2) + " km²";
        }
        if (!localOfflineRegion.styleUrlName) {
            localOfflineRegion.styleUrlName = this.getMapNameFromMapType(localOfflineRegion.style_url);
        }
        if (!localOfflineRegion.coverImage) {
            var aspectRatio = this.content.contentHeight / this.content.contentWidth;
            var mapStyle = localOfflineRegion.style_url;
            var longitude = localOfflineRegion.center_coordinates.lng;
            var latitude = localOfflineRegion.center_coordinates.lat;
            var zoom = Math.floor(localOfflineRegion.zoom_level);
            var width = 300;
            var height = (300 * aspectRatio).toFixed(0);
            if (localOfflineRegion.style_url.includes("opencycle") ||
                localOfflineRegion.style_url.includes("topographic") ||
                localOfflineRegion.style_url.includes("transport")) {
                if (localOfflineRegion.style_url.includes("opencycle"))
                    mapStyle = "cycle";
                if (localOfflineRegion.style_url.includes("topographic"))
                    mapStyle = "outdoors";
                if (localOfflineRegion.style_url.includes("transport"))
                    mapStyle = "transport";
                localOfflineRegion.coverImage =
                    "https://tile.thunderforest.com/static/" +
                        mapStyle +
                        "/" +
                        longitude +
                        "," +
                        latitude +
                        "," +
                        zoom +
                        "/" +
                        width +
                        "x" +
                        height +
                        "@2x.png?apikey=" +
                        __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].THUNDERFOREST_ACCESS_TOKEN;
            }
            else {
                var openMapTileStyleUrl = void 0;
                switch (localOfflineRegion.style_url) {
                    case "outdoors":
                        openMapTileStyleUrl = __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].getOutdoorsMapUrl();
                        break;
                    case "dark":
                        openMapTileStyleUrl = __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].getDarkMapUrl();
                        break;
                    case "light":
                        openMapTileStyleUrl = __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].getLightMapUrl();
                        break;
                }
                localOfflineRegion.coverImage =
                    openMapTileStyleUrl +
                        "/static/" +
                        longitude +
                        "," +
                        latitude +
                        "," +
                        zoom +
                        "/" +
                        width +
                        "x" +
                        height +
                        "@2x.png?key=LbuJldUW3nrvEh4z7PUF";
            }
        }
        if (localOfflineRegion.lower_resources_expected >=
            MAX_NUMBER_OF_TILES_ALLOWED &&
            localOfflineRegion.region_state === "active") {
            if (!this.isAlertForBigAreaShown) {
                this.isAlertForBigAreaShown = true;
                Mapbox.pauseDownload(this.MAP_ID, this.offlineRegions[this.offlineRegions.length - 1], function (_pauseSuccess) {
                    _this.logger.debug("forced stop because this pack is too big", _this.offlineRegions[_this.offlineRegions.length - 1]);
                });
                var alert_1 = this.alertCtrl.create({
                    title: this.translate.instant("offline_map_list_page.alert_title_max_limit_reached"),
                    subTitle: this.translate.instant("offline_map_list_page.alert_subtitle_max_tiles_reached", {
                        regionName: localOfflineRegion.region_name,
                        mapStyle: localOfflineRegion.styleUrlName,
                    }),
                    enableBackdropDismiss: false,
                    buttons: [
                        {
                            text: this.translate.instant("offline_map_list_page.alert_button_delete_big_region"),
                            handler: function () {
                                Mapbox.deleteOfflineRegion({ region_id: localOfflineRegion.region_id }, _this.MAP_ID, function (_removeSuccess) {
                                    _this.logger.debug("forced remove area");
                                    _this.ngZone.run(function () {
                                        _this.offlineRegions.splice(_this.offlineRegions.length - 1, 1);
                                        _this.isAlertForBigAreaShown = false;
                                    });
                                }, function (_removeError) {
                                    _this.logger.debug("remove offline zone error");
                                });
                            },
                        },
                    ],
                });
                alert_1.present();
            }
        }
        this.logger.debug("VEDIAMO I PACCHETTI OFFLINE", this.offlineRegions);
        this.calculateOccupiedPacksSpace();
    };
    OfflineMapListPage.prototype.getMapNameFromMapType = function (styleURL) {
        if (styleURL.includes("outdoors")) {
            return this.translate.instant("offline_map_list_page.outdoors_map_type");
        }
        else if (styleURL.includes("satellite")) {
            return this.translate.instant("offline_map_list_page.satellite_map_type");
        }
        else if (styleURL.includes("light")) {
            return this.translate.instant("offline_map_list_page.osm_style_map");
        }
        else if (styleURL.includes("dark")) {
            return this.translate.instant("offline_map_list_page.dark_map_type");
        }
        else if (styleURL.includes("opencycle")) {
            return this.translate.instant("offline_map_list_page.open_cycle_map_style");
        }
        else if (styleURL.includes("topographic")) {
            return this.translate.instant("offline_map_list_page.topographic_map_style");
        }
        else if (styleURL.includes("transport")) {
            return this.translate.instant("offline_map_list_page.transport_map_style");
        }
    };
    OfflineMapListPage.prototype.offlineRegionCardCLick = function (e) {
        var _this = this;
        if (e.stopClicked) {
            Mapbox.pauseDownload(e.updateRegion, this.MAP_ID, function (_pauseSuccess) {
                _this.logger.debug("[stop download] region stopped success", _pauseSuccess);
                _this.ngZone.run(function () {
                    if (!_this.platform.is("ios")) {
                        e.updateRegion.region_state = "inactive";
                        _this.formatOfflineRegionList(e.updateRegion);
                    }
                });
            });
        }
        else if (e.resumeClicked) {
            Mapbox.resumeDownload(e.updateRegion, this.MAP_ID, function (updateRegionsCallback) {
                _this.logger.debug("[resume download] region resumed success", updateRegionsCallback);
                if (!_this.platform.is("ios")) {
                    _this.ngZone.run(function () {
                        _this.formatOfflineRegionList(updateRegionsCallback);
                    });
                }
            });
        }
        else {
            var onClosePage = function (deleteThisArea) {
                return new Promise(function (resolve, reject) {
                    if (deleteThisArea) {
                        _this.offlineRegions.splice(e.index, 1);
                        _this.calculateOccupiedPacksSpace();
                    }
                    resolve(null);
                });
            };
            this.navCtrl.push("GetOfflineMapPage", {
                showContainer: "region-detail",
                region: e.regionClicked,
                callback: onClosePage,
            });
        }
    };
    OfflineMapListPage.prototype.calculateOccupiedPacksSpace = function () {
        this.offlineRegionsTotalSize = 0;
        for (var _i = 0, _a = this.offlineRegions; _i < _a.length; _i++) {
            var pack = _a[_i];
            if (pack.raw_bytes) {
                this.offlineRegionsTotalSize += pack.raw_bytes;
            }
        }
        this.offlineRegionsTotalSize = __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */].formatBytes(this.offlineRegionsTotalSize);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("hiddenmap"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], OfflineMapListPage.prototype, "hiddenMapContainer", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */])
    ], OfflineMapListPage.prototype, "content", void 0);
    OfflineMapListPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-offline-map-list",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/offline-map-list/offline-map-list.html"*/'<ion-header>\n  <ion-toolbar>\n    <ion-navbar hideBackButton>\n      <ion-buttons start>\n        <button back ion-button (click)="onCloseModal()" [disabled]="!mapReady">{{"offline_map_list_page.close_button" | translate}}</button>\n      </ion-buttons>\n    </ion-navbar>\n  </ion-toolbar>\n</ion-header>\n\n<ion-content class="offlinemap-content">\n  <h1 class="title">{{ "offline_map_list_page.title" | translate }}</h1>\n\n  <div #hiddenmap ion-fixed class="map-container"></div>\n\n  <ion-item class="occupied-space-offline-regions-container">\n    <span class="key">{{"offline_map_list_page.offline_region_occupied_space" | translate}}</span>\n    <span class="value">{{offlineRegionsTotalSize}}</span>\n  </ion-item>\n\n  <div class="empty-regions-container" *ngIf="offlineRegions.length == 0">\n    <p [innerHTML]="\'offline_map_list_page.empty_regions_text\' | translate"></p>\n  </div>\n\n  <div class="list-regions-container">\n    <offline-item [pack]="region" [packIndex]="i" (onOfflineRegionCLick)="offlineRegionCardCLick($event)" *ngFor="let region of offlineRegions; index as i;"></offline-item>\n  </div>\n</ion-content>\n\n<ion-footer>\n  <ion-toolbar>\n    <button ion-button block (click)="goToFullMapPage()" [disabled]="!mapReady">\n      <span *ngIf="mapReady">{{ "offline_map_list_page.button_footer" | translate }}</span>\n      <span *ngIf="!mapReady">{{ "offline_map_list_page.loading" | translate }}</span>\n    </button>\n  </ion-toolbar>\n</ion-footer>'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/offline-map-list/offline-map-list.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_5__providers_logger_logger__["a" /* LoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_7__providers_plus_plus__["a" /* PlusProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* Events */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* UtilsProvider */]])
    ], OfflineMapListPage);
    return OfflineMapListPage;
}());

//# sourceMappingURL=offline-map-list.js.map

/***/ })

});
//# sourceMappingURL=73.js.map