webpackJsonp([84],{

/***/ 1157:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LapPageModule", function() { return LapPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__lap__ = __webpack_require__(1526);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var LapPageModule = /** @class */ (function () {
    function LapPageModule() {
    }
    LapPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__lap__["a" /* LapPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__lap__["a" /* LapPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], LapPageModule);
    return LapPageModule;
}());

//# sourceMappingURL=lap.module.js.map

/***/ }),

/***/ 1526:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LapPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_convert_metrics_convert_metrics__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_activity_controller_activity_controller__ = __webpack_require__(597);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger_logger__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_highcharts__ = __webpack_require__(224);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_highcharts___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_highcharts__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var LapPage = /** @class */ (function () {
    function LapPage(navCtrl, navParams, viewCtrl, metrics, activityCtrl, logger) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.metrics = metrics;
        this.activityCtrl = activityCtrl;
        this.logger = logger;
        this.generalObj = {};
        this.formattedLaps = [];
        this.loading = true;
        this.displayDurationArray = [];
        this.yAxisValues = [];
        this.categories = [];
        this.graphReady = false;
        this.hasPlotBand = false;
        this.fromPage = "";
    }
    LapPage.prototype.ionViewWillEnter = function () {
        if (this.session) {
            var backText = this.activityCtrl.getCurrentSession(this.session)
                .activityTitle;
            this.viewCtrl.setBackButtonText(backText);
        }
    };
    LapPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.pageTitle = this.navParams.get("pageTitle");
        this.session = this.navParams.get("session");
        if (this.session) {
            this.generalObj = this.activityCtrl.getCurrentSession(this.session).laps;
        }
        else {
            this.generalObj = this.navParams.get("history");
        }
        if (this.navParams.get("fromPage")) {
            this.fromPage = this.navParams.get("fromPage");
        }
        this.logger.debug("element in LapPage", this.generalObj);
        this.generalObj.displayReferenceTime = [];
        this.diffFromBestTime();
        this.formattedLapsForSeries();
        this.addCategories();
        this.loading = false;
        setTimeout(function () {
            _this.formatHeader();
            // general height of vh, includes marginTop and marginBottom
            var generalHeight = Math.round(_this.content.getContentDimensions().contentHeight / 2);
            var scrollContentHeight = Math.round(_this.content.getContentDimensions().contentHeight / 2);
            var generalWidth = _this.content.getContentDimensions().contentWidth;
            // possible items visibles in avaiable scroll content height
            var possibleItemVisible = Math.floor(scrollContentHeight / 45);
            if (_this.formattedLaps.length < possibleItemVisible) {
                _this.listItemHeight = 45 + "px";
                _this.content._scrollContent.nativeElement.style.top =
                    generalHeight + "px";
                _this.chartHeight = generalHeight - 70 + "px";
                _this.content._fixedContent.nativeElement.children[1].style.height = _this.chartHeight;
                _this.chartWidth = generalWidth;
            }
            else if (_this.formattedLaps.length == possibleItemVisible) {
                var morePixel = Math.round(scrollContentHeight % 45);
                scrollContentHeight += morePixel;
                // style's scrollContent
                _this.content._scrollContent.nativeElement.style.top =
                    generalHeight - morePixel + "px";
                // recalculate more pixel to fit exactly item in list
                morePixel = Math.round(scrollContentHeight % 45);
                _this.listItemHeight = 45 + morePixel / possibleItemVisible + "px";
                // chart's height and leftAxis' height; 70 is the header's width
                var fixedContentHeight = _this.content.getContentDimensions().contentHeight -
                    scrollContentHeight;
                _this.chartHeight = fixedContentHeight - 70 + "px";
                _this.content._fixedContent.nativeElement.children[1].style.height = _this.chartHeight;
                _this.plotBandWidth = generalWidth / possibleItemVisible;
                _this.chartWidth = generalWidth;
            }
            else if (_this.formattedLaps.length > possibleItemVisible) {
                var morePixel = Math.round(scrollContentHeight % 45);
                scrollContentHeight += morePixel;
                // style's scrollContent
                _this.content._scrollContent.nativeElement.style.top =
                    generalHeight - morePixel + "px";
                // recalculate more pixel to fit exactly item in list
                morePixel = Math.round(scrollContentHeight % 45);
                _this.listItemHeight = 45 + morePixel / possibleItemVisible + "px";
                // chart's height and leftAxis' height; 70 is the header's width
                var fixedContentHeight = _this.content.getContentDimensions().contentHeight -
                    scrollContentHeight;
                _this.chartHeight = fixedContentHeight - 70 + "px";
                _this.content._fixedContent.nativeElement.children[1].style.height = _this.chartHeight;
                _this.plotBandWidth = generalWidth / possibleItemVisible;
                _this.chartWidth = _this.formattedLaps.length * _this.plotBandWidth;
            }
            _this._initChart();
            _this.graphReady = true;
            _this.chart.addScrollEventListener(function (e) {
                _this.scrollList(e.target.scrollLeft);
            });
        }, 300);
    };
    LapPage.prototype.diffFromBestTime = function () {
        for (var _i = 0, _a = this.generalObj.referenceData; _i < _a.length; _i++) {
            var item = _a[_i];
            if (item.duration == null) {
                item.displayDiffFromReferenceTime = "";
            }
            else {
                item.diffFromReferenceTime =
                    item.duration - (this.generalObj.bestReferenceTime
                        ? this.generalObj.bestReferenceTime
                        : this.generalObj.referenceTime);
                if (item.diffFromReferenceTime < 0) {
                    item.displayDiffFromReferenceTime =
                        "- " +
                            this.metrics.getDisplayTime(Math.abs(item.diffFromReferenceTime), true);
                    item.color = "#00ffa8";
                }
                else if (item.diffFromReferenceTime > 0) {
                    item.displayDiffFromReferenceTime =
                        "+ " +
                            this.metrics.getDisplayTime(item.diffFromReferenceTime, true);
                    item.color = "red";
                }
                else if (item.diffFromReferenceTime == 0) {
                    item.displayDiffFromReferenceTime = "-";
                    item.color = "#B0B3CC";
                }
            }
        }
    };
    LapPage.prototype.formatHeader = function () {
        this.subtitle.nativeElement.innerHTML = this.generalObj.subtitle;
        var displayReferenceTime = this.metrics.getDisplayTime(this.generalObj.bestReferenceTime
            ? this.generalObj.bestReferenceTime
            : this.generalObj.referenceTime, true);
        this.generalObj.displayReferenceTime = this.metrics.getArrayDurationPreciseFromDisplayDuration(displayReferenceTime);
    };
    LapPage.prototype.formattedLapsForSeries = function () {
        for (var _i = 0, _a = this.generalObj.referenceData; _i < _a.length; _i++) {
            var item = _a[_i];
            if (item.duration) {
                var displayDuration = this.metrics.getDisplayTime(item.duration, true);
                item.displayDuration = this.metrics.getArrayDurationPreciseFromDisplayDuration(displayDuration);
            }
            this.formattedLaps.push([item.displayName, item.duration]);
            item.select = false;
        }
    };
    LapPage.prototype.addCategories = function () {
        for (var _i = 0, _a = this.generalObj.referenceData; _i < _a.length; _i++) {
            var item = _a[_i];
            this.categories.push(item.title);
        }
    };
    LapPage.prototype.onSelectItemListChart = function (index) {
        var _this = this;
        if (this.prevIndex == undefined) {
            this.generalObj.referenceData[index].select = true;
        }
        else {
            if (index !== this.prevIndex) {
                this.generalObj.referenceData[index].select = true;
                this.generalObj.referenceData[this.prevIndex].select = false;
            }
        }
        if (this.hasPlotBand) {
            this.graph.xAxis[0].removePlotBand("plot-band-wh" + this.prevIndex);
            this.hasPlotBand = false;
        }
        if (!this.hasPlotBand) {
            setTimeout(function () {
                _this.graph.xAxis[0].addPlotBand({
                    from: -0.5 + index,
                    to: 0.5 + index,
                    color: "#006663",
                    id: "plot-band-wh" + index,
                });
                _this.hasPlotBand = true;
            }, 200);
        }
        this.prevIndex = index;
        this.hasPlotBand = !this.hasPlotBand;
    };
    LapPage.prototype.goToSegment = function (segment) {
        if (this.generalObj.seeActivityOfMatching) {
            this.navCtrl.push("ActivityPage", {
                currentActivity: { id: segment.referenceSegment.activity_id },
            });
        }
        else {
            var activityName = this.activityCtrl.getCurrentSession(this.session)
                .activityTitle;
            var user = this.activityCtrl.getCurrentSession(this.session).user;
            this.activityCtrl.setCurrentSessionSegmentData(this.session, segment.referenceSegment, activityName, user);
            this.navCtrl.push("SegmentPage", { session: this.session });
        }
    };
    LapPage.prototype.scrollListEvent = function (e) {
        this.scrollGraph(e.scrollTop);
    };
    LapPage.prototype.scrollList = function (scroll) {
        var index = this.listItemHeight.indexOf("p");
        var listItem = parseFloat(this.listItemHeight.substring(0, index));
        var multiply = listItem / this.plotBandWidth;
        var pixel = scroll * multiply;
        this.content._elementRef.nativeElement.children[1].scrollTop = Math.round(pixel);
    };
    LapPage.prototype.scrollGraph = function (scroll) {
        var index = this.listItemHeight.indexOf("p");
        var listItem = parseFloat(this.listItemHeight.substring(0, index));
        var multiply = this.plotBandWidth / listItem;
        var pixel = scroll * multiply;
        this.chart._scrollContent.nativeElement.scrollLeft = Math.round(pixel);
    };
    LapPage.prototype._initChart = function () {
        var _t = this;
        this.graph = __WEBPACK_IMPORTED_MODULE_5_highcharts__["chart"](this.graphlaps.nativeElement, {
            chart: {
                height: _t.chartHeight,
                width: _t.chartWidth,
                margin: [0, 10, 10, 50],
            },
            title: {
                text: null,
            },
            subtitle: {
                text: null,
            },
            legend: {
                enabled: false,
            },
            tooltip: {
                enabled: false,
            },
            credits: {
                enabled: false,
            },
            yAxis: {
                reversed: true,
                gridLineWidth: 0,
                labels: {
                    formatter: function () {
                        var value = _t.metrics.getDisplayTime(this.value, true);
                        var pointIndex = value.indexOf(".");
                        value = value.substring(0, pointIndex);
                        _t.yAxisValues.push(value);
                    },
                },
                title: {
                    text: null,
                },
            },
            xAxis: {
                gridLineWidth: 0,
                categories: _t.categories,
                tickColor: "transparent",
                lineColor: "transparent",
                labels: {
                    enabled: false,
                },
                title: {
                    text: null,
                },
            },
            series: [
                {
                    type: "spline",
                    color: "#B0B3CC",
                    data: _t.formattedLaps,
                    events: {
                        click: function (e) {
                            _t.onSelectItemListChart(e.point.index);
                        },
                    },
                },
            ],
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("graphlaps"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], LapPage.prototype, "graphlaps", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("chart"),
        __metadata("design:type", Object)
    ], LapPage.prototype, "chart", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Content */])
    ], LapPage.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])("subtitle"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], LapPage.prototype, "subtitle", void 0);
    LapPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: "page-lap",template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/lap/lap.html"*/'<ion-header>\n\n  <ion-navbar>\n    <ion-title *ngIf="pageTitle">{{pageTitle}}</ion-title>\n  </ion-navbar>\n\n</ion-header>\n\n\n<ion-content (ionScroll)="scrollListEvent($event)">\n\n	<ion-spinner ion-fixed class="center" *ngIf="loading"></ion-spinner>\n	\n	<div class="content-header" *ngIf="!loading" ion-fixed>\n		<div #subtitle id="subtitle"></div>\n		<div class="title">{{ generalObj.title }}</div>\n		<div class="badge-container">\n			<span class="text">{{ generalObj.badgeTitle }}</span>&nbsp;\n			<span class="total-time">{{ generalObj.displayReferenceTime[0] }}</span><span class="tenths-time">{{ generalObj.displayReferenceTime[1] }}</span>\n		</div>\n	</div>\n\n  <div #leftaxis *ngIf="!loading" ion-fixed class="y-axis-left">\n		<div class="item-left" *ngFor="let item of yAxisValues;">{{item}}</div>\n	</div>\n	<ion-scroll *ngIf="!loading" #chart name="chart" scrollX="true" class="general-container" [ngStyle]="{ \'height\': chartHeight }" ion-fixed>\n    <div class="chart-container">\n      <div #graphlaps class="graphic-statistic"></div>\n    </div>\n  </ion-scroll>\n  \n  <div *ngIf="!loading" class="splits-container">\n    <button ion-item *ngFor="let item of generalObj.referenceData; index as i" (click)="onSelectItemListChart(i)" [ngClass]="{\'lap-selected\': item.select}" [disabled]="!graphReady || !item.duration" [style.height]="listItemHeight">\n			<div class="info-container" [ngClass]="{\'pause-container\': !item.duration}">\n				<div class="text-wrapper">{{ item.title }}</div>\n				<div class="time" [ngClass]="{\'no-transition\': !item.referenceSegment.id}">\n					<p *ngIf="item.displayDuration" class="time-text"><span>{{ item.displayDuration[0] }}</span><span>{{ item.displayDuration[1] }}</span></p>\n					<p class="diff" [style.color]="item.color">{{ item.displayDiffFromReferenceTime }}</p>\n				</div>\n			</div>\n			<div *ngIf="item.referenceSegment.id || fromPage !== \'newsegment\'" class="segment-button-container" [ngClass]="{\'show-button-segment-detail\': item.select}">\n				<button *ngIf="item.type === \'lap\'" ion-button outline (click)="goToSegment(item)">{{\'laps_page.segment_detail\' | translate}}</button>\n				<button *ngIf="item.type === \'segment\'" ion-button outline (click)="goToSegment(item)">{{\'laps_page.leaderboard_text\' | translate}}</button>\n			</div>\n		</button>\n  </div>\n\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/lap/lap.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* ViewController */],
            __WEBPACK_IMPORTED_MODULE_2__providers_convert_metrics_convert_metrics__["a" /* ConvertMetricsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_activity_controller_activity_controller__["a" /* ActivityControllerProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_logger_logger__["a" /* LoggerProvider */]])
    ], LapPage);
    return LapPage;
}());

//# sourceMappingURL=lap.js.map

/***/ })

});
//# sourceMappingURL=84.js.map