webpackJsonp([96],{

/***/ 1138:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FollowersFollowingPageModule", function() { return FollowersFollowingPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__followers_following__ = __webpack_require__(1469);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var FollowersFollowingPageModule = /** @class */ (function () {
    function FollowersFollowingPageModule() {
    }
    FollowersFollowingPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__followers_following__["a" /* FollowersFollowingPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* ComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_4__followers_following__["a" /* FollowersFollowingPage */]),
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ]
        })
    ], FollowersFollowingPageModule);
    return FollowersFollowingPageModule;
}());

//# sourceMappingURL=followers-following.module.js.map

/***/ }),

/***/ 1469:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FollowersFollowingPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_user_social_user_social__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__ = __webpack_require__(10);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var FollowersFollowingPage = /** @class */ (function () {
    function FollowersFollowingPage(navCtrl, navParams, social, logger) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.social = social;
        this.logger = logger;
        this.name = {};
        this.isFollowers = false;
    }
    FollowersFollowingPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.isFollowers = this.navParams.get('isFollowers');
        this.name = { name: this.navParams.get('name') };
        this.externalUserId = this.navParams.get('externalUserId');
        this.loading = true;
        this.showNoInternetContainer = false;
        if (this.isFollowers) {
            this.social.getUserFollowers(this.externalUserId).then(function (list) {
                _this.logger.debug("get followers -> success", list);
                _this.listSocial = list;
                _this.loading = false;
            }).catch(function (error) {
                _this.logger.debug("get followers -> error", error);
                _this.loading = false;
            });
        }
        else {
            this.social.getUserFollowing(this.externalUserId).then(function (list) {
                _this.logger.debug("get following -> success", list);
                _this.listSocial = list;
                _this.loading = false;
            }).catch(function (error) {
                _this.logger.debug("get following -> error", error);
                _this.loading = false;
            });
        }
    };
    FollowersFollowingPage.prototype.doSocialListRefresh = function (index) {
        //this.listSocial.splice(index, 1);
    };
    FollowersFollowingPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-followers-following',template:/*ion-inline-start:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/followers-following/followers-following.html"*/'<ion-header>\n\n  <ion-navbar>\n    <ion-title *ngIf="isFollowers">\n      <div [innerHTML]="\'followears_following_page.title_followers\' | translate:name"></div>\n    </ion-title>\n    <ion-title *ngIf="!isFollowers">\n      <div [innerHTML]="\'followears_following_page.title_following\' | translate:name"></div>\n    </ion-title>\n  </ion-navbar>\n\n</ion-header>\n\n\n<ion-content>\n\n  <ion-spinner class="center" *ngIf="loading"></ion-spinner>\n\n  <div class="list-container" *ngIf="!loading">\n    <ion-list *ngIf="listSocial">\n      <ion-item *ngFor="let user of listSocial; index as i">\n        <ion-thumbnail item-start>\n          <user-link [user]="user">\n            <img src="{{user.avatar}}">\n          </user-link>\n        </ion-thumbnail>\n        <div class="user-button-container">\n          <user-link [user]="user">\n            <h2 class="truncate-text">{{ user.first_name }}&nbsp;{{ user.last_name }}</h2>\n          </user-link>\n          <social-button [profile]="user" (socialRefresh)="doSocialListRefresh(i)"></social-button>\n        </div>\n      </ion-item>\n    </ion-list>\n    <div *ngIf="listSocial" class="no-follower-following">\n      <p *ngIf="listSocial.length == 0 && isFollowers">{{ \'followears_following_page.no_followers\' | translate }}</p>\n      <p *ngIf="listSocial.length == 0 && !isFollowers">{{ \'followears_following_page.no_following\' | translate }}</p>\n    </div>\n  </div>\n</ion-content>\n'/*ion-inline-end:"/Users/giok57/REPOS/new-wanda/wanda-android-34/src/pages/followers-following/followers-following.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* NavController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* NavParams */], __WEBPACK_IMPORTED_MODULE_2__providers_user_social_user_social__["a" /* UserSocialProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_logger_logger__["a" /* LoggerProvider */]])
    ], FollowersFollowingPage);
    return FollowersFollowingPage;
}());

//# sourceMappingURL=followers-following.js.map

/***/ })

});
//# sourceMappingURL=96.js.map